// Copyright 2023 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   extensions/common/api/automation_internal.idl
// by tools/json_schema_compiler.
// DO NOT EDIT.

#include "extensions/common/api/automation_internal.h"

#include <memory>
#include <ostream>
#include <string>
#include <utility>
#include <vector>

#include "base/check.h"
#include "base/check_op.h"
#include "base/notreached.h"
#include "base/strings/string_number_conversions.h"
#include "base/strings/utf_string_conversions.h"
#include "base/values.h"
#include "tools/json_schema_compiler/util.h"

using base::UTF8ToUTF16;

namespace extensions {
namespace api {
namespace automation_internal {
//
// Types
//

AXEventParams::AXEventParams()
 {}

AXEventParams::~AXEventParams() = default;
AXEventParams::AXEventParams(AXEventParams&& rhs) = default;
AXEventParams& AXEventParams::operator=(AXEventParams&& rhs) = default;
// static
bool AXEventParams::Populate(
    const base::Value& value, AXEventParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  return true;
}

// static
std::unique_ptr<AXEventParams> AXEventParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<AXEventParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> AXEventParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();


  return to_value_result;
}


AXTextLocationParams::AXTextLocationParams()
: node_id(0),
result(false),
left(0),
top(0),
width(0),
height(0),
request_id(0) {}

AXTextLocationParams::~AXTextLocationParams() = default;
AXTextLocationParams::AXTextLocationParams(AXTextLocationParams&& rhs) = default;
AXTextLocationParams& AXTextLocationParams::operator=(AXTextLocationParams&& rhs) = default;
// static
bool AXTextLocationParams::Populate(
    const base::Value& value, AXTextLocationParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* tree_id_value = dict->FindKey("treeID");
  if (!tree_id_value) {
    return false;
  }
  {
    auto* temp = (*tree_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->tree_id = *temp;
  }

  const base::Value* node_id_value = dict->FindKey("nodeID");
  if (!node_id_value) {
    return false;
  }
  {
    auto temp = (*node_id_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->node_id = temp.value();
  }

  const base::Value* result_value = dict->FindKey("result");
  if (!result_value) {
    return false;
  }
  {
    auto temp = (*result_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->result = temp.value();
  }

  const base::Value* left_value = dict->FindKey("left");
  if (!left_value) {
    return false;
  }
  {
    auto temp = (*left_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->left = temp.value();
  }

  const base::Value* top_value = dict->FindKey("top");
  if (!top_value) {
    return false;
  }
  {
    auto temp = (*top_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->top = temp.value();
  }

  const base::Value* width_value = dict->FindKey("width");
  if (!width_value) {
    return false;
  }
  {
    auto temp = (*width_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->width = temp.value();
  }

  const base::Value* height_value = dict->FindKey("height");
  if (!height_value) {
    return false;
  }
  {
    auto temp = (*height_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->height = temp.value();
  }

  const base::Value* request_id_value = dict->FindKey("requestID");
  if (!request_id_value) {
    return false;
  }
  {
    auto temp = (*request_id_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->request_id = temp.value();
  }

  return true;
}

// static
std::unique_ptr<AXTextLocationParams> AXTextLocationParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<AXTextLocationParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> AXTextLocationParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("treeID", std::make_unique<base::Value>(this->tree_id));

  to_value_result->SetWithoutPathExpansion("nodeID", std::make_unique<base::Value>(this->node_id));

  to_value_result->SetWithoutPathExpansion("result", std::make_unique<base::Value>(this->result));

  to_value_result->SetWithoutPathExpansion("left", std::make_unique<base::Value>(this->left));

  to_value_result->SetWithoutPathExpansion("top", std::make_unique<base::Value>(this->top));

  to_value_result->SetWithoutPathExpansion("width", std::make_unique<base::Value>(this->width));

  to_value_result->SetWithoutPathExpansion("height", std::make_unique<base::Value>(this->height));

  to_value_result->SetWithoutPathExpansion("requestID", std::make_unique<base::Value>(this->request_id));


  return to_value_result;
}


PerformActionRequiredParams::PerformActionRequiredParams()
: automation_node_id(0) {}

PerformActionRequiredParams::~PerformActionRequiredParams() = default;
PerformActionRequiredParams::PerformActionRequiredParams(PerformActionRequiredParams&& rhs) = default;
PerformActionRequiredParams& PerformActionRequiredParams::operator=(PerformActionRequiredParams&& rhs) = default;
// static
bool PerformActionRequiredParams::Populate(
    const base::Value& value, PerformActionRequiredParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* tree_id_value = dict->FindKey("treeID");
  if (!tree_id_value) {
    return false;
  }
  {
    auto* temp = (*tree_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->tree_id = *temp;
  }

  const base::Value* automation_node_id_value = dict->FindKey("automationNodeID");
  if (!automation_node_id_value) {
    return false;
  }
  {
    auto temp = (*automation_node_id_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->automation_node_id = temp.value();
  }

  const base::Value* action_type_value = dict->FindKey("actionType");
  if (!action_type_value) {
    return false;
  }
  {
    auto* temp = (*action_type_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->action_type = *temp;
  }

  const base::Value* request_id_value = dict->FindKey("requestID");
  if (request_id_value) {
    {
      auto temp = (*request_id_value).GetIfInt();
      if (!temp.has_value()) {
        out->request_id.reset();
        return false;
      }
      out->request_id = std::make_unique<int>(temp.value());
    }
  }

  return true;
}

// static
std::unique_ptr<PerformActionRequiredParams> PerformActionRequiredParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<PerformActionRequiredParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> PerformActionRequiredParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("treeID", std::make_unique<base::Value>(this->tree_id));

  to_value_result->SetWithoutPathExpansion("automationNodeID", std::make_unique<base::Value>(this->automation_node_id));

  to_value_result->SetWithoutPathExpansion("actionType", std::make_unique<base::Value>(this->action_type));

  if (this->request_id.get()) {
    to_value_result->SetWithoutPathExpansion("requestID", std::make_unique<base::Value>(*this->request_id));

  }

  return to_value_result;
}


PerformCustomActionParams::PerformCustomActionParams()
: custom_action_id(0) {}

PerformCustomActionParams::~PerformCustomActionParams() = default;
PerformCustomActionParams::PerformCustomActionParams(PerformCustomActionParams&& rhs) = default;
PerformCustomActionParams& PerformCustomActionParams::operator=(PerformCustomActionParams&& rhs) = default;
// static
bool PerformCustomActionParams::Populate(
    const base::Value& value, PerformCustomActionParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* custom_action_id_value = dict->FindKey("customActionID");
  if (!custom_action_id_value) {
    return false;
  }
  {
    auto temp = (*custom_action_id_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->custom_action_id = temp.value();
  }

  return true;
}

// static
std::unique_ptr<PerformCustomActionParams> PerformCustomActionParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<PerformCustomActionParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> PerformCustomActionParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("customActionID", std::make_unique<base::Value>(this->custom_action_id));


  return to_value_result;
}


SetSelectionParams::SetSelectionParams()
: focus_node_id(0),
anchor_offset(0),
focus_offset(0) {}

SetSelectionParams::~SetSelectionParams() = default;
SetSelectionParams::SetSelectionParams(SetSelectionParams&& rhs) = default;
SetSelectionParams& SetSelectionParams::operator=(SetSelectionParams&& rhs) = default;
// static
bool SetSelectionParams::Populate(
    const base::Value& value, SetSelectionParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* focus_node_id_value = dict->FindKey("focusNodeID");
  if (!focus_node_id_value) {
    return false;
  }
  {
    auto temp = (*focus_node_id_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->focus_node_id = temp.value();
  }

  const base::Value* anchor_offset_value = dict->FindKey("anchorOffset");
  if (!anchor_offset_value) {
    return false;
  }
  {
    auto temp = (*anchor_offset_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->anchor_offset = temp.value();
  }

  const base::Value* focus_offset_value = dict->FindKey("focusOffset");
  if (!focus_offset_value) {
    return false;
  }
  {
    auto temp = (*focus_offset_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->focus_offset = temp.value();
  }

  return true;
}

// static
std::unique_ptr<SetSelectionParams> SetSelectionParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<SetSelectionParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> SetSelectionParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("focusNodeID", std::make_unique<base::Value>(this->focus_node_id));

  to_value_result->SetWithoutPathExpansion("anchorOffset", std::make_unique<base::Value>(this->anchor_offset));

  to_value_result->SetWithoutPathExpansion("focusOffset", std::make_unique<base::Value>(this->focus_offset));


  return to_value_result;
}


ReplaceSelectedTextParams::ReplaceSelectedTextParams()
 {}

ReplaceSelectedTextParams::~ReplaceSelectedTextParams() = default;
ReplaceSelectedTextParams::ReplaceSelectedTextParams(ReplaceSelectedTextParams&& rhs) = default;
ReplaceSelectedTextParams& ReplaceSelectedTextParams::operator=(ReplaceSelectedTextParams&& rhs) = default;
// static
bool ReplaceSelectedTextParams::Populate(
    const base::Value& value, ReplaceSelectedTextParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* value_value = dict->FindKey("value");
  if (!value_value) {
    return false;
  }
  {
    auto* temp = (*value_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->value = *temp;
  }

  return true;
}

// static
std::unique_ptr<ReplaceSelectedTextParams> ReplaceSelectedTextParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<ReplaceSelectedTextParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> ReplaceSelectedTextParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("value", std::make_unique<base::Value>(this->value));


  return to_value_result;
}


SetValueParams::SetValueParams()
 {}

SetValueParams::~SetValueParams() = default;
SetValueParams::SetValueParams(SetValueParams&& rhs) = default;
SetValueParams& SetValueParams::operator=(SetValueParams&& rhs) = default;
// static
bool SetValueParams::Populate(
    const base::Value& value, SetValueParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* value_value = dict->FindKey("value");
  if (!value_value) {
    return false;
  }
  {
    auto* temp = (*value_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->value = *temp;
  }

  return true;
}

// static
std::unique_ptr<SetValueParams> SetValueParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<SetValueParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> SetValueParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("value", std::make_unique<base::Value>(this->value));


  return to_value_result;
}


ScrollToPointParams::ScrollToPointParams()
: x(0),
y(0) {}

ScrollToPointParams::~ScrollToPointParams() = default;
ScrollToPointParams::ScrollToPointParams(ScrollToPointParams&& rhs) = default;
ScrollToPointParams& ScrollToPointParams::operator=(ScrollToPointParams&& rhs) = default;
// static
bool ScrollToPointParams::Populate(
    const base::Value& value, ScrollToPointParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* x_value = dict->FindKey("x");
  if (!x_value) {
    return false;
  }
  {
    auto temp = (*x_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->x = temp.value();
  }

  const base::Value* y_value = dict->FindKey("y");
  if (!y_value) {
    return false;
  }
  {
    auto temp = (*y_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->y = temp.value();
  }

  return true;
}

// static
std::unique_ptr<ScrollToPointParams> ScrollToPointParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<ScrollToPointParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> ScrollToPointParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("x", std::make_unique<base::Value>(this->x));

  to_value_result->SetWithoutPathExpansion("y", std::make_unique<base::Value>(this->y));


  return to_value_result;
}


SetScrollOffsetParams::SetScrollOffsetParams()
: x(0),
y(0) {}

SetScrollOffsetParams::~SetScrollOffsetParams() = default;
SetScrollOffsetParams::SetScrollOffsetParams(SetScrollOffsetParams&& rhs) = default;
SetScrollOffsetParams& SetScrollOffsetParams::operator=(SetScrollOffsetParams&& rhs) = default;
// static
bool SetScrollOffsetParams::Populate(
    const base::Value& value, SetScrollOffsetParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* x_value = dict->FindKey("x");
  if (!x_value) {
    return false;
  }
  {
    auto temp = (*x_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->x = temp.value();
  }

  const base::Value* y_value = dict->FindKey("y");
  if (!y_value) {
    return false;
  }
  {
    auto temp = (*y_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->y = temp.value();
  }

  return true;
}

// static
std::unique_ptr<SetScrollOffsetParams> SetScrollOffsetParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<SetScrollOffsetParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> SetScrollOffsetParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("x", std::make_unique<base::Value>(this->x));

  to_value_result->SetWithoutPathExpansion("y", std::make_unique<base::Value>(this->y));


  return to_value_result;
}


QuerySelectorRequiredParams::QuerySelectorRequiredParams()
: automation_node_id(0) {}

QuerySelectorRequiredParams::~QuerySelectorRequiredParams() = default;
QuerySelectorRequiredParams::QuerySelectorRequiredParams(QuerySelectorRequiredParams&& rhs) = default;
QuerySelectorRequiredParams& QuerySelectorRequiredParams::operator=(QuerySelectorRequiredParams&& rhs) = default;
// static
bool QuerySelectorRequiredParams::Populate(
    const base::Value& value, QuerySelectorRequiredParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* tree_id_value = dict->FindKey("treeID");
  if (!tree_id_value) {
    return false;
  }
  {
    auto* temp = (*tree_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->tree_id = *temp;
  }

  const base::Value* automation_node_id_value = dict->FindKey("automationNodeID");
  if (!automation_node_id_value) {
    return false;
  }
  {
    auto temp = (*automation_node_id_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->automation_node_id = temp.value();
  }

  const base::Value* selector_value = dict->FindKey("selector");
  if (!selector_value) {
    return false;
  }
  {
    auto* temp = (*selector_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->selector = *temp;
  }

  return true;
}

// static
std::unique_ptr<QuerySelectorRequiredParams> QuerySelectorRequiredParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<QuerySelectorRequiredParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> QuerySelectorRequiredParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("treeID", std::make_unique<base::Value>(this->tree_id));

  to_value_result->SetWithoutPathExpansion("automationNodeID", std::make_unique<base::Value>(this->automation_node_id));

  to_value_result->SetWithoutPathExpansion("selector", std::make_unique<base::Value>(this->selector));


  return to_value_result;
}


EnableTabParams::EnableTabParams()
 {}

EnableTabParams::~EnableTabParams() = default;
EnableTabParams::EnableTabParams(EnableTabParams&& rhs) = default;
EnableTabParams& EnableTabParams::operator=(EnableTabParams&& rhs) = default;
// static
bool EnableTabParams::Populate(
    const base::Value& value, EnableTabParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* tab_id_value = dict->FindKey("tabID");
  if (tab_id_value) {
    {
      auto temp = (*tab_id_value).GetIfInt();
      if (!temp.has_value()) {
        out->tab_id.reset();
        return false;
      }
      out->tab_id = std::make_unique<int>(temp.value());
    }
  }

  return true;
}

// static
std::unique_ptr<EnableTabParams> EnableTabParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<EnableTabParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> EnableTabParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  if (this->tab_id.get()) {
    to_value_result->SetWithoutPathExpansion("tabID", std::make_unique<base::Value>(*this->tab_id));

  }

  return to_value_result;
}


GetImageDataParams::GetImageDataParams()
: max_width(0),
max_height(0) {}

GetImageDataParams::~GetImageDataParams() = default;
GetImageDataParams::GetImageDataParams(GetImageDataParams&& rhs) = default;
GetImageDataParams& GetImageDataParams::operator=(GetImageDataParams&& rhs) = default;
// static
bool GetImageDataParams::Populate(
    const base::Value& value, GetImageDataParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* max_width_value = dict->FindKey("maxWidth");
  if (!max_width_value) {
    return false;
  }
  {
    auto temp = (*max_width_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->max_width = temp.value();
  }

  const base::Value* max_height_value = dict->FindKey("maxHeight");
  if (!max_height_value) {
    return false;
  }
  {
    auto temp = (*max_height_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->max_height = temp.value();
  }

  return true;
}

// static
std::unique_ptr<GetImageDataParams> GetImageDataParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<GetImageDataParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> GetImageDataParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("maxWidth", std::make_unique<base::Value>(this->max_width));

  to_value_result->SetWithoutPathExpansion("maxHeight", std::make_unique<base::Value>(this->max_height));


  return to_value_result;
}


HitTestParams::HitTestParams()
: x(0),
y(0) {}

HitTestParams::~HitTestParams() = default;
HitTestParams::HitTestParams(HitTestParams&& rhs) = default;
HitTestParams& HitTestParams::operator=(HitTestParams&& rhs) = default;
// static
bool HitTestParams::Populate(
    const base::Value& value, HitTestParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* x_value = dict->FindKey("x");
  if (!x_value) {
    return false;
  }
  {
    auto temp = (*x_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->x = temp.value();
  }

  const base::Value* y_value = dict->FindKey("y");
  if (!y_value) {
    return false;
  }
  {
    auto temp = (*y_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->y = temp.value();
  }

  const base::Value* event_to_fire_value = dict->FindKey("eventToFire");
  if (!event_to_fire_value) {
    return false;
  }
  {
    auto* temp = (*event_to_fire_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->event_to_fire = *temp;
  }

  return true;
}

// static
std::unique_ptr<HitTestParams> HitTestParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<HitTestParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> HitTestParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("x", std::make_unique<base::Value>(this->x));

  to_value_result->SetWithoutPathExpansion("y", std::make_unique<base::Value>(this->y));

  to_value_result->SetWithoutPathExpansion("eventToFire", std::make_unique<base::Value>(this->event_to_fire));


  return to_value_result;
}


GetTextLocationDataParams::GetTextLocationDataParams()
: start_index(0),
end_index(0) {}

GetTextLocationDataParams::~GetTextLocationDataParams() = default;
GetTextLocationDataParams::GetTextLocationDataParams(GetTextLocationDataParams&& rhs) = default;
GetTextLocationDataParams& GetTextLocationDataParams::operator=(GetTextLocationDataParams&& rhs) = default;
// static
bool GetTextLocationDataParams::Populate(
    const base::Value& value, GetTextLocationDataParams* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* start_index_value = dict->FindKey("startIndex");
  if (!start_index_value) {
    return false;
  }
  {
    auto temp = (*start_index_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->start_index = temp.value();
  }

  const base::Value* end_index_value = dict->FindKey("endIndex");
  if (!end_index_value) {
    return false;
  }
  {
    auto temp = (*end_index_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->end_index = temp.value();
  }

  return true;
}

// static
std::unique_ptr<GetTextLocationDataParams> GetTextLocationDataParams::FromValue(const base::Value& value) {
  auto out = std::make_unique<GetTextLocationDataParams>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> GetTextLocationDataParams::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("startIndex", std::make_unique<base::Value>(this->start_index));

  to_value_result->SetWithoutPathExpansion("endIndex", std::make_unique<base::Value>(this->end_index));


  return to_value_result;
}


EnableTabCallbackInfo::EnableTabCallbackInfo()
: tab_id(0) {}

EnableTabCallbackInfo::~EnableTabCallbackInfo() = default;
EnableTabCallbackInfo::EnableTabCallbackInfo(EnableTabCallbackInfo&& rhs) = default;
EnableTabCallbackInfo& EnableTabCallbackInfo::operator=(EnableTabCallbackInfo&& rhs) = default;
// static
bool EnableTabCallbackInfo::Populate(
    const base::Value& value, EnableTabCallbackInfo* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* tree_id_value = dict->FindKey("treeID");
  if (!tree_id_value) {
    return false;
  }
  {
    auto* temp = (*tree_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->tree_id = *temp;
  }

  const base::Value* tab_id_value = dict->FindKey("tabId");
  if (!tab_id_value) {
    return false;
  }
  {
    auto temp = (*tab_id_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->tab_id = temp.value();
  }

  return true;
}

// static
std::unique_ptr<EnableTabCallbackInfo> EnableTabCallbackInfo::FromValue(const base::Value& value) {
  auto out = std::make_unique<EnableTabCallbackInfo>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> EnableTabCallbackInfo::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("treeID", std::make_unique<base::Value>(this->tree_id));

  to_value_result->SetWithoutPathExpansion("tabId", std::make_unique<base::Value>(this->tab_id));


  return to_value_result;
}



//
// Functions
//

namespace EnableTab {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& args_value = args[0];
    {
      if (!args_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!EnableTabParams::Populate(args_value, &params->args)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


std::vector<base::Value> Results::Create(const EnableTabCallbackInfo& info) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue((info).ToValue()));

  return create_results;
}
}  // namespace EnableTab

namespace EnableTree {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& tree_id_value = args[0];
    {
      auto* temp = tree_id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->tree_id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace EnableTree

namespace EnableDesktop {

std::vector<base::Value> Results::Create(const std::string& tree_id) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(tree_id)));

  return create_results;
}
}  // namespace EnableDesktop

namespace PerformAction {

Params::OptArgs::OptArgs()
 {}

Params::OptArgs::~OptArgs() = default;
Params::OptArgs::OptArgs(OptArgs&& rhs) = default;
Params::OptArgs& Params::OptArgs::operator=(OptArgs&& rhs) = default;
// static
bool Params::OptArgs::Populate(
    const base::Value& value, OptArgs* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  out->additional_properties.MergeDictionary(dict);
  return true;
}


Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& args_value = args[0];
    {
      if (!args_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!PerformActionRequiredParams::Populate(args_value, &params->args)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& opt_args_value = args[1];
    {
      if (!opt_args_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!OptArgs::Populate(opt_args_value, &params->opt_args)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace PerformAction

namespace QuerySelector {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& args_value = args[0];
    {
      if (!args_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!QuerySelectorRequiredParams::Populate(args_value, &params->args)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


std::vector<base::Value> Results::Create(int result_automation_node_id) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(result_automation_node_id)));

  return create_results;
}
}  // namespace QuerySelector

//
// Events
//

namespace OnAccessibilityEvent {

const char kEventName[] = "automationInternal.onAccessibilityEvent";

std::vector<base::Value> Create(const AXEventParams& update) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue((update).ToValue()));

  return create_results;
}

}  // namespace OnAccessibilityEvent

namespace OnAccessibilityTreeDestroyed {

const char kEventName[] = "automationInternal.onAccessibilityTreeDestroyed";

std::vector<base::Value> Create(const std::string& tree_id) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(tree_id)));

  return create_results;
}

}  // namespace OnAccessibilityTreeDestroyed

namespace OnGetTextLocationResult {

const char kEventName[] = "automationInternal.onGetTextLocationResult";

std::vector<base::Value> Create(const AXTextLocationParams& params) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue((params).ToValue()));

  return create_results;
}

}  // namespace OnGetTextLocationResult

namespace OnTreeChange {

const char kEventName[] = "automationInternal.onTreeChange";

std::vector<base::Value> Create(int observer_id, const std::string& tree_id, int node_id, const std::string& change_type) {
  std::vector<base::Value> create_results;
  create_results.reserve(4);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(observer_id)));

  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(tree_id)));

  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(node_id)));

  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(change_type)));

  return create_results;
}

}  // namespace OnTreeChange

namespace OnChildTreeID {

const char kEventName[] = "automationInternal.onChildTreeID";

std::vector<base::Value> Create(const std::string& tree_id) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(tree_id)));

  return create_results;
}

}  // namespace OnChildTreeID

namespace OnNodesRemoved {

const char kEventName[] = "automationInternal.onNodesRemoved";

std::vector<base::Value> Create(const std::string& tree_id, const std::vector<int>& node_i_ds) {
  std::vector<base::Value> create_results;
  create_results.reserve(2);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(tree_id)));

  create_results.push_back(base::Value::FromUniquePtrValue(json_schema_compiler::util::CreateValueFromArray(node_i_ds)));

  return create_results;
}

}  // namespace OnNodesRemoved

namespace OnAccessibilityTreeSerializationError {

const char kEventName[] = "automationInternal.onAccessibilityTreeSerializationError";

std::vector<base::Value> Create(const std::string& tree_id) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(tree_id)));

  return create_results;
}

}  // namespace OnAccessibilityTreeSerializationError

namespace OnActionResult {

const char kEventName[] = "automationInternal.onActionResult";

std::vector<base::Value> Create(const std::string& tree_id, int request_id, bool result) {
  std::vector<base::Value> create_results;
  create_results.reserve(3);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(tree_id)));

  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(request_id)));

  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(result)));

  return create_results;
}

}  // namespace OnActionResult

}  // namespace automation_internal
}  // namespace api
}  // namespace extensions

