// Copyright 2023 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   extensions/common/api/system_display.idl
// by tools/json_schema_compiler.
// DO NOT EDIT.

#include "extensions/common/api/system_display.h"

#include <memory>
#include <ostream>
#include <string>
#include <utility>
#include <vector>

#include "base/check.h"
#include "base/check_op.h"
#include "base/notreached.h"
#include "base/strings/string_number_conversions.h"
#include "base/strings/utf_string_conversions.h"
#include "base/values.h"
#include "tools/json_schema_compiler/util.h"

using base::UTF8ToUTF16;

namespace extensions {
namespace api {
namespace system_display {
//
// Types
//

Bounds::Bounds()
: left(0),
top(0),
width(0),
height(0) {}

Bounds::~Bounds() = default;
Bounds::Bounds(Bounds&& rhs) = default;
Bounds& Bounds::operator=(Bounds&& rhs) = default;
// static
bool Bounds::Populate(
    const base::Value& value, Bounds* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* left_value = dict->FindKey("left");
  if (!left_value) {
    return false;
  }
  {
    auto temp = (*left_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->left = temp.value();
  }

  const base::Value* top_value = dict->FindKey("top");
  if (!top_value) {
    return false;
  }
  {
    auto temp = (*top_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->top = temp.value();
  }

  const base::Value* width_value = dict->FindKey("width");
  if (!width_value) {
    return false;
  }
  {
    auto temp = (*width_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->width = temp.value();
  }

  const base::Value* height_value = dict->FindKey("height");
  if (!height_value) {
    return false;
  }
  {
    auto temp = (*height_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->height = temp.value();
  }

  return true;
}

// static
std::unique_ptr<Bounds> Bounds::FromValue(const base::Value& value) {
  auto out = std::make_unique<Bounds>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> Bounds::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("left", std::make_unique<base::Value>(this->left));

  to_value_result->SetWithoutPathExpansion("top", std::make_unique<base::Value>(this->top));

  to_value_result->SetWithoutPathExpansion("width", std::make_unique<base::Value>(this->width));

  to_value_result->SetWithoutPathExpansion("height", std::make_unique<base::Value>(this->height));


  return to_value_result;
}


Insets::Insets()
: left(0),
top(0),
right(0),
bottom(0) {}

Insets::~Insets() = default;
Insets::Insets(Insets&& rhs) = default;
Insets& Insets::operator=(Insets&& rhs) = default;
// static
bool Insets::Populate(
    const base::Value& value, Insets* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* left_value = dict->FindKey("left");
  if (!left_value) {
    return false;
  }
  {
    auto temp = (*left_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->left = temp.value();
  }

  const base::Value* top_value = dict->FindKey("top");
  if (!top_value) {
    return false;
  }
  {
    auto temp = (*top_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->top = temp.value();
  }

  const base::Value* right_value = dict->FindKey("right");
  if (!right_value) {
    return false;
  }
  {
    auto temp = (*right_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->right = temp.value();
  }

  const base::Value* bottom_value = dict->FindKey("bottom");
  if (!bottom_value) {
    return false;
  }
  {
    auto temp = (*bottom_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->bottom = temp.value();
  }

  return true;
}

// static
std::unique_ptr<Insets> Insets::FromValue(const base::Value& value) {
  auto out = std::make_unique<Insets>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> Insets::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("left", std::make_unique<base::Value>(this->left));

  to_value_result->SetWithoutPathExpansion("top", std::make_unique<base::Value>(this->top));

  to_value_result->SetWithoutPathExpansion("right", std::make_unique<base::Value>(this->right));

  to_value_result->SetWithoutPathExpansion("bottom", std::make_unique<base::Value>(this->bottom));


  return to_value_result;
}


Point::Point()
: x(0),
y(0) {}

Point::~Point() = default;
Point::Point(Point&& rhs) = default;
Point& Point::operator=(Point&& rhs) = default;
// static
bool Point::Populate(
    const base::Value& value, Point* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* x_value = dict->FindKey("x");
  if (!x_value) {
    return false;
  }
  {
    auto temp = (*x_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->x = temp.value();
  }

  const base::Value* y_value = dict->FindKey("y");
  if (!y_value) {
    return false;
  }
  {
    auto temp = (*y_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->y = temp.value();
  }

  return true;
}

// static
std::unique_ptr<Point> Point::FromValue(const base::Value& value) {
  auto out = std::make_unique<Point>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> Point::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("x", std::make_unique<base::Value>(this->x));

  to_value_result->SetWithoutPathExpansion("y", std::make_unique<base::Value>(this->y));


  return to_value_result;
}


TouchCalibrationPair::TouchCalibrationPair()
 {}

TouchCalibrationPair::~TouchCalibrationPair() = default;
TouchCalibrationPair::TouchCalibrationPair(TouchCalibrationPair&& rhs) = default;
TouchCalibrationPair& TouchCalibrationPair::operator=(TouchCalibrationPair&& rhs) = default;
// static
bool TouchCalibrationPair::Populate(
    const base::Value& value, TouchCalibrationPair* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* display_point_value = dict->FindKey("displayPoint");
  if (!display_point_value) {
    return false;
  }
  {
    if (!(*display_point_value).is_dict()) {
      return false;
    }
    if (!Point::Populate((*display_point_value), &out->display_point)) {
      return false;
    }
  }

  const base::Value* touch_point_value = dict->FindKey("touchPoint");
  if (!touch_point_value) {
    return false;
  }
  {
    if (!(*touch_point_value).is_dict()) {
      return false;
    }
    if (!Point::Populate((*touch_point_value), &out->touch_point)) {
      return false;
    }
  }

  return true;
}

// static
std::unique_ptr<TouchCalibrationPair> TouchCalibrationPair::FromValue(const base::Value& value) {
  auto out = std::make_unique<TouchCalibrationPair>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> TouchCalibrationPair::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("displayPoint", (this->display_point).ToValue());

  to_value_result->SetWithoutPathExpansion("touchPoint", (this->touch_point).ToValue());


  return to_value_result;
}


TouchCalibrationPairQuad::TouchCalibrationPairQuad()
 {}

TouchCalibrationPairQuad::~TouchCalibrationPairQuad() = default;
TouchCalibrationPairQuad::TouchCalibrationPairQuad(TouchCalibrationPairQuad&& rhs) = default;
TouchCalibrationPairQuad& TouchCalibrationPairQuad::operator=(TouchCalibrationPairQuad&& rhs) = default;
// static
bool TouchCalibrationPairQuad::Populate(
    const base::Value& value, TouchCalibrationPairQuad* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* pair1_value = dict->FindKey("pair1");
  if (!pair1_value) {
    return false;
  }
  {
    if (!(*pair1_value).is_dict()) {
      return false;
    }
    if (!TouchCalibrationPair::Populate((*pair1_value), &out->pair1)) {
      return false;
    }
  }

  const base::Value* pair2_value = dict->FindKey("pair2");
  if (!pair2_value) {
    return false;
  }
  {
    if (!(*pair2_value).is_dict()) {
      return false;
    }
    if (!TouchCalibrationPair::Populate((*pair2_value), &out->pair2)) {
      return false;
    }
  }

  const base::Value* pair3_value = dict->FindKey("pair3");
  if (!pair3_value) {
    return false;
  }
  {
    if (!(*pair3_value).is_dict()) {
      return false;
    }
    if (!TouchCalibrationPair::Populate((*pair3_value), &out->pair3)) {
      return false;
    }
  }

  const base::Value* pair4_value = dict->FindKey("pair4");
  if (!pair4_value) {
    return false;
  }
  {
    if (!(*pair4_value).is_dict()) {
      return false;
    }
    if (!TouchCalibrationPair::Populate((*pair4_value), &out->pair4)) {
      return false;
    }
  }

  return true;
}

// static
std::unique_ptr<TouchCalibrationPairQuad> TouchCalibrationPairQuad::FromValue(const base::Value& value) {
  auto out = std::make_unique<TouchCalibrationPairQuad>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> TouchCalibrationPairQuad::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("pair1", (this->pair1).ToValue());

  to_value_result->SetWithoutPathExpansion("pair2", (this->pair2).ToValue());

  to_value_result->SetWithoutPathExpansion("pair3", (this->pair3).ToValue());

  to_value_result->SetWithoutPathExpansion("pair4", (this->pair4).ToValue());


  return to_value_result;
}


DisplayMode::DisplayMode()
: width(0),
height(0),
width_in_native_pixels(0),
height_in_native_pixels(0),
device_scale_factor(0.0),
refresh_rate(0.0),
is_native(false),
is_selected(false) {}

DisplayMode::~DisplayMode() = default;
DisplayMode::DisplayMode(DisplayMode&& rhs) = default;
DisplayMode& DisplayMode::operator=(DisplayMode&& rhs) = default;
// static
bool DisplayMode::Populate(
    const base::Value& value, DisplayMode* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* width_value = dict->FindKey("width");
  if (!width_value) {
    return false;
  }
  {
    auto temp = (*width_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->width = temp.value();
  }

  const base::Value* height_value = dict->FindKey("height");
  if (!height_value) {
    return false;
  }
  {
    auto temp = (*height_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->height = temp.value();
  }

  const base::Value* width_in_native_pixels_value = dict->FindKey("widthInNativePixels");
  if (!width_in_native_pixels_value) {
    return false;
  }
  {
    auto temp = (*width_in_native_pixels_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->width_in_native_pixels = temp.value();
  }

  const base::Value* height_in_native_pixels_value = dict->FindKey("heightInNativePixels");
  if (!height_in_native_pixels_value) {
    return false;
  }
  {
    auto temp = (*height_in_native_pixels_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->height_in_native_pixels = temp.value();
  }

  const base::Value* ui_scale_value = dict->FindKey("uiScale");
  if (ui_scale_value) {
    {
      auto temp = (*ui_scale_value).GetIfDouble();
      if (!temp.has_value()) {
        out->ui_scale.reset();
        return false;
      }
      out->ui_scale = std::make_unique<double>(temp.value());
    }
  }

  const base::Value* device_scale_factor_value = dict->FindKey("deviceScaleFactor");
  if (!device_scale_factor_value) {
    return false;
  }
  {
    auto temp = (*device_scale_factor_value).GetIfDouble();
    if (!temp.has_value()) {
      return false;
    }
    out->device_scale_factor = temp.value();
  }

  const base::Value* refresh_rate_value = dict->FindKey("refreshRate");
  if (!refresh_rate_value) {
    return false;
  }
  {
    auto temp = (*refresh_rate_value).GetIfDouble();
    if (!temp.has_value()) {
      return false;
    }
    out->refresh_rate = temp.value();
  }

  const base::Value* is_native_value = dict->FindKey("isNative");
  if (!is_native_value) {
    return false;
  }
  {
    auto temp = (*is_native_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->is_native = temp.value();
  }

  const base::Value* is_selected_value = dict->FindKey("isSelected");
  if (!is_selected_value) {
    return false;
  }
  {
    auto temp = (*is_selected_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->is_selected = temp.value();
  }

  const base::Value* is_interlaced_value = dict->FindKey("isInterlaced");
  if (is_interlaced_value) {
    {
      auto temp = (*is_interlaced_value).GetIfBool();
      if (!temp.has_value()) {
        out->is_interlaced.reset();
        return false;
      }
      out->is_interlaced = std::make_unique<bool>(temp.value());
    }
  }

  return true;
}

// static
std::unique_ptr<DisplayMode> DisplayMode::FromValue(const base::Value& value) {
  auto out = std::make_unique<DisplayMode>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> DisplayMode::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("width", std::make_unique<base::Value>(this->width));

  to_value_result->SetWithoutPathExpansion("height", std::make_unique<base::Value>(this->height));

  to_value_result->SetWithoutPathExpansion("widthInNativePixels", std::make_unique<base::Value>(this->width_in_native_pixels));

  to_value_result->SetWithoutPathExpansion("heightInNativePixels", std::make_unique<base::Value>(this->height_in_native_pixels));

  if (this->ui_scale.get()) {
    to_value_result->SetWithoutPathExpansion("uiScale", std::make_unique<base::Value>(*this->ui_scale));

  }
  to_value_result->SetWithoutPathExpansion("deviceScaleFactor", std::make_unique<base::Value>(this->device_scale_factor));

  to_value_result->SetWithoutPathExpansion("refreshRate", std::make_unique<base::Value>(this->refresh_rate));

  to_value_result->SetWithoutPathExpansion("isNative", std::make_unique<base::Value>(this->is_native));

  to_value_result->SetWithoutPathExpansion("isSelected", std::make_unique<base::Value>(this->is_selected));

  if (this->is_interlaced.get()) {
    to_value_result->SetWithoutPathExpansion("isInterlaced", std::make_unique<base::Value>(*this->is_interlaced));

  }

  return to_value_result;
}


const char* ToString(LayoutPosition enum_param) {
  switch (enum_param) {
    case LAYOUT_POSITION_TOP:
      return "top";
    case LAYOUT_POSITION_RIGHT:
      return "right";
    case LAYOUT_POSITION_BOTTOM:
      return "bottom";
    case LAYOUT_POSITION_LEFT:
      return "left";
    case LAYOUT_POSITION_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

LayoutPosition ParseLayoutPosition(const std::string& enum_string) {
  if (enum_string == "top")
    return LAYOUT_POSITION_TOP;
  if (enum_string == "right")
    return LAYOUT_POSITION_RIGHT;
  if (enum_string == "bottom")
    return LAYOUT_POSITION_BOTTOM;
  if (enum_string == "left")
    return LAYOUT_POSITION_LEFT;
  return LAYOUT_POSITION_NONE;
}


DisplayLayout::DisplayLayout()
: position(LAYOUT_POSITION_NONE),
offset(0) {}

DisplayLayout::~DisplayLayout() = default;
DisplayLayout::DisplayLayout(DisplayLayout&& rhs) = default;
DisplayLayout& DisplayLayout::operator=(DisplayLayout&& rhs) = default;
// static
bool DisplayLayout::Populate(
    const base::Value& value, DisplayLayout* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* id_value = dict->FindKey("id");
  if (!id_value) {
    return false;
  }
  {
    auto* temp = (*id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->id = *temp;
  }

  const base::Value* parent_id_value = dict->FindKey("parentId");
  if (!parent_id_value) {
    return false;
  }
  {
    auto* temp = (*parent_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->parent_id = *temp;
  }

  const base::Value* position_value = dict->FindKey("position");
  if (!position_value) {
    return false;
  }
  {
    const std::string* layout_position_as_string = (*position_value).GetIfString();
    if (!layout_position_as_string) {
      return false;
    }
    out->position = ParseLayoutPosition(*layout_position_as_string);
    if (out->position == LAYOUT_POSITION_NONE) {
      return false;
    }
  }

  const base::Value* offset_value = dict->FindKey("offset");
  if (!offset_value) {
    return false;
  }
  {
    auto temp = (*offset_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->offset = temp.value();
  }

  return true;
}

// static
std::unique_ptr<DisplayLayout> DisplayLayout::FromValue(const base::Value& value) {
  auto out = std::make_unique<DisplayLayout>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> DisplayLayout::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("id", std::make_unique<base::Value>(this->id));

  to_value_result->SetWithoutPathExpansion("parentId", std::make_unique<base::Value>(this->parent_id));

  to_value_result->SetWithoutPathExpansion("position", std::make_unique<base::Value>(system_display::ToString(this->position)));

  to_value_result->SetWithoutPathExpansion("offset", std::make_unique<base::Value>(this->offset));


  return to_value_result;
}


Edid::Edid()
: year_of_manufacture(0) {}

Edid::~Edid() = default;
Edid::Edid(Edid&& rhs) = default;
Edid& Edid::operator=(Edid&& rhs) = default;
// static
bool Edid::Populate(
    const base::Value& value, Edid* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* manufacturer_id_value = dict->FindKey("manufacturerId");
  if (!manufacturer_id_value) {
    return false;
  }
  {
    auto* temp = (*manufacturer_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->manufacturer_id = *temp;
  }

  const base::Value* product_id_value = dict->FindKey("productId");
  if (!product_id_value) {
    return false;
  }
  {
    auto* temp = (*product_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->product_id = *temp;
  }

  const base::Value* year_of_manufacture_value = dict->FindKey("yearOfManufacture");
  if (!year_of_manufacture_value) {
    return false;
  }
  {
    auto temp = (*year_of_manufacture_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->year_of_manufacture = temp.value();
  }

  return true;
}

// static
std::unique_ptr<Edid> Edid::FromValue(const base::Value& value) {
  auto out = std::make_unique<Edid>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> Edid::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("manufacturerId", std::make_unique<base::Value>(this->manufacturer_id));

  to_value_result->SetWithoutPathExpansion("productId", std::make_unique<base::Value>(this->product_id));

  to_value_result->SetWithoutPathExpansion("yearOfManufacture", std::make_unique<base::Value>(this->year_of_manufacture));


  return to_value_result;
}


DisplayUnitInfo::DisplayUnitInfo()
: is_primary(false),
is_internal(false),
is_enabled(false),
is_unified(false),
dpi_x(0.0),
dpi_y(0.0),
rotation(0),
has_touch_support(false),
has_accelerometer_support(false),
display_zoom_factor(0.0) {}

DisplayUnitInfo::~DisplayUnitInfo() = default;
DisplayUnitInfo::DisplayUnitInfo(DisplayUnitInfo&& rhs) = default;
DisplayUnitInfo& DisplayUnitInfo::operator=(DisplayUnitInfo&& rhs) = default;
// static
bool DisplayUnitInfo::Populate(
    const base::Value& value, DisplayUnitInfo* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* id_value = dict->FindKey("id");
  if (!id_value) {
    return false;
  }
  {
    auto* temp = (*id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->id = *temp;
  }

  const base::Value* name_value = dict->FindKey("name");
  if (!name_value) {
    return false;
  }
  {
    auto* temp = (*name_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->name = *temp;
  }

  const base::Value* edid_value = dict->FindKey("edid");
  if (edid_value) {
    {
      if (!(*edid_value).is_dict()) {
        return false;
      }
      else {
        auto temp = std::make_unique<Edid>();
        if (!Edid::Populate((*edid_value), temp.get())) {
          return false;
        }
        else
          out->edid = std::move(temp);
      }
    }
  }

  const base::Value* mirroring_source_id_value = dict->FindKey("mirroringSourceId");
  if (!mirroring_source_id_value) {
    return false;
  }
  {
    auto* temp = (*mirroring_source_id_value).GetIfString();
    if (!temp) {
      return false;
    }
    out->mirroring_source_id = *temp;
  }

  const base::Value* mirroring_destination_ids_value = dict->FindKey("mirroringDestinationIds");
  if (!mirroring_destination_ids_value) {
    return false;
  }
  {
    if (!(*mirroring_destination_ids_value).is_list()) {
      return false;
    }
    else {
      if (!json_schema_compiler::util::PopulateArrayFromList((*mirroring_destination_ids_value).GetListDeprecated(), &out->mirroring_destination_ids)) {
        return false;
      }
    }
  }

  const base::Value* is_primary_value = dict->FindKey("isPrimary");
  if (!is_primary_value) {
    return false;
  }
  {
    auto temp = (*is_primary_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->is_primary = temp.value();
  }

  const base::Value* is_internal_value = dict->FindKey("isInternal");
  if (!is_internal_value) {
    return false;
  }
  {
    auto temp = (*is_internal_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->is_internal = temp.value();
  }

  const base::Value* is_enabled_value = dict->FindKey("isEnabled");
  if (!is_enabled_value) {
    return false;
  }
  {
    auto temp = (*is_enabled_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->is_enabled = temp.value();
  }

  const base::Value* is_unified_value = dict->FindKey("isUnified");
  if (!is_unified_value) {
    return false;
  }
  {
    auto temp = (*is_unified_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->is_unified = temp.value();
  }

  const base::Value* is_auto_rotation_allowed_value = dict->FindKey("isAutoRotationAllowed");
  if (is_auto_rotation_allowed_value) {
    {
      auto temp = (*is_auto_rotation_allowed_value).GetIfBool();
      if (!temp.has_value()) {
        out->is_auto_rotation_allowed.reset();
        return false;
      }
      out->is_auto_rotation_allowed = std::make_unique<bool>(temp.value());
    }
  }

  const base::Value* dpi_x_value = dict->FindKey("dpiX");
  if (!dpi_x_value) {
    return false;
  }
  {
    auto temp = (*dpi_x_value).GetIfDouble();
    if (!temp.has_value()) {
      return false;
    }
    out->dpi_x = temp.value();
  }

  const base::Value* dpi_y_value = dict->FindKey("dpiY");
  if (!dpi_y_value) {
    return false;
  }
  {
    auto temp = (*dpi_y_value).GetIfDouble();
    if (!temp.has_value()) {
      return false;
    }
    out->dpi_y = temp.value();
  }

  const base::Value* rotation_value = dict->FindKey("rotation");
  if (!rotation_value) {
    return false;
  }
  {
    auto temp = (*rotation_value).GetIfInt();
    if (!temp.has_value()) {
      return false;
    }
    out->rotation = temp.value();
  }

  const base::Value* bounds_value = dict->FindKey("bounds");
  if (!bounds_value) {
    return false;
  }
  {
    if (!(*bounds_value).is_dict()) {
      return false;
    }
    if (!Bounds::Populate((*bounds_value), &out->bounds)) {
      return false;
    }
  }

  const base::Value* overscan_value = dict->FindKey("overscan");
  if (!overscan_value) {
    return false;
  }
  {
    if (!(*overscan_value).is_dict()) {
      return false;
    }
    if (!Insets::Populate((*overscan_value), &out->overscan)) {
      return false;
    }
  }

  const base::Value* work_area_value = dict->FindKey("workArea");
  if (!work_area_value) {
    return false;
  }
  {
    if (!(*work_area_value).is_dict()) {
      return false;
    }
    if (!Bounds::Populate((*work_area_value), &out->work_area)) {
      return false;
    }
  }

  const base::Value* modes_value = dict->FindKey("modes");
  if (!modes_value) {
    return false;
  }
  {
    if (!(*modes_value).is_list()) {
      return false;
    }
    else {
      if (!json_schema_compiler::util::PopulateArrayFromList((*modes_value).GetListDeprecated(), &out->modes)) {
        return false;
      }
    }
  }

  const base::Value* has_touch_support_value = dict->FindKey("hasTouchSupport");
  if (!has_touch_support_value) {
    return false;
  }
  {
    auto temp = (*has_touch_support_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->has_touch_support = temp.value();
  }

  const base::Value* has_accelerometer_support_value = dict->FindKey("hasAccelerometerSupport");
  if (!has_accelerometer_support_value) {
    return false;
  }
  {
    auto temp = (*has_accelerometer_support_value).GetIfBool();
    if (!temp.has_value()) {
      return false;
    }
    out->has_accelerometer_support = temp.value();
  }

  const base::Value* available_display_zoom_factors_value = dict->FindKey("availableDisplayZoomFactors");
  if (!available_display_zoom_factors_value) {
    return false;
  }
  {
    if (!(*available_display_zoom_factors_value).is_list()) {
      return false;
    }
    else {
      if (!json_schema_compiler::util::PopulateArrayFromList((*available_display_zoom_factors_value).GetListDeprecated(), &out->available_display_zoom_factors)) {
        return false;
      }
    }
  }

  const base::Value* display_zoom_factor_value = dict->FindKey("displayZoomFactor");
  if (!display_zoom_factor_value) {
    return false;
  }
  {
    auto temp = (*display_zoom_factor_value).GetIfDouble();
    if (!temp.has_value()) {
      return false;
    }
    out->display_zoom_factor = temp.value();
  }

  return true;
}

// static
std::unique_ptr<DisplayUnitInfo> DisplayUnitInfo::FromValue(const base::Value& value) {
  auto out = std::make_unique<DisplayUnitInfo>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> DisplayUnitInfo::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("id", std::make_unique<base::Value>(this->id));

  to_value_result->SetWithoutPathExpansion("name", std::make_unique<base::Value>(this->name));

  if (this->edid.get()) {
    to_value_result->SetWithoutPathExpansion("edid", (this->edid)->ToValue());

  }
  to_value_result->SetWithoutPathExpansion("mirroringSourceId", std::make_unique<base::Value>(this->mirroring_source_id));

  to_value_result->SetWithoutPathExpansion("mirroringDestinationIds", json_schema_compiler::util::CreateValueFromArray(this->mirroring_destination_ids));

  to_value_result->SetWithoutPathExpansion("isPrimary", std::make_unique<base::Value>(this->is_primary));

  to_value_result->SetWithoutPathExpansion("isInternal", std::make_unique<base::Value>(this->is_internal));

  to_value_result->SetWithoutPathExpansion("isEnabled", std::make_unique<base::Value>(this->is_enabled));

  to_value_result->SetWithoutPathExpansion("isUnified", std::make_unique<base::Value>(this->is_unified));

  if (this->is_auto_rotation_allowed.get()) {
    to_value_result->SetWithoutPathExpansion("isAutoRotationAllowed", std::make_unique<base::Value>(*this->is_auto_rotation_allowed));

  }
  to_value_result->SetWithoutPathExpansion("dpiX", std::make_unique<base::Value>(this->dpi_x));

  to_value_result->SetWithoutPathExpansion("dpiY", std::make_unique<base::Value>(this->dpi_y));

  to_value_result->SetWithoutPathExpansion("rotation", std::make_unique<base::Value>(this->rotation));

  to_value_result->SetWithoutPathExpansion("bounds", (this->bounds).ToValue());

  to_value_result->SetWithoutPathExpansion("overscan", (this->overscan).ToValue());

  to_value_result->SetWithoutPathExpansion("workArea", (this->work_area).ToValue());

  to_value_result->SetWithoutPathExpansion("modes", json_schema_compiler::util::CreateValueFromArray(this->modes));

  to_value_result->SetWithoutPathExpansion("hasTouchSupport", std::make_unique<base::Value>(this->has_touch_support));

  to_value_result->SetWithoutPathExpansion("hasAccelerometerSupport", std::make_unique<base::Value>(this->has_accelerometer_support));

  to_value_result->SetWithoutPathExpansion("availableDisplayZoomFactors", json_schema_compiler::util::CreateValueFromArray(this->available_display_zoom_factors));

  to_value_result->SetWithoutPathExpansion("displayZoomFactor", std::make_unique<base::Value>(this->display_zoom_factor));


  return to_value_result;
}


DisplayProperties::DisplayProperties()
 {}

DisplayProperties::~DisplayProperties() = default;
DisplayProperties::DisplayProperties(DisplayProperties&& rhs) = default;
DisplayProperties& DisplayProperties::operator=(DisplayProperties&& rhs) = default;
// static
bool DisplayProperties::Populate(
    const base::Value& value, DisplayProperties* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* is_unified_value = dict->FindKey("isUnified");
  if (is_unified_value) {
    {
      auto temp = (*is_unified_value).GetIfBool();
      if (!temp.has_value()) {
        out->is_unified.reset();
        return false;
      }
      out->is_unified = std::make_unique<bool>(temp.value());
    }
  }

  const base::Value* mirroring_source_id_value = dict->FindKey("mirroringSourceId");
  if (mirroring_source_id_value) {
    {
      auto* temp = (*mirroring_source_id_value).GetIfString();
      if (!temp) {
        out->mirroring_source_id.reset();
        return false;
      }
      out->mirroring_source_id = std::make_unique<std::string>(*temp);
    }
  }

  const base::Value* is_primary_value = dict->FindKey("isPrimary");
  if (is_primary_value) {
    {
      auto temp = (*is_primary_value).GetIfBool();
      if (!temp.has_value()) {
        out->is_primary.reset();
        return false;
      }
      out->is_primary = std::make_unique<bool>(temp.value());
    }
  }

  const base::Value* overscan_value = dict->FindKey("overscan");
  if (overscan_value) {
    {
      if (!(*overscan_value).is_dict()) {
        return false;
      }
      else {
        auto temp = std::make_unique<Insets>();
        if (!Insets::Populate((*overscan_value), temp.get())) {
          return false;
        }
        else
          out->overscan = std::move(temp);
      }
    }
  }

  const base::Value* rotation_value = dict->FindKey("rotation");
  if (rotation_value) {
    {
      auto temp = (*rotation_value).GetIfInt();
      if (!temp.has_value()) {
        out->rotation.reset();
        return false;
      }
      out->rotation = std::make_unique<int>(temp.value());
    }
  }

  const base::Value* bounds_origin_x_value = dict->FindKey("boundsOriginX");
  if (bounds_origin_x_value) {
    {
      auto temp = (*bounds_origin_x_value).GetIfInt();
      if (!temp.has_value()) {
        out->bounds_origin_x.reset();
        return false;
      }
      out->bounds_origin_x = std::make_unique<int>(temp.value());
    }
  }

  const base::Value* bounds_origin_y_value = dict->FindKey("boundsOriginY");
  if (bounds_origin_y_value) {
    {
      auto temp = (*bounds_origin_y_value).GetIfInt();
      if (!temp.has_value()) {
        out->bounds_origin_y.reset();
        return false;
      }
      out->bounds_origin_y = std::make_unique<int>(temp.value());
    }
  }

  const base::Value* display_mode_value = dict->FindKey("displayMode");
  if (display_mode_value) {
    {
      if (!(*display_mode_value).is_dict()) {
        return false;
      }
      else {
        auto temp = std::make_unique<DisplayMode>();
        if (!DisplayMode::Populate((*display_mode_value), temp.get())) {
          return false;
        }
        else
          out->display_mode = std::move(temp);
      }
    }
  }

  const base::Value* display_zoom_factor_value = dict->FindKey("displayZoomFactor");
  if (display_zoom_factor_value) {
    {
      auto temp = (*display_zoom_factor_value).GetIfDouble();
      if (!temp.has_value()) {
        out->display_zoom_factor.reset();
        return false;
      }
      out->display_zoom_factor = std::make_unique<double>(temp.value());
    }
  }

  return true;
}

// static
std::unique_ptr<DisplayProperties> DisplayProperties::FromValue(const base::Value& value) {
  auto out = std::make_unique<DisplayProperties>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> DisplayProperties::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  if (this->is_unified.get()) {
    to_value_result->SetWithoutPathExpansion("isUnified", std::make_unique<base::Value>(*this->is_unified));

  }
  if (this->mirroring_source_id.get()) {
    to_value_result->SetWithoutPathExpansion("mirroringSourceId", std::make_unique<base::Value>(*this->mirroring_source_id));

  }
  if (this->is_primary.get()) {
    to_value_result->SetWithoutPathExpansion("isPrimary", std::make_unique<base::Value>(*this->is_primary));

  }
  if (this->overscan.get()) {
    to_value_result->SetWithoutPathExpansion("overscan", (this->overscan)->ToValue());

  }
  if (this->rotation.get()) {
    to_value_result->SetWithoutPathExpansion("rotation", std::make_unique<base::Value>(*this->rotation));

  }
  if (this->bounds_origin_x.get()) {
    to_value_result->SetWithoutPathExpansion("boundsOriginX", std::make_unique<base::Value>(*this->bounds_origin_x));

  }
  if (this->bounds_origin_y.get()) {
    to_value_result->SetWithoutPathExpansion("boundsOriginY", std::make_unique<base::Value>(*this->bounds_origin_y));

  }
  if (this->display_mode.get()) {
    to_value_result->SetWithoutPathExpansion("displayMode", (this->display_mode)->ToValue());

  }
  if (this->display_zoom_factor.get()) {
    to_value_result->SetWithoutPathExpansion("displayZoomFactor", std::make_unique<base::Value>(*this->display_zoom_factor));

  }

  return to_value_result;
}


GetInfoFlags::GetInfoFlags()
 {}

GetInfoFlags::~GetInfoFlags() = default;
GetInfoFlags::GetInfoFlags(GetInfoFlags&& rhs) = default;
GetInfoFlags& GetInfoFlags::operator=(GetInfoFlags&& rhs) = default;
// static
bool GetInfoFlags::Populate(
    const base::Value& value, GetInfoFlags* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* single_unified_value = dict->FindKey("singleUnified");
  if (single_unified_value) {
    {
      auto temp = (*single_unified_value).GetIfBool();
      if (!temp.has_value()) {
        out->single_unified.reset();
        return false;
      }
      out->single_unified = std::make_unique<bool>(temp.value());
    }
  }

  return true;
}

// static
std::unique_ptr<GetInfoFlags> GetInfoFlags::FromValue(const base::Value& value) {
  auto out = std::make_unique<GetInfoFlags>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> GetInfoFlags::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  if (this->single_unified.get()) {
    to_value_result->SetWithoutPathExpansion("singleUnified", std::make_unique<base::Value>(*this->single_unified));

  }

  return to_value_result;
}


const char* ToString(MirrorMode enum_param) {
  switch (enum_param) {
    case MIRROR_MODE_OFF:
      return "off";
    case MIRROR_MODE_NORMAL:
      return "normal";
    case MIRROR_MODE_MIXED:
      return "mixed";
    case MIRROR_MODE_NONE:
      return "";
  }
  NOTREACHED();
  return "";
}

MirrorMode ParseMirrorMode(const std::string& enum_string) {
  if (enum_string == "off")
    return MIRROR_MODE_OFF;
  if (enum_string == "normal")
    return MIRROR_MODE_NORMAL;
  if (enum_string == "mixed")
    return MIRROR_MODE_MIXED;
  return MIRROR_MODE_NONE;
}


MirrorModeInfo::MirrorModeInfo()
: mode(MIRROR_MODE_NONE) {}

MirrorModeInfo::~MirrorModeInfo() = default;
MirrorModeInfo::MirrorModeInfo(MirrorModeInfo&& rhs) = default;
MirrorModeInfo& MirrorModeInfo::operator=(MirrorModeInfo&& rhs) = default;
// static
bool MirrorModeInfo::Populate(
    const base::Value& value, MirrorModeInfo* out) {
  if (!value.is_dict()) {
    return false;
  }
  const auto* dict = static_cast<const base::DictionaryValue*>(&value);
  const base::Value* mode_value = dict->FindKey("mode");
  if (!mode_value) {
    return false;
  }
  {
    const std::string* mirror_mode_as_string = (*mode_value).GetIfString();
    if (!mirror_mode_as_string) {
      return false;
    }
    out->mode = ParseMirrorMode(*mirror_mode_as_string);
    if (out->mode == MIRROR_MODE_NONE) {
      return false;
    }
  }

  const base::Value* mirroring_source_id_value = dict->FindKey("mirroringSourceId");
  if (mirroring_source_id_value) {
    {
      auto* temp = (*mirroring_source_id_value).GetIfString();
      if (!temp) {
        out->mirroring_source_id.reset();
        return false;
      }
      out->mirroring_source_id = std::make_unique<std::string>(*temp);
    }
  }

  const base::Value* mirroring_destination_ids_value = dict->FindKey("mirroringDestinationIds");
  if (mirroring_destination_ids_value) {
    {
      if (!(*mirroring_destination_ids_value).is_list()) {
        return false;
      }
      else {
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*mirroring_destination_ids_value).GetListDeprecated(), &out->mirroring_destination_ids)) {
          return false;
        }
      }
    }
  }

  return true;
}

// static
std::unique_ptr<MirrorModeInfo> MirrorModeInfo::FromValue(const base::Value& value) {
  auto out = std::make_unique<MirrorModeInfo>();
  bool result = Populate(value, out.get());
  if (!result)
    return nullptr;
  return out;
}

std::unique_ptr<base::DictionaryValue> MirrorModeInfo::ToValue() const {
  auto to_value_result =
      std::make_unique<base::DictionaryValue>();

  to_value_result->SetWithoutPathExpansion("mode", std::make_unique<base::Value>(system_display::ToString(this->mode)));

  if (this->mirroring_source_id.get()) {
    to_value_result->SetWithoutPathExpansion("mirroringSourceId", std::make_unique<base::Value>(*this->mirroring_source_id));

  }
  if (this->mirroring_destination_ids.get()) {
    to_value_result->SetWithoutPathExpansion("mirroringDestinationIds", json_schema_compiler::util::CreateValueFromArray(*this->mirroring_destination_ids));

  }

  return to_value_result;
}



//
// Functions
//

namespace GetInfo {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() > 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& flags_value = args[0];
    {
      if (!flags_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      else {
        auto temp = std::make_unique<GetInfoFlags>();
        if (!GetInfoFlags::Populate(flags_value, temp.get())) {
          return std::unique_ptr<Params>();
        }
        else
          params->flags = std::move(temp);
      }
    }
  }

  return params;
}


std::vector<base::Value> Results::Create(const std::vector<DisplayUnitInfo>& display_info) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue(json_schema_compiler::util::CreateValueFromArray(display_info)));

  return create_results;
}
}  // namespace GetInfo

namespace GetDisplayLayout {

std::vector<base::Value> Results::Create(const std::vector<DisplayLayout>& layouts) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue(json_schema_compiler::util::CreateValueFromArray(layouts)));

  return create_results;
}
}  // namespace GetDisplayLayout

namespace SetDisplayProperties {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& id_value = args[0];
    {
      auto* temp = id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& info_value = args[1];
    {
      if (!info_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!DisplayProperties::Populate(info_value, &params->info)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


std::vector<base::Value> Results::Create() {
  std::vector<base::Value> create_results;

  return create_results;
}
}  // namespace SetDisplayProperties

namespace SetDisplayLayout {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& layouts_value = args[0];
    {
      if (!layouts_value.is_list()) {
        return std::unique_ptr<Params>();
      }
      else {
        if (!json_schema_compiler::util::PopulateArrayFromList(layouts_value.GetListDeprecated(), &params->layouts)) {
          return std::unique_ptr<Params>();
        }
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


std::vector<base::Value> Results::Create() {
  std::vector<base::Value> create_results;

  return create_results;
}
}  // namespace SetDisplayLayout

namespace EnableUnifiedDesktop {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& enabled_value = args[0];
    {
      auto temp = enabled_value.GetIfBool();
      if (!temp.has_value()) {
        return std::unique_ptr<Params>();
      }
      params->enabled = temp.value();
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace EnableUnifiedDesktop

namespace OverscanCalibrationStart {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& id_value = args[0];
    {
      auto* temp = id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace OverscanCalibrationStart

namespace OverscanCalibrationAdjust {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& id_value = args[0];
    {
      auto* temp = id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& delta_value = args[1];
    {
      if (!delta_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!Insets::Populate(delta_value, &params->delta)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace OverscanCalibrationAdjust

namespace OverscanCalibrationReset {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& id_value = args[0];
    {
      auto* temp = id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace OverscanCalibrationReset

namespace OverscanCalibrationComplete {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& id_value = args[0];
    {
      auto* temp = id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace OverscanCalibrationComplete

namespace ShowNativeTouchCalibration {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& id_value = args[0];
    {
      auto* temp = id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


std::vector<base::Value> Results::Create(bool success) {
  std::vector<base::Value> create_results;
  create_results.reserve(1);
  create_results.push_back(base::Value::FromUniquePtrValue(std::make_unique<base::Value>(success)));

  return create_results;
}
}  // namespace ShowNativeTouchCalibration

namespace StartCustomTouchCalibration {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& id_value = args[0];
    {
      auto* temp = id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace StartCustomTouchCalibration

namespace CompleteCustomTouchCalibration {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 2) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& pairs_value = args[0];
    {
      if (!pairs_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!TouchCalibrationPairQuad::Populate(pairs_value, &params->pairs)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  if (1 < args.size() &&
      !args[1].is_none()) {
    const base::Value& bounds_value = args[1];
    {
      if (!bounds_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!Bounds::Populate(bounds_value, &params->bounds)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace CompleteCustomTouchCalibration

namespace ClearTouchCalibration {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& id_value = args[0];
    {
      auto* temp = id_value.GetIfString();
      if (!temp) {
        return std::unique_ptr<Params>();
      }
      params->id = *temp;
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


}  // namespace ClearTouchCalibration

namespace SetMirrorMode {

Params::Params() = default;
Params::~Params() = default;

// static
std::unique_ptr<Params> Params::Create(const base::Value::ConstListView& args) {
  if (args.size() != 1) {
    return nullptr;
  }
  std::unique_ptr<Params> params(new Params());

  if (0 < args.size() &&
      !args[0].is_none()) {
    const base::Value& info_value = args[0];
    {
      if (!info_value.is_dict()) {
        return std::unique_ptr<Params>();
      }
      if (!MirrorModeInfo::Populate(info_value, &params->info)) {
        return std::unique_ptr<Params>();
      }
    }
  }
  else {
    return std::unique_ptr<Params>();
  }

  return params;
}


std::vector<base::Value> Results::Create() {
  std::vector<base::Value> create_results;

  return create_results;
}
}  // namespace SetMirrorMode

//
// Events
//

namespace OnDisplayChanged {

const char kEventName[] = "system.display.onDisplayChanged";

std::vector<base::Value> Create() {
  std::vector<base::Value> create_results;

  return create_results;
}

}  // namespace OnDisplayChanged

}  // namespace system_display
}  // namespace api
}  // namespace extensions

