// extensions/common/mojom/event_router.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef EXTENSIONS_COMMON_MOJOM_EVENT_ROUTER_MOJOM_H_
#define EXTENSIONS_COMMON_MOJOM_EVENT_ROUTER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "extensions/common/mojom/event_router.mojom-shared.h"
#include "extensions/common/mojom/event_router.mojom-forward.h"
#include "mojo/public/mojom/base/values.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace extensions {
namespace mojom {

class EventRouterProxy;

template <typename ImplRefTraits>
class EventRouterStub;

class EventRouterRequestValidator;


class  EventRouter
    : public EventRouterInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = EventRouterInterfaceBase;
  using Proxy_ = EventRouterProxy;

  template <typename ImplRefTraits>
  using Stub_ = EventRouterStub<ImplRefTraits>;

  using RequestValidator_ = EventRouterRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kAddListenerForMainThreadMinVersion = 0,
    kAddListenerForServiceWorkerMinVersion = 0,
    kAddLazyListenerForMainThreadMinVersion = 0,
    kAddLazyListenerForServiceWorkerMinVersion = 0,
    kAddFilteredListenerForMainThreadMinVersion = 0,
    kAddFilteredListenerForServiceWorkerMinVersion = 0,
    kRemoveListenerForMainThreadMinVersion = 0,
    kRemoveListenerForServiceWorkerMinVersion = 0,
    kRemoveLazyListenerForMainThreadMinVersion = 0,
    kRemoveLazyListenerForServiceWorkerMinVersion = 0,
    kRemoveFilteredListenerForMainThreadMinVersion = 0,
    kRemoveFilteredListenerForServiceWorkerMinVersion = 0,
  };
  virtual ~EventRouter() = default;

  
  virtual void AddListenerForMainThread(EventListenerParamPtr param, const std::string& event_name) = 0;

  
  virtual void AddListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name, int64_t service_worker_version_id, int32_t worker_thread_id) = 0;

  
  virtual void AddLazyListenerForMainThread(const std::string& extension_id, const std::string& event_name) = 0;

  
  virtual void AddLazyListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name) = 0;

  
  virtual void AddFilteredListenerForMainThread(EventListenerParamPtr param, const std::string& event_name, ::base::Value filter, bool add_lazy_listener) = 0;

  
  virtual void AddFilteredListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name, int64_t service_worker_version_id, int32_t worker_thread_id, ::base::Value filter, bool add_lazy_listener) = 0;

  
  virtual void RemoveListenerForMainThread(EventListenerParamPtr param, const std::string& event_name) = 0;

  
  virtual void RemoveListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name, int64_t service_worker_version_id, int32_t worker_thread_id) = 0;

  
  virtual void RemoveLazyListenerForMainThread(const std::string& extension_id, const std::string& event_name) = 0;

  
  virtual void RemoveLazyListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name) = 0;

  
  virtual void RemoveFilteredListenerForMainThread(EventListenerParamPtr param, const std::string& event_name, ::base::Value filter, bool remove_lazy_listener) = 0;

  
  virtual void RemoveFilteredListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name, int64_t service_worker_version_id, int32_t worker_thread_id, ::base::Value filter, bool remove_lazy_listener) = 0;
};



class  EventRouterProxy
    : public EventRouter {
 public:
  using InterfaceType = EventRouter;

  explicit EventRouterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AddListenerForMainThread(EventListenerParamPtr param, const std::string& event_name) final;
  
  void AddListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name, int64_t service_worker_version_id, int32_t worker_thread_id) final;
  
  void AddLazyListenerForMainThread(const std::string& extension_id, const std::string& event_name) final;
  
  void AddLazyListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name) final;
  
  void AddFilteredListenerForMainThread(EventListenerParamPtr param, const std::string& event_name, ::base::Value filter, bool add_lazy_listener) final;
  
  void AddFilteredListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name, int64_t service_worker_version_id, int32_t worker_thread_id, ::base::Value filter, bool add_lazy_listener) final;
  
  void RemoveListenerForMainThread(EventListenerParamPtr param, const std::string& event_name) final;
  
  void RemoveListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name, int64_t service_worker_version_id, int32_t worker_thread_id) final;
  
  void RemoveLazyListenerForMainThread(const std::string& extension_id, const std::string& event_name) final;
  
  void RemoveLazyListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name) final;
  
  void RemoveFilteredListenerForMainThread(EventListenerParamPtr param, const std::string& event_name, ::base::Value filter, bool remove_lazy_listener) final;
  
  void RemoveFilteredListenerForServiceWorker(const std::string& extension_id, const ::GURL& worker_scope_url, const std::string& event_name, int64_t service_worker_version_id, int32_t worker_thread_id, ::base::Value filter, bool remove_lazy_listener) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  EventRouterStubDispatch {
 public:
  static bool Accept(EventRouter* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      EventRouter* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<EventRouter>>
class EventRouterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  EventRouterStub() = default;
  ~EventRouterStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return EventRouterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return EventRouterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  EventRouterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  EventListenerParam {
 public:
  using DataView = EventListenerParamDataView;
  using Data_ = internal::EventListenerParam_Data;
  using Tag = Data_::EventListenerParam_Tag;

  static EventListenerParamPtr New() {
    return EventListenerParamPtr(base::in_place);
  }
  // Construct an instance holding |extension_id|.
  static EventListenerParamPtr
  NewExtensionId(
      const std::string& extension_id) {
    auto result = EventListenerParamPtr(base::in_place);
    result->set_extension_id(std::move(extension_id));
    return result;
  }
  // Construct an instance holding |listener_url|.
  static EventListenerParamPtr
  NewListenerUrl(
      const ::GURL& listener_url) {
    auto result = EventListenerParamPtr(base::in_place);
    result->set_listener_url(std::move(listener_url));
    return result;
  }

  template <typename U>
  static EventListenerParamPtr From(const U& u) {
    return mojo::TypeConverter<EventListenerParamPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, EventListenerParam>::Convert(*this);
  }

  EventListenerParam();
  ~EventListenerParam();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = EventListenerParamPtr>
  EventListenerParamPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, EventListenerParam>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, EventListenerParam>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_extension_id() const { return tag_ == Tag::EXTENSION_ID; }

  
  std::string& get_extension_id() const {
    CHECK(tag_ == Tag::EXTENSION_ID);
    return *(data_.extension_id);
  }

  
  void set_extension_id(
      const std::string& extension_id);
  
  bool is_listener_url() const { return tag_ == Tag::LISTENER_URL; }

  
  ::GURL& get_listener_url() const {
    CHECK(tag_ == Tag::LISTENER_URL);
    return *(data_.listener_url);
  }

  
  void set_listener_url(
      const ::GURL& listener_url);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        EventListenerParam::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<EventListenerParam::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    std::string* extension_id;
    ::GURL* listener_url;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};

template <typename UnionPtrType>
EventListenerParamPtr EventListenerParam::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::EXTENSION_ID:
      rv->set_extension_id(mojo::Clone(*data_.extension_id));
      break;
    case Tag::LISTENER_URL:
      rv->set_listener_url(mojo::Clone(*data_.listener_url));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, EventListenerParam>::value>::type*>
bool EventListenerParam::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::EXTENSION_ID:
      return mojo::Equals(*(data_.extension_id), *(other.data_.extension_id));
    case Tag::LISTENER_URL:
      return mojo::Equals(*(data_.listener_url), *(other.data_.listener_url));
  }

  return false;
}


}  // namespace mojom
}  // namespace extensions

namespace mojo {


template <>
struct  UnionTraits<::extensions::mojom::EventListenerParam::DataView,
                                        ::extensions::mojom::EventListenerParamPtr> {
  static bool IsNull(const ::extensions::mojom::EventListenerParamPtr& input) { return !input; }
  static void SetToNull(::extensions::mojom::EventListenerParamPtr* output) { output->reset(); }

  static ::extensions::mojom::EventListenerParam::Tag GetTag(const ::extensions::mojom::EventListenerParamPtr& input) {
    return input->which();
  }

  static const std::string& extension_id(const ::extensions::mojom::EventListenerParamPtr& input) {
    return input->get_extension_id();
  }

  static const ::GURL& listener_url(const ::extensions::mojom::EventListenerParamPtr& input) {
    return input->get_listener_url();
  }

  static bool Read(::extensions::mojom::EventListenerParam::DataView input, ::extensions::mojom::EventListenerParamPtr* output);
};

}  // namespace mojo

#endif  // EXTENSIONS_COMMON_MOJOM_EVENT_ROUTER_MOJOM_H_