// qtwebengine/common/renderer_configuration.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "qtwebengine/common/renderer_configuration.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "qtwebengine/common/renderer_configuration.mojom-params-data.h"
#include "qtwebengine/common/renderer_configuration.mojom-shared-message-ids.h"

#include "qtwebengine/common/renderer_configuration.mojom-import-headers.h"
#include "qtwebengine/common/renderer_configuration.mojom-test-utils.h"


#ifndef QTWEBENGINE_COMMON_RENDERER_CONFIGURATION_MOJOM_JUMBO_H_
#define QTWEBENGINE_COMMON_RENDERER_CONFIGURATION_MOJOM_JUMBO_H_
#endif



namespace qtwebengine {
namespace mojom {
const char RendererConfiguration::Name_[] = "qtwebengine.mojom.RendererConfiguration";

uint32_t RendererConfiguration::MessageToStableIPCHash_(mojo::Message& message) {
  switch (message.name()) {
    case internal::kRendererConfiguration_SetInitialConfiguration_Name: {
      constexpr uint32_t value = base::MD5Hash32Constexpr(
              "(Impl)qtwebengine::mojom::RendererConfiguration::SetInitialConfiguration");
      return value;
    }
  }
  return 0;
}


const char* RendererConfiguration::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kRendererConfiguration_SetInitialConfiguration_Name:
            return "Receive qtwebengine::mojom::RendererConfiguration::SetInitialConfiguration";
    }
  } else {
    switch (message.name()) {
      case internal::kRendererConfiguration_SetInitialConfiguration_Name:
            return "Receive reply qtwebengine::mojom::RendererConfiguration::SetInitialConfiguration";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

RendererConfigurationProxy::RendererConfigurationProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void RendererConfigurationProxy::SetInitialConfiguration(
    bool in_is_incognito_process) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send qtwebengine::mojom::RendererConfiguration::SetInitialConfiguration", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("is_incognito_process"), in_is_incognito_process,
                        "<value of type bool>");
   });
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kRendererConfiguration_SetInitialConfiguration_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::qtwebengine::mojom::internal::RendererConfiguration_SetInitialConfiguration_Params_Data> params(
          message);
  params.Allocate();
  params->is_incognito_process = in_is_incognito_process;

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(RendererConfiguration::Name_);
  message.set_method_name("SetInitialConfiguration");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMessage(*receiver_, message);
}

// static
bool RendererConfigurationStubDispatch::Accept(
    RendererConfiguration* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kRendererConfiguration_SetInitialConfiguration_Name: {

      DCHECK(message->is_serialized());
      internal::RendererConfiguration_SetInitialConfiguration_Params_Data* params =
          reinterpret_cast<internal::RendererConfiguration_SetInitialConfiguration_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      bool p_is_incognito_process{};
      RendererConfiguration_SetInitialConfiguration_ParamsDataView input_data_view(params, message);
      
      if (success)
        p_is_incognito_process = input_data_view.is_incognito_process();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            RendererConfiguration::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetInitialConfiguration(
std::move(p_is_incognito_process));
      return true;
    }
  }
  return false;
}

// static
bool RendererConfigurationStubDispatch::AcceptWithResponder(
    RendererConfiguration* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kRendererConfiguration_SetInitialConfiguration_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kRendererConfigurationValidationInfo[] = {
    {internal::kRendererConfiguration_SetInitialConfiguration_Name,
     {&internal::RendererConfiguration_SetInitialConfiguration_Params_Data::Validate,
      nullptr /* no response */}},
};

bool RendererConfigurationRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::qtwebengine::mojom::RendererConfiguration::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kRendererConfigurationValidationInfo);
}



}  // namespace mojom
}  // namespace qtwebengine


namespace mojo {

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace qtwebengine {
namespace mojom {


void RendererConfigurationInterceptorForTesting::SetInitialConfiguration(bool is_incognito_process) {
  GetForwardingInterface()->SetInitialConfiguration(std::move(is_incognito_process));
}
RendererConfigurationAsyncWaiter::RendererConfigurationAsyncWaiter(
    RendererConfiguration* proxy) : proxy_(proxy) {}

RendererConfigurationAsyncWaiter::~RendererConfigurationAsyncWaiter() = default;






}  // namespace mojom
}  // namespace qtwebengine


#if defined(__clang__)
#pragma clang diagnostic pop
#endif