// services/data_decoder/public/mojom/gzipper.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DATA_DECODER_PUBLIC_MOJOM_GZIPPER_MOJOM_H_
#define SERVICES_DATA_DECODER_PUBLIC_MOJOM_GZIPPER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/data_decoder/public/mojom/gzipper.mojom-shared.h"
#include "services/data_decoder/public/mojom/gzipper.mojom-forward.h"
#include "mojo/public/mojom/base/big_buffer.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace data_decoder {
namespace mojom {

class GzipperProxy;

template <typename ImplRefTraits>
class GzipperStub;

class GzipperRequestValidator;
class GzipperResponseValidator;


class  Gzipper
    : public GzipperInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = GzipperInterfaceBase;
  using Proxy_ = GzipperProxy;

  template <typename ImplRefTraits>
  using Stub_ = GzipperStub<ImplRefTraits>;

  using RequestValidator_ = GzipperRequestValidator;
  using ResponseValidator_ = GzipperResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCompressMinVersion = 0,
    kUncompressMinVersion = 0,
  };
  virtual ~Gzipper() = default;


  using CompressCallback = base::OnceCallback<void(absl::optional<::mojo_base::BigBuffer>)>;
  
  virtual void Compress(::mojo_base::BigBuffer data, CompressCallback callback) = 0;


  using UncompressCallback = base::OnceCallback<void(absl::optional<::mojo_base::BigBuffer>)>;
  
  virtual void Uncompress(::mojo_base::BigBuffer compressed_data, UncompressCallback callback) = 0;
};



class  GzipperProxy
    : public Gzipper {
 public:
  using InterfaceType = Gzipper;

  explicit GzipperProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Compress(::mojo_base::BigBuffer data, CompressCallback callback) final;
  
  void Uncompress(::mojo_base::BigBuffer compressed_data, UncompressCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  GzipperStubDispatch {
 public:
  static bool Accept(Gzipper* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      Gzipper* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Gzipper>>
class GzipperStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  GzipperStub() = default;
  ~GzipperStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return GzipperStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return GzipperStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  GzipperRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  GzipperResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace data_decoder

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_DATA_DECODER_PUBLIC_MOJOM_GZIPPER_MOJOM_H_