// third_party/blink/public/mojom/browsing_topics/browsing_topics.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_BROWSING_TOPICS_BROWSING_TOPICS_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_BROWSING_TOPICS_BROWSING_TOPICS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/browsing_topics/browsing_topics.mojom-shared.h"
#include "third_party/blink/public/mojom/browsing_topics/browsing_topics.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class BrowsingTopicsDocumentServiceProxy;

template <typename ImplRefTraits>
class BrowsingTopicsDocumentServiceStub;

class BrowsingTopicsDocumentServiceRequestValidator;
class BrowsingTopicsDocumentServiceResponseValidator;


class BLINK_COMMON_EXPORT BrowsingTopicsDocumentService
    : public BrowsingTopicsDocumentServiceInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = BrowsingTopicsDocumentServiceInterfaceBase;
  using Proxy_ = BrowsingTopicsDocumentServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = BrowsingTopicsDocumentServiceStub<ImplRefTraits>;

  using RequestValidator_ = BrowsingTopicsDocumentServiceRequestValidator;
  using ResponseValidator_ = BrowsingTopicsDocumentServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetBrowsingTopicsMinVersion = 0,
  };
  virtual ~BrowsingTopicsDocumentService() = default;


  using GetBrowsingTopicsCallback = base::OnceCallback<void(std::vector<EpochTopicPtr>)>;
  
  virtual void GetBrowsingTopics(GetBrowsingTopicsCallback callback) = 0;
};



class BLINK_COMMON_EXPORT BrowsingTopicsDocumentServiceProxy
    : public BrowsingTopicsDocumentService {
 public:
  using InterfaceType = BrowsingTopicsDocumentService;

  explicit BrowsingTopicsDocumentServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetBrowsingTopics(GetBrowsingTopicsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT BrowsingTopicsDocumentServiceStubDispatch {
 public:
  static bool Accept(BrowsingTopicsDocumentService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BrowsingTopicsDocumentService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BrowsingTopicsDocumentService>>
class BrowsingTopicsDocumentServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BrowsingTopicsDocumentServiceStub() = default;
  ~BrowsingTopicsDocumentServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BrowsingTopicsDocumentServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BrowsingTopicsDocumentServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT BrowsingTopicsDocumentServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT BrowsingTopicsDocumentServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class BLINK_COMMON_EXPORT EpochTopic {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<EpochTopic, T>::value>;
  using DataView = EpochTopicDataView;
  using Data_ = internal::EpochTopic_Data;

  template <typename... Args>
  static EpochTopicPtr New(Args&&... args) {
    return EpochTopicPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static EpochTopicPtr From(const U& u) {
    return mojo::TypeConverter<EpochTopicPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, EpochTopic>::Convert(*this);
  }


  EpochTopic();

  EpochTopic(
      int32_t topic,
      const std::string& version,
      const std::string& config_version,
      const std::string& model_version,
      const std::string& taxonomy_version);


  ~EpochTopic();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = EpochTopicPtr>
  EpochTopicPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, EpochTopic::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, EpochTopic::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        EpochTopic::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        EpochTopic::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::EpochTopic_UnserializedMessageContext<
            UserType, EpochTopic::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<EpochTopic::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return EpochTopic::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::EpochTopic_UnserializedMessageContext<
            UserType, EpochTopic::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<EpochTopic::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  int32_t topic;
  
  std::string version;
  
  std::string config_version;
  
  std::string model_version;
  
  std::string taxonomy_version;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, EpochTopic::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, EpochTopic::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, EpochTopic::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, EpochTopic::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
EpochTopicPtr EpochTopic::Clone() const {
  return New(
      mojo::Clone(topic),
      mojo::Clone(version),
      mojo::Clone(config_version),
      mojo::Clone(model_version),
      mojo::Clone(taxonomy_version)
  );
}

template <typename T, EpochTopic::EnableIfSame<T>*>
bool EpochTopic::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->topic, other_struct.topic))
    return false;
  if (!mojo::Equals(this->version, other_struct.version))
    return false;
  if (!mojo::Equals(this->config_version, other_struct.config_version))
    return false;
  if (!mojo::Equals(this->model_version, other_struct.model_version))
    return false;
  if (!mojo::Equals(this->taxonomy_version, other_struct.taxonomy_version))
    return false;
  return true;
}

template <typename T, EpochTopic::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.topic < rhs.topic)
    return true;
  if (rhs.topic < lhs.topic)
    return false;
  if (lhs.version < rhs.version)
    return true;
  if (rhs.version < lhs.version)
    return false;
  if (lhs.config_version < rhs.config_version)
    return true;
  if (rhs.config_version < lhs.config_version)
    return false;
  if (lhs.model_version < rhs.model_version)
    return true;
  if (rhs.model_version < lhs.model_version)
    return false;
  if (lhs.taxonomy_version < rhs.taxonomy_version)
    return true;
  if (rhs.taxonomy_version < lhs.taxonomy_version)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::EpochTopic::DataView,
                                         ::blink::mojom::EpochTopicPtr> {
  static bool IsNull(const ::blink::mojom::EpochTopicPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::EpochTopicPtr* output) { output->reset(); }

  static decltype(::blink::mojom::EpochTopic::topic) topic(
      const ::blink::mojom::EpochTopicPtr& input) {
    return input->topic;
  }

  static const decltype(::blink::mojom::EpochTopic::version)& version(
      const ::blink::mojom::EpochTopicPtr& input) {
    return input->version;
  }

  static const decltype(::blink::mojom::EpochTopic::config_version)& config_version(
      const ::blink::mojom::EpochTopicPtr& input) {
    return input->config_version;
  }

  static const decltype(::blink::mojom::EpochTopic::model_version)& model_version(
      const ::blink::mojom::EpochTopicPtr& input) {
    return input->model_version;
  }

  static const decltype(::blink::mojom::EpochTopic::taxonomy_version)& taxonomy_version(
      const ::blink::mojom::EpochTopicPtr& input) {
    return input->taxonomy_version;
  }

  static bool Read(::blink::mojom::EpochTopic::DataView input, ::blink::mojom::EpochTopicPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_BROWSING_TOPICS_BROWSING_TOPICS_MOJOM_H_