// third_party/blink/public/mojom/conversions/conversions.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_CONVERSIONS_CONVERSIONS_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_CONVERSIONS_CONVERSIONS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/conversions/conversions.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "third_party/blink/public/mojom/conversions/attribution_data_host.mojom-shared.h"
#include "third_party/blink/public/mojom/tokens/tokens.mojom-shared.h"
#include "url/mojom/origin.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "base/component_export.h"




namespace blink {
namespace mojom {
class ImpressionDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::ImpressionDataView> {
  using Data = ::blink::mojom::internal::Impression_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ConversionHostInterfaceBase {};

using ConversionHostPtrDataView =
    mojo::InterfacePtrDataView<ConversionHostInterfaceBase>;
using ConversionHostRequestDataView =
    mojo::InterfaceRequestDataView<ConversionHostInterfaceBase>;
using ConversionHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ConversionHostInterfaceBase>;
using ConversionHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ConversionHostInterfaceBase>;


class ImpressionDataView {
 public:
  ImpressionDataView() = default;

  ImpressionDataView(
      internal::Impression_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetConversionDestinationDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadConversionDestination(UserType* output) {
    
    auto* pointer = data_->conversion_destination.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, message_);
  }
  inline void GetReportingOriginDataView(
      ::url::mojom::OriginDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadReportingOrigin(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::url::mojom::OriginDataView, UserType>(),
    "Attempting to read the optional `reporting_origin` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadReportingOrigin` instead "
    "of `ReadReportingOrigin if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->reporting_origin.Get();
    return mojo::internal::Deserialize<::url::mojom::OriginDataView>(
        pointer, output, message_);
  }
  uint64_t impression_data() const {
    return data_->impression_data;
  }
  inline void GetExpiryDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadExpiry(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::mojo_base::mojom::TimeDeltaDataView, UserType>(),
    "Attempting to read the optional `expiry` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadExpiry` instead "
    "of `ReadExpiry if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->expiry.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, message_);
  }
  int64_t priority() const {
    return data_->priority;
  }
  inline void GetAttributionSrcTokenDataView(
      ::blink::mojom::AttributionSrcTokenDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadAttributionSrcToken(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::blink::mojom::AttributionSrcTokenDataView, UserType>(),
    "Attempting to read the optional `attribution_src_token` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadAttributionSrcToken` instead "
    "of `ReadAttributionSrcToken if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->attribution_src_token.Get();
    return mojo::internal::Deserialize<::blink::mojom::AttributionSrcTokenDataView>(
        pointer, output, message_);
  }
 private:
  internal::Impression_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ImpressionDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ImpressionDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::Impression_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::conversion_destination(input)) in_conversion_destination = Traits::conversion_destination(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->conversion_destination)::BaseType> conversion_destination_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_conversion_destination, conversion_destination_fragment);
    fragment->conversion_destination.Set(
        conversion_destination_fragment.is_null() ? nullptr : conversion_destination_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->conversion_destination.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null conversion_destination in Impression struct");
    decltype(Traits::reporting_origin(input)) in_reporting_origin = Traits::reporting_origin(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->reporting_origin)::BaseType> reporting_origin_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::OriginDataView>(
        in_reporting_origin, reporting_origin_fragment);
    fragment->reporting_origin.Set(
        reporting_origin_fragment.is_null() ? nullptr : reporting_origin_fragment.data());
    fragment->impression_data = Traits::impression_data(input);
    decltype(Traits::expiry(input)) in_expiry = Traits::expiry(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->expiry)::BaseType> expiry_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
        in_expiry, expiry_fragment);
    fragment->expiry.Set(
        expiry_fragment.is_null() ? nullptr : expiry_fragment.data());
    fragment->priority = Traits::priority(input);
    decltype(Traits::attribution_src_token(input)) in_attribution_src_token = Traits::attribution_src_token(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->attribution_src_token)::BaseType> attribution_src_token_fragment(
            fragment.message());
    mojo::internal::Serialize<::blink::mojom::AttributionSrcTokenDataView>(
        in_attribution_src_token, attribution_src_token_fragment);
    fragment->attribution_src_token.Set(
        attribution_src_token_fragment.is_null() ? nullptr : attribution_src_token_fragment.data());
  }

  static bool Deserialize(::blink::mojom::internal::Impression_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ImpressionDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void ImpressionDataView::GetConversionDestinationDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->conversion_destination.Get();
  *output = ::url::mojom::OriginDataView(pointer, message_);
}
inline void ImpressionDataView::GetReportingOriginDataView(
    ::url::mojom::OriginDataView* output) {
  auto pointer = data_->reporting_origin.Get();
  *output = ::url::mojom::OriginDataView(pointer, message_);
}
inline void ImpressionDataView::GetExpiryDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->expiry.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, message_);
}
inline void ImpressionDataView::GetAttributionSrcTokenDataView(
    ::blink::mojom::AttributionSrcTokenDataView* output) {
  auto pointer = data_->attribution_src_token.Get();
  *output = ::blink::mojom::AttributionSrcTokenDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace blink

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_CONVERSIONS_CONVERSIONS_MOJOM_SHARED_H_