// third_party/blink/public/mojom/digital_goods/digital_goods.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIGITAL_GOODS_DIGITAL_GOODS_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIGITAL_GOODS_DIGITAL_GOODS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/digital_goods/digital_goods.mojom-shared.h"
#include "third_party/blink/public/mojom/digital_goods/digital_goods.mojom-forward.h"
#include "components/payments/mojom/payment_request_data.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace payments {
namespace mojom {

class DigitalGoodsProxy;

template <typename ImplRefTraits>
class DigitalGoodsStub;

class DigitalGoodsRequestValidator;
class DigitalGoodsResponseValidator;


class BLINK_COMMON_EXPORT DigitalGoods
    : public DigitalGoodsInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = DigitalGoodsInterfaceBase;
  using Proxy_ = DigitalGoodsProxy;

  template <typename ImplRefTraits>
  using Stub_ = DigitalGoodsStub<ImplRefTraits>;

  using RequestValidator_ = DigitalGoodsRequestValidator;
  using ResponseValidator_ = DigitalGoodsResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetDetailsMinVersion = 0,
    kListPurchasesMinVersion = 0,
    kListPurchaseHistoryMinVersion = 0,
    kConsumeMinVersion = 0,
  };
  virtual ~DigitalGoods() = default;


  using GetDetailsCallback = base::OnceCallback<void(BillingResponseCode, std::vector<ItemDetailsPtr>)>;
  
  virtual void GetDetails(const std::vector<std::string>& item_ids, GetDetailsCallback callback) = 0;


  using ListPurchasesCallback = base::OnceCallback<void(BillingResponseCode, std::vector<PurchaseReferencePtr>)>;
  
  virtual void ListPurchases(ListPurchasesCallback callback) = 0;


  using ListPurchaseHistoryCallback = base::OnceCallback<void(BillingResponseCode, std::vector<PurchaseReferencePtr>)>;
  
  virtual void ListPurchaseHistory(ListPurchaseHistoryCallback callback) = 0;


  using ConsumeCallback = base::OnceCallback<void(BillingResponseCode)>;
  
  virtual void Consume(const std::string& purchase_token, ConsumeCallback callback) = 0;
};

class DigitalGoodsFactoryProxy;

template <typename ImplRefTraits>
class DigitalGoodsFactoryStub;

class DigitalGoodsFactoryRequestValidator;
class DigitalGoodsFactoryResponseValidator;


class BLINK_COMMON_EXPORT DigitalGoodsFactory
    : public DigitalGoodsFactoryInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = DigitalGoodsFactoryInterfaceBase;
  using Proxy_ = DigitalGoodsFactoryProxy;

  template <typename ImplRefTraits>
  using Stub_ = DigitalGoodsFactoryStub<ImplRefTraits>;

  using RequestValidator_ = DigitalGoodsFactoryRequestValidator;
  using ResponseValidator_ = DigitalGoodsFactoryResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateDigitalGoodsMinVersion = 0,
  };
  virtual ~DigitalGoodsFactory() = default;


  using CreateDigitalGoodsCallback = base::OnceCallback<void(CreateDigitalGoodsResponseCode, ::mojo::PendingRemote<DigitalGoods>)>;
  
  virtual void CreateDigitalGoods(const std::string& payment_method, CreateDigitalGoodsCallback callback) = 0;
};



class BLINK_COMMON_EXPORT DigitalGoodsProxy
    : public DigitalGoods {
 public:
  using InterfaceType = DigitalGoods;

  explicit DigitalGoodsProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetDetails(const std::vector<std::string>& item_ids, GetDetailsCallback callback) final;
  
  void ListPurchases(ListPurchasesCallback callback) final;
  
  void ListPurchaseHistory(ListPurchaseHistoryCallback callback) final;
  
  void Consume(const std::string& purchase_token, ConsumeCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT DigitalGoodsFactoryProxy
    : public DigitalGoodsFactory {
 public:
  using InterfaceType = DigitalGoodsFactory;

  explicit DigitalGoodsFactoryProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateDigitalGoods(const std::string& payment_method, CreateDigitalGoodsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT DigitalGoodsStubDispatch {
 public:
  static bool Accept(DigitalGoods* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      DigitalGoods* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DigitalGoods>>
class DigitalGoodsStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DigitalGoodsStub() = default;
  ~DigitalGoodsStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DigitalGoodsStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DigitalGoodsStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT DigitalGoodsFactoryStubDispatch {
 public:
  static bool Accept(DigitalGoodsFactory* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      DigitalGoodsFactory* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DigitalGoodsFactory>>
class DigitalGoodsFactoryStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DigitalGoodsFactoryStub() = default;
  ~DigitalGoodsFactoryStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DigitalGoodsFactoryStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DigitalGoodsFactoryStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT DigitalGoodsRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT DigitalGoodsFactoryRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT DigitalGoodsResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT DigitalGoodsFactoryResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class BLINK_COMMON_EXPORT PurchaseReference {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PurchaseReference, T>::value>;
  using DataView = PurchaseReferenceDataView;
  using Data_ = internal::PurchaseReference_Data;

  template <typename... Args>
  static PurchaseReferencePtr New(Args&&... args) {
    return PurchaseReferencePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PurchaseReferencePtr From(const U& u) {
    return mojo::TypeConverter<PurchaseReferencePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PurchaseReference>::Convert(*this);
  }


  PurchaseReference();

  PurchaseReference(
      const std::string& item_id,
      const std::string& purchase_token);


  ~PurchaseReference();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PurchaseReferencePtr>
  PurchaseReferencePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PurchaseReference::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, PurchaseReference::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PurchaseReference::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PurchaseReference::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PurchaseReference_UnserializedMessageContext<
            UserType, PurchaseReference::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<PurchaseReference::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PurchaseReference::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PurchaseReference_UnserializedMessageContext<
            UserType, PurchaseReference::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PurchaseReference::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string item_id;
  
  std::string purchase_token;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PurchaseReference::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PurchaseReference::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PurchaseReference::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PurchaseReference::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class BLINK_COMMON_EXPORT ItemDetails {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ItemDetails, T>::value>;
  using DataView = ItemDetailsDataView;
  using Data_ = internal::ItemDetails_Data;

  template <typename... Args>
  static ItemDetailsPtr New(Args&&... args) {
    return ItemDetailsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ItemDetailsPtr From(const U& u) {
    return mojo::TypeConverter<ItemDetailsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ItemDetails>::Convert(*this);
  }


  ItemDetails();

  ItemDetails(
      const std::string& item_id,
      const std::string& title,
      const std::string& description,
      ::payments::mojom::PaymentCurrencyAmountPtr price,
      const absl::optional<std::string>& subscription_period,
      const absl::optional<std::string>& free_trial_period,
      ::payments::mojom::PaymentCurrencyAmountPtr introductory_price,
      const absl::optional<std::string>& introductory_price_period);

  ItemDetails(
      const std::string& item_id,
      const std::string& title,
      const std::string& description,
      ::payments::mojom::PaymentCurrencyAmountPtr price,
      const absl::optional<std::string>& subscription_period,
      const absl::optional<std::string>& free_trial_period,
      ::payments::mojom::PaymentCurrencyAmountPtr introductory_price,
      const absl::optional<std::string>& introductory_price_period,
      uint32_t introductory_price_cycles,
      ItemType type,
      absl::optional<std::vector<::GURL>> icon_urls);

ItemDetails(const ItemDetails&) = delete;
ItemDetails& operator=(const ItemDetails&) = delete;

  ~ItemDetails();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ItemDetailsPtr>
  ItemDetailsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ItemDetails::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ItemDetails::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ItemDetails_UnserializedMessageContext<
            UserType, ItemDetails::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ItemDetails::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ItemDetails::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ItemDetails_UnserializedMessageContext<
            UserType, ItemDetails::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ItemDetails::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string item_id;
  
  std::string title;
  
  std::string description;
  
  ::payments::mojom::PaymentCurrencyAmountPtr price;
  
  absl::optional<std::string> subscription_period;
  
  absl::optional<std::string> free_trial_period;
  
  ::payments::mojom::PaymentCurrencyAmountPtr introductory_price;
  
  absl::optional<std::string> introductory_price_period;
  
  uint32_t introductory_price_cycles;
  
  ItemType type;
  
  absl::optional<std::vector<::GURL>> icon_urls;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT PurchaseDetails {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PurchaseDetails, T>::value>;
  using DataView = PurchaseDetailsDataView;
  using Data_ = internal::PurchaseDetails_Data;

  template <typename... Args>
  static PurchaseDetailsPtr New(Args&&... args) {
    return PurchaseDetailsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PurchaseDetailsPtr From(const U& u) {
    return mojo::TypeConverter<PurchaseDetailsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PurchaseDetails>::Convert(*this);
  }


  PurchaseDetails();

  PurchaseDetails(
      const std::string& item_id,
      const std::string& purchase_token,
      bool acknowledged,
      PurchaseState purchase_state,
      ::base::TimeDelta purchase_time,
      bool will_auto_renew);


  ~PurchaseDetails();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PurchaseDetailsPtr>
  PurchaseDetailsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PurchaseDetails::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, PurchaseDetails::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PurchaseDetails::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PurchaseDetails::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PurchaseDetails_UnserializedMessageContext<
            UserType, PurchaseDetails::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<PurchaseDetails::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PurchaseDetails::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PurchaseDetails_UnserializedMessageContext<
            UserType, PurchaseDetails::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PurchaseDetails::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string item_id;
  
  std::string purchase_token;
  
  bool acknowledged;
  
  PurchaseState purchase_state;
  
  ::base::TimeDelta purchase_time;
  
  bool will_auto_renew;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PurchaseDetails::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PurchaseDetails::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PurchaseDetails::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PurchaseDetails::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ItemDetailsPtr ItemDetails::Clone() const {
  return New(
      mojo::Clone(item_id),
      mojo::Clone(title),
      mojo::Clone(description),
      mojo::Clone(price),
      mojo::Clone(subscription_period),
      mojo::Clone(free_trial_period),
      mojo::Clone(introductory_price),
      mojo::Clone(introductory_price_period),
      mojo::Clone(introductory_price_cycles),
      mojo::Clone(type),
      mojo::Clone(icon_urls)
  );
}

template <typename T, ItemDetails::EnableIfSame<T>*>
bool ItemDetails::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->item_id, other_struct.item_id))
    return false;
  if (!mojo::Equals(this->title, other_struct.title))
    return false;
  if (!mojo::Equals(this->description, other_struct.description))
    return false;
  if (!mojo::Equals(this->price, other_struct.price))
    return false;
  if (!mojo::Equals(this->subscription_period, other_struct.subscription_period))
    return false;
  if (!mojo::Equals(this->free_trial_period, other_struct.free_trial_period))
    return false;
  if (!mojo::Equals(this->introductory_price, other_struct.introductory_price))
    return false;
  if (!mojo::Equals(this->introductory_price_period, other_struct.introductory_price_period))
    return false;
  if (!mojo::Equals(this->introductory_price_cycles, other_struct.introductory_price_cycles))
    return false;
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->icon_urls, other_struct.icon_urls))
    return false;
  return true;
}

template <typename T, ItemDetails::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.item_id < rhs.item_id)
    return true;
  if (rhs.item_id < lhs.item_id)
    return false;
  if (lhs.title < rhs.title)
    return true;
  if (rhs.title < lhs.title)
    return false;
  if (lhs.description < rhs.description)
    return true;
  if (rhs.description < lhs.description)
    return false;
  if (lhs.price < rhs.price)
    return true;
  if (rhs.price < lhs.price)
    return false;
  if (lhs.subscription_period < rhs.subscription_period)
    return true;
  if (rhs.subscription_period < lhs.subscription_period)
    return false;
  if (lhs.free_trial_period < rhs.free_trial_period)
    return true;
  if (rhs.free_trial_period < lhs.free_trial_period)
    return false;
  if (lhs.introductory_price < rhs.introductory_price)
    return true;
  if (rhs.introductory_price < lhs.introductory_price)
    return false;
  if (lhs.introductory_price_period < rhs.introductory_price_period)
    return true;
  if (rhs.introductory_price_period < lhs.introductory_price_period)
    return false;
  if (lhs.introductory_price_cycles < rhs.introductory_price_cycles)
    return true;
  if (rhs.introductory_price_cycles < lhs.introductory_price_cycles)
    return false;
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.icon_urls < rhs.icon_urls)
    return true;
  if (rhs.icon_urls < lhs.icon_urls)
    return false;
  return false;
}
template <typename StructPtrType>
PurchaseReferencePtr PurchaseReference::Clone() const {
  return New(
      mojo::Clone(item_id),
      mojo::Clone(purchase_token)
  );
}

template <typename T, PurchaseReference::EnableIfSame<T>*>
bool PurchaseReference::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->item_id, other_struct.item_id))
    return false;
  if (!mojo::Equals(this->purchase_token, other_struct.purchase_token))
    return false;
  return true;
}

template <typename T, PurchaseReference::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.item_id < rhs.item_id)
    return true;
  if (rhs.item_id < lhs.item_id)
    return false;
  if (lhs.purchase_token < rhs.purchase_token)
    return true;
  if (rhs.purchase_token < lhs.purchase_token)
    return false;
  return false;
}
template <typename StructPtrType>
PurchaseDetailsPtr PurchaseDetails::Clone() const {
  return New(
      mojo::Clone(item_id),
      mojo::Clone(purchase_token),
      mojo::Clone(acknowledged),
      mojo::Clone(purchase_state),
      mojo::Clone(purchase_time),
      mojo::Clone(will_auto_renew)
  );
}

template <typename T, PurchaseDetails::EnableIfSame<T>*>
bool PurchaseDetails::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->item_id, other_struct.item_id))
    return false;
  if (!mojo::Equals(this->purchase_token, other_struct.purchase_token))
    return false;
  if (!mojo::Equals(this->acknowledged, other_struct.acknowledged))
    return false;
  if (!mojo::Equals(this->purchase_state, other_struct.purchase_state))
    return false;
  if (!mojo::Equals(this->purchase_time, other_struct.purchase_time))
    return false;
  if (!mojo::Equals(this->will_auto_renew, other_struct.will_auto_renew))
    return false;
  return true;
}

template <typename T, PurchaseDetails::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.item_id < rhs.item_id)
    return true;
  if (rhs.item_id < lhs.item_id)
    return false;
  if (lhs.purchase_token < rhs.purchase_token)
    return true;
  if (rhs.purchase_token < lhs.purchase_token)
    return false;
  if (lhs.acknowledged < rhs.acknowledged)
    return true;
  if (rhs.acknowledged < lhs.acknowledged)
    return false;
  if (lhs.purchase_state < rhs.purchase_state)
    return true;
  if (rhs.purchase_state < lhs.purchase_state)
    return false;
  if (lhs.purchase_time < rhs.purchase_time)
    return true;
  if (rhs.purchase_time < lhs.purchase_time)
    return false;
  if (lhs.will_auto_renew < rhs.will_auto_renew)
    return true;
  if (rhs.will_auto_renew < lhs.will_auto_renew)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace payments

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::payments::mojom::ItemDetails::DataView,
                                         ::payments::mojom::ItemDetailsPtr> {
  static bool IsNull(const ::payments::mojom::ItemDetailsPtr& input) { return !input; }
  static void SetToNull(::payments::mojom::ItemDetailsPtr* output) { output->reset(); }

  static const decltype(::payments::mojom::ItemDetails::item_id)& item_id(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->item_id;
  }

  static const decltype(::payments::mojom::ItemDetails::title)& title(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->title;
  }

  static const decltype(::payments::mojom::ItemDetails::description)& description(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->description;
  }

  static const decltype(::payments::mojom::ItemDetails::price)& price(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->price;
  }

  static const decltype(::payments::mojom::ItemDetails::subscription_period)& subscription_period(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->subscription_period;
  }

  static const decltype(::payments::mojom::ItemDetails::free_trial_period)& free_trial_period(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->free_trial_period;
  }

  static const decltype(::payments::mojom::ItemDetails::introductory_price)& introductory_price(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->introductory_price;
  }

  static const decltype(::payments::mojom::ItemDetails::introductory_price_period)& introductory_price_period(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->introductory_price_period;
  }

  static decltype(::payments::mojom::ItemDetails::introductory_price_cycles) introductory_price_cycles(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->introductory_price_cycles;
  }

  static decltype(::payments::mojom::ItemDetails::type) type(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->type;
  }

  static const decltype(::payments::mojom::ItemDetails::icon_urls)& icon_urls(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->icon_urls;
  }

  static bool Read(::payments::mojom::ItemDetails::DataView input, ::payments::mojom::ItemDetailsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::payments::mojom::PurchaseReference::DataView,
                                         ::payments::mojom::PurchaseReferencePtr> {
  static bool IsNull(const ::payments::mojom::PurchaseReferencePtr& input) { return !input; }
  static void SetToNull(::payments::mojom::PurchaseReferencePtr* output) { output->reset(); }

  static const decltype(::payments::mojom::PurchaseReference::item_id)& item_id(
      const ::payments::mojom::PurchaseReferencePtr& input) {
    return input->item_id;
  }

  static const decltype(::payments::mojom::PurchaseReference::purchase_token)& purchase_token(
      const ::payments::mojom::PurchaseReferencePtr& input) {
    return input->purchase_token;
  }

  static bool Read(::payments::mojom::PurchaseReference::DataView input, ::payments::mojom::PurchaseReferencePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::payments::mojom::PurchaseDetails::DataView,
                                         ::payments::mojom::PurchaseDetailsPtr> {
  static bool IsNull(const ::payments::mojom::PurchaseDetailsPtr& input) { return !input; }
  static void SetToNull(::payments::mojom::PurchaseDetailsPtr* output) { output->reset(); }

  static const decltype(::payments::mojom::PurchaseDetails::item_id)& item_id(
      const ::payments::mojom::PurchaseDetailsPtr& input) {
    return input->item_id;
  }

  static const decltype(::payments::mojom::PurchaseDetails::purchase_token)& purchase_token(
      const ::payments::mojom::PurchaseDetailsPtr& input) {
    return input->purchase_token;
  }

  static decltype(::payments::mojom::PurchaseDetails::acknowledged) acknowledged(
      const ::payments::mojom::PurchaseDetailsPtr& input) {
    return input->acknowledged;
  }

  static decltype(::payments::mojom::PurchaseDetails::purchase_state) purchase_state(
      const ::payments::mojom::PurchaseDetailsPtr& input) {
    return input->purchase_state;
  }

  static const decltype(::payments::mojom::PurchaseDetails::purchase_time)& purchase_time(
      const ::payments::mojom::PurchaseDetailsPtr& input) {
    return input->purchase_time;
  }

  static decltype(::payments::mojom::PurchaseDetails::will_auto_renew) will_auto_renew(
      const ::payments::mojom::PurchaseDetailsPtr& input) {
    return input->will_auto_renew;
  }

  static bool Read(::payments::mojom::PurchaseDetails::DataView input, ::payments::mojom::PurchaseDetailsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIGITAL_GOODS_DIGITAL_GOODS_MOJOM_H_