// third_party/blink/public/mojom/interest_group/ad_auction_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-shared.h"
#include "third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-forward.h"
#include "third_party/blink/public/mojom/parakeet/ad_request.mojom-forward.h"
#include "third_party/blink/public/mojom/interest_group/interest_group_types.mojom.h"
#include "url/mojom/origin.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class AdAuctionServiceProxy;

template <typename ImplRefTraits>
class AdAuctionServiceStub;

class AdAuctionServiceRequestValidator;
class AdAuctionServiceResponseValidator;


class BLINK_COMMON_EXPORT AdAuctionService
    : public AdAuctionServiceInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AdAuctionServiceInterfaceBase;
  using Proxy_ = AdAuctionServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = AdAuctionServiceStub<ImplRefTraits>;

  using RequestValidator_ = AdAuctionServiceRequestValidator;
  using ResponseValidator_ = AdAuctionServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateAdRequestMinVersion = 0,
    kFinalizeAdMinVersion = 0,
    kRunAdAuctionMinVersion = 0,
    kJoinInterestGroupMinVersion = 0,
    kLeaveInterestGroupMinVersion = 0,
    kLeaveInterestGroupForDocumentMinVersion = 0,
    kUpdateAdInterestGroupsMinVersion = 0,
    kDeprecatedGetURLFromURNMinVersion = 0,
  };
  virtual ~AdAuctionService() = default;


  using CreateAdRequestCallback = base::OnceCallback<void(const absl::optional<std::string>&)>;
  
  virtual void CreateAdRequest(::blink::mojom::AdRequestConfigPtr config, CreateAdRequestCallback callback) = 0;


  using FinalizeAdCallback = base::OnceCallback<void(const absl::optional<::GURL>&)>;
  
  virtual void FinalizeAd(const std::string& ads_guid, ::blink::mojom::AuctionAdConfigPtr config, FinalizeAdCallback callback) = 0;


  using RunAdAuctionCallback = base::OnceCallback<void(const absl::optional<::GURL>&)>;
  
  virtual void RunAdAuction(::blink::mojom::AuctionAdConfigPtr config, RunAdAuctionCallback callback) = 0;

  
  virtual void JoinInterestGroup(const ::blink::InterestGroup& group) = 0;

  
  virtual void LeaveInterestGroup(const ::url::Origin& owner, const std::string& name) = 0;

  
  virtual void LeaveInterestGroupForDocument() = 0;

  
  virtual void UpdateAdInterestGroups() = 0;


  using DeprecatedGetURLFromURNCallback = base::OnceCallback<void(const absl::optional<::GURL>&)>;
  
  virtual void DeprecatedGetURLFromURN(const ::GURL& uuid_url, DeprecatedGetURLFromURNCallback callback) = 0;
};



class BLINK_COMMON_EXPORT AdAuctionServiceProxy
    : public AdAuctionService {
 public:
  using InterfaceType = AdAuctionService;

  explicit AdAuctionServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateAdRequest(::blink::mojom::AdRequestConfigPtr config, CreateAdRequestCallback callback) final;
  
  void FinalizeAd(const std::string& ads_guid, ::blink::mojom::AuctionAdConfigPtr config, FinalizeAdCallback callback) final;
  
  void RunAdAuction(::blink::mojom::AuctionAdConfigPtr config, RunAdAuctionCallback callback) final;
  
  void JoinInterestGroup(const ::blink::InterestGroup& group) final;
  
  void LeaveInterestGroup(const ::url::Origin& owner, const std::string& name) final;
  
  void LeaveInterestGroupForDocument() final;
  
  void UpdateAdInterestGroups() final;
  
  void DeprecatedGetURLFromURN(const ::GURL& uuid_url, DeprecatedGetURLFromURNCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT AdAuctionServiceStubDispatch {
 public:
  static bool Accept(AdAuctionService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AdAuctionService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AdAuctionService>>
class AdAuctionServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AdAuctionServiceStub() = default;
  ~AdAuctionServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AdAuctionServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AdAuctionServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT AdAuctionServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT AdAuctionServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_