// third_party/blink/public/mojom/shared_storage/shared_storage.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_STORAGE_SHARED_STORAGE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_STORAGE_SHARED_STORAGE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/shared_storage/shared_storage.mojom-shared.h"
#include "third_party/blink/public/mojom/shared_storage/shared_storage.mojom-forward.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/shared_storage/shared_storage_mojom_traits.h"
#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class SharedStorageDocumentServiceProxy;

template <typename ImplRefTraits>
class SharedStorageDocumentServiceStub;

class SharedStorageDocumentServiceRequestValidator;
class SharedStorageDocumentServiceResponseValidator;


class BLINK_COMMON_EXPORT SharedStorageDocumentService
    : public SharedStorageDocumentServiceInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = SharedStorageDocumentServiceInterfaceBase;
  using Proxy_ = SharedStorageDocumentServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = SharedStorageDocumentServiceStub<ImplRefTraits>;

  using RequestValidator_ = SharedStorageDocumentServiceRequestValidator;
  using ResponseValidator_ = SharedStorageDocumentServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kAddModuleOnWorkletMinVersion = 0,
    kRunOperationOnWorkletMinVersion = 0,
    kRunURLSelectionOperationOnWorkletMinVersion = 0,
    kSharedStorageSetMinVersion = 0,
    kSharedStorageAppendMinVersion = 0,
    kSharedStorageDeleteMinVersion = 0,
    kSharedStorageClearMinVersion = 0,
  };
  virtual ~SharedStorageDocumentService() = default;


  using AddModuleOnWorkletCallback = base::OnceCallback<void(bool, const std::string&)>;
  
  virtual void AddModuleOnWorklet(const ::GURL& script_source_url, AddModuleOnWorkletCallback callback) = 0;

  
  virtual void RunOperationOnWorklet(const std::string& name, const std::vector<uint8_t>& serialized_data) = 0;


  using RunURLSelectionOperationOnWorkletCallback = base::OnceCallback<void(bool, const std::string&, const ::GURL&)>;
  
  virtual void RunURLSelectionOperationOnWorklet(const std::string& name, const std::vector<::GURL>& urls, const std::vector<uint8_t>& serialized_data, RunURLSelectionOperationOnWorkletCallback callback) = 0;

  
  virtual void SharedStorageSet(const ::std::u16string& key, const ::std::u16string& value, bool ignore_if_present) = 0;

  
  virtual void SharedStorageAppend(const ::std::u16string& key, const ::std::u16string& value) = 0;

  
  virtual void SharedStorageDelete(const ::std::u16string& key) = 0;

  
  virtual void SharedStorageClear() = 0;
};



class BLINK_COMMON_EXPORT SharedStorageDocumentServiceProxy
    : public SharedStorageDocumentService {
 public:
  using InterfaceType = SharedStorageDocumentService;

  explicit SharedStorageDocumentServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void AddModuleOnWorklet(const ::GURL& script_source_url, AddModuleOnWorkletCallback callback) final;
  
  void RunOperationOnWorklet(const std::string& name, const std::vector<uint8_t>& serialized_data) final;
  
  void RunURLSelectionOperationOnWorklet(const std::string& name, const std::vector<::GURL>& urls, const std::vector<uint8_t>& serialized_data, RunURLSelectionOperationOnWorkletCallback callback) final;
  
  void SharedStorageSet(const ::std::u16string& key, const ::std::u16string& value, bool ignore_if_present) final;
  
  void SharedStorageAppend(const ::std::u16string& key, const ::std::u16string& value) final;
  
  void SharedStorageDelete(const ::std::u16string& key) final;
  
  void SharedStorageClear() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT SharedStorageDocumentServiceStubDispatch {
 public:
  static bool Accept(SharedStorageDocumentService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SharedStorageDocumentService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SharedStorageDocumentService>>
class SharedStorageDocumentServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SharedStorageDocumentServiceStub() = default;
  ~SharedStorageDocumentServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharedStorageDocumentServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharedStorageDocumentServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT SharedStorageDocumentServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT SharedStorageDocumentServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};









class BLINK_COMMON_EXPORT SharedStorageKeyArgument {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SharedStorageKeyArgument, T>::value>;
  using DataView = SharedStorageKeyArgumentDataView;
  using Data_ = internal::SharedStorageKeyArgument_Data;

  template <typename... Args>
  static SharedStorageKeyArgumentPtr New(Args&&... args) {
    return SharedStorageKeyArgumentPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SharedStorageKeyArgumentPtr From(const U& u) {
    return mojo::TypeConverter<SharedStorageKeyArgumentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SharedStorageKeyArgument>::Convert(*this);
  }


  SharedStorageKeyArgument();

  explicit SharedStorageKeyArgument(
      const ::std::u16string& data);


  ~SharedStorageKeyArgument();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SharedStorageKeyArgumentPtr>
  SharedStorageKeyArgumentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SharedStorageKeyArgument::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SharedStorageKeyArgument::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SharedStorageKeyArgument::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SharedStorageKeyArgument::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SharedStorageKeyArgument_UnserializedMessageContext<
            UserType, SharedStorageKeyArgument::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SharedStorageKeyArgument::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SharedStorageKeyArgument::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SharedStorageKeyArgument_UnserializedMessageContext<
            UserType, SharedStorageKeyArgument::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SharedStorageKeyArgument::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::std::u16string data;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SharedStorageKeyArgument::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SharedStorageKeyArgument::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SharedStorageKeyArgument::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SharedStorageKeyArgument::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT SharedStorageValueArgument {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SharedStorageValueArgument, T>::value>;
  using DataView = SharedStorageValueArgumentDataView;
  using Data_ = internal::SharedStorageValueArgument_Data;

  template <typename... Args>
  static SharedStorageValueArgumentPtr New(Args&&... args) {
    return SharedStorageValueArgumentPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SharedStorageValueArgumentPtr From(const U& u) {
    return mojo::TypeConverter<SharedStorageValueArgumentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SharedStorageValueArgument>::Convert(*this);
  }


  SharedStorageValueArgument();

  explicit SharedStorageValueArgument(
      const ::std::u16string& data);


  ~SharedStorageValueArgument();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SharedStorageValueArgumentPtr>
  SharedStorageValueArgumentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SharedStorageValueArgument::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SharedStorageValueArgument::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SharedStorageValueArgument::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SharedStorageValueArgument::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SharedStorageValueArgument_UnserializedMessageContext<
            UserType, SharedStorageValueArgument::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SharedStorageValueArgument::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SharedStorageValueArgument::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SharedStorageValueArgument_UnserializedMessageContext<
            UserType, SharedStorageValueArgument::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SharedStorageValueArgument::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::std::u16string data;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SharedStorageValueArgument::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SharedStorageValueArgument::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SharedStorageValueArgument::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SharedStorageValueArgument::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
SharedStorageKeyArgumentPtr SharedStorageKeyArgument::Clone() const {
  return New(
      mojo::Clone(data)
  );
}

template <typename T, SharedStorageKeyArgument::EnableIfSame<T>*>
bool SharedStorageKeyArgument::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->data, other_struct.data))
    return false;
  return true;
}

template <typename T, SharedStorageKeyArgument::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.data < rhs.data)
    return true;
  if (rhs.data < lhs.data)
    return false;
  return false;
}
template <typename StructPtrType>
SharedStorageValueArgumentPtr SharedStorageValueArgument::Clone() const {
  return New(
      mojo::Clone(data)
  );
}

template <typename T, SharedStorageValueArgument::EnableIfSame<T>*>
bool SharedStorageValueArgument::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->data, other_struct.data))
    return false;
  return true;
}

template <typename T, SharedStorageValueArgument::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.data < rhs.data)
    return true;
  if (rhs.data < lhs.data)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::SharedStorageKeyArgument::DataView,
                                         ::blink::mojom::SharedStorageKeyArgumentPtr> {
  static bool IsNull(const ::blink::mojom::SharedStorageKeyArgumentPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::SharedStorageKeyArgumentPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::SharedStorageKeyArgument::data)& data(
      const ::blink::mojom::SharedStorageKeyArgumentPtr& input) {
    return input->data;
  }

  static bool Read(::blink::mojom::SharedStorageKeyArgument::DataView input, ::blink::mojom::SharedStorageKeyArgumentPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::SharedStorageValueArgument::DataView,
                                         ::blink::mojom::SharedStorageValueArgumentPtr> {
  static bool IsNull(const ::blink::mojom::SharedStorageValueArgumentPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::SharedStorageValueArgumentPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::SharedStorageValueArgument::data)& data(
      const ::blink::mojom::SharedStorageValueArgumentPtr& input) {
    return input->data;
  }

  static bool Read(::blink::mojom::SharedStorageValueArgument::DataView input, ::blink::mojom::SharedStorageValueArgumentPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_STORAGE_SHARED_STORAGE_MOJOM_H_