// third_party/blink/public/mojom/webid/federated_auth_request.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/webid/federated_auth_request.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/webid/federated_auth_request.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* RequestIdTokenStatusToStringHelper(RequestIdTokenStatus value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case RequestIdTokenStatus::kSuccess:
      return "kSuccess";
    case RequestIdTokenStatus::kApprovalDeclined:
      return "kApprovalDeclined";
    case RequestIdTokenStatus::kErrorTooManyRequests:
      return "kErrorTooManyRequests";
    case RequestIdTokenStatus::kErrorCanceled:
      return "kErrorCanceled";
    case RequestIdTokenStatus::kError:
      return "kError";
    default:
      return nullptr;
  }
}

std::string RequestIdTokenStatusToString(RequestIdTokenStatus value) {
  const char *str = RequestIdTokenStatusToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown RequestIdTokenStatus value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, RequestIdTokenStatus value) {
  return os << RequestIdTokenStatusToString(value);
}

static NOINLINE const char* LogoutRpsStatusToStringHelper(LogoutRpsStatus value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case LogoutRpsStatus::kSuccess:
      return "kSuccess";
    case LogoutRpsStatus::kErrorTooManyRequests:
      return "kErrorTooManyRequests";
    case LogoutRpsStatus::kError:
      return "kError";
    default:
      return nullptr;
  }
}

std::string LogoutRpsStatusToString(LogoutRpsStatus value) {
  const char *str = LogoutRpsStatusToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown LogoutRpsStatus value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, LogoutRpsStatus value) {
  return os << LogoutRpsStatusToString(value);
}

static NOINLINE const char* RevokeStatusToStringHelper(RevokeStatus value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case RevokeStatus::kSuccess:
      return "kSuccess";
    case RevokeStatus::kError:
      return "kError";
    default:
      return nullptr;
  }
}

std::string RevokeStatusToString(RevokeStatus value) {
  const char *str = RevokeStatusToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown RevokeStatus value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, RevokeStatus value) {
  return os << RevokeStatusToString(value);
}

static NOINLINE const char* LogoutStatusToStringHelper(LogoutStatus value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case LogoutStatus::kSuccess:
      return "kSuccess";
    case LogoutStatus::kNotLoggedIn:
      return "kNotLoggedIn";
    default:
      return nullptr;
  }
}

std::string LogoutStatusToString(LogoutStatus value) {
  const char *str = LogoutStatusToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown LogoutStatus value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, LogoutStatus value) {
  return os << LogoutStatusToString(value);
}

namespace internal {


// static
bool LogoutRpsRequest_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const LogoutRpsRequest_Data* object =
      static_cast<const LogoutRpsRequest_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->account_id, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams account_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->account_id, validation_context,
                                         &account_id_validate_params)) {
    return false;
  }

  return true;
}

LogoutRpsRequest_Data::LogoutRpsRequest_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_RequestIdToken_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_RequestIdToken_Params_Data* object =
      static_cast<const FederatedAuthRequest_RequestIdToken_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->provider, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->provider, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->client_id, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams client_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->client_id, validation_context,
                                         &client_id_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->nonce, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams nonce_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->nonce, validation_context,
                                         &nonce_validate_params)) {
    return false;
  }

  return true;
}

FederatedAuthRequest_RequestIdToken_Params_Data::FederatedAuthRequest_RequestIdToken_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_RequestIdToken_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_RequestIdToken_ResponseParams_Data* object =
      static_cast<const FederatedAuthRequest_RequestIdToken_ResponseParams_Data*>(data);


  if (!::blink::mojom::internal::RequestIdTokenStatus_Data
        ::Validate(object->status, validation_context))
    return false;

  const mojo::internal::ContainerValidateParams id_token_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->id_token, validation_context,
                                         &id_token_validate_params)) {
    return false;
  }

  return true;
}

FederatedAuthRequest_RequestIdToken_ResponseParams_Data::FederatedAuthRequest_RequestIdToken_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_CancelTokenRequest_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_CancelTokenRequest_Params_Data* object =
      static_cast<const FederatedAuthRequest_CancelTokenRequest_Params_Data*>(data);

  return true;
}

FederatedAuthRequest_CancelTokenRequest_Params_Data::FederatedAuthRequest_CancelTokenRequest_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_Revoke_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_Revoke_Params_Data* object =
      static_cast<const FederatedAuthRequest_Revoke_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->provider, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->provider, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->client_id, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams client_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->client_id, validation_context,
                                         &client_id_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->account_id, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams account_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->account_id, validation_context,
                                         &account_id_validate_params)) {
    return false;
  }

  return true;
}

FederatedAuthRequest_Revoke_Params_Data::FederatedAuthRequest_Revoke_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_Revoke_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_Revoke_ResponseParams_Data* object =
      static_cast<const FederatedAuthRequest_Revoke_ResponseParams_Data*>(data);


  if (!::blink::mojom::internal::RevokeStatus_Data
        ::Validate(object->status, validation_context))
    return false;

  return true;
}

FederatedAuthRequest_Revoke_ResponseParams_Data::FederatedAuthRequest_Revoke_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_Logout_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_Logout_Params_Data* object =
      static_cast<const FederatedAuthRequest_Logout_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->provider, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->provider, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->account_id, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams account_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->account_id, validation_context,
                                         &account_id_validate_params)) {
    return false;
  }

  return true;
}

FederatedAuthRequest_Logout_Params_Data::FederatedAuthRequest_Logout_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_Logout_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_Logout_ResponseParams_Data* object =
      static_cast<const FederatedAuthRequest_Logout_ResponseParams_Data*>(data);


  if (!::blink::mojom::internal::LogoutStatus_Data
        ::Validate(object->status, validation_context))
    return false;

  return true;
}

FederatedAuthRequest_Logout_ResponseParams_Data::FederatedAuthRequest_Logout_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_LogoutRps_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_LogoutRps_Params_Data* object =
      static_cast<const FederatedAuthRequest_LogoutRps_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->rp_logout_requests, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams rp_logout_requests_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->rp_logout_requests, validation_context,
                                         &rp_logout_requests_validate_params)) {
    return false;
  }

  return true;
}

FederatedAuthRequest_LogoutRps_Params_Data::FederatedAuthRequest_LogoutRps_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FederatedAuthRequest_LogoutRps_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FederatedAuthRequest_LogoutRps_ResponseParams_Data* object =
      static_cast<const FederatedAuthRequest_LogoutRps_ResponseParams_Data*>(data);


  if (!::blink::mojom::internal::LogoutRpsStatus_Data
        ::Validate(object->status, validation_context))
    return false;

  return true;
}

FederatedAuthRequest_LogoutRps_ResponseParams_Data::FederatedAuthRequest_LogoutRps_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::RequestIdTokenStatus>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::RequestIdTokenStatus value) {
  return std::move(context).WriteString(::blink::mojom::RequestIdTokenStatusToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::LogoutRpsStatus>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::LogoutRpsStatus value) {
  return std::move(context).WriteString(::blink::mojom::LogoutRpsStatusToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::RevokeStatus>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::RevokeStatus value) {
  return std::move(context).WriteString(::blink::mojom::RevokeStatusToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::LogoutStatus>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::LogoutStatus value) {
  return std::move(context).WriteString(::blink::mojom::LogoutStatusToString(value));
}

} // namespace perfetto