
#ifndef DAWNNATIVE_DAWN_PLATFORM_AUTOGEN_H_
#define DAWNNATIVE_DAWN_PLATFORM_AUTOGEN_H_

#include "dawn/webgpu_cpp.h"
#include "dawn/native/Forward.h"

// Use our autogenerated version of the wgpu structures that point to dawn::native object types
// (wgpu::Buffer is dawn::native::BufferBase*)
#include <dawn/native/wgpu_structs_autogen.h>

namespace dawn::native {

    inline const WGPUAdapterProperties* ToAPI(const AdapterProperties* rhs) {
        return reinterpret_cast<const WGPUAdapterProperties*>(rhs);
    }

    inline WGPUAdapterProperties* ToAPI(AdapterProperties* rhs) {
        return reinterpret_cast<WGPUAdapterProperties*>(rhs);
    }

    inline const AdapterProperties* FromAPI(const WGPUAdapterProperties* rhs) {
        return reinterpret_cast<const AdapterProperties*>(rhs);
    }

    inline AdapterProperties* FromAPI(WGPUAdapterProperties* rhs) {
        return reinterpret_cast<AdapterProperties*>(rhs);
    }
    inline const WGPUBindGroupEntry* ToAPI(const BindGroupEntry* rhs) {
        return reinterpret_cast<const WGPUBindGroupEntry*>(rhs);
    }

    inline WGPUBindGroupEntry* ToAPI(BindGroupEntry* rhs) {
        return reinterpret_cast<WGPUBindGroupEntry*>(rhs);
    }

    inline const BindGroupEntry* FromAPI(const WGPUBindGroupEntry* rhs) {
        return reinterpret_cast<const BindGroupEntry*>(rhs);
    }

    inline BindGroupEntry* FromAPI(WGPUBindGroupEntry* rhs) {
        return reinterpret_cast<BindGroupEntry*>(rhs);
    }
    inline const WGPUBlendComponent* ToAPI(const BlendComponent* rhs) {
        return reinterpret_cast<const WGPUBlendComponent*>(rhs);
    }

    inline WGPUBlendComponent* ToAPI(BlendComponent* rhs) {
        return reinterpret_cast<WGPUBlendComponent*>(rhs);
    }

    inline const BlendComponent* FromAPI(const WGPUBlendComponent* rhs) {
        return reinterpret_cast<const BlendComponent*>(rhs);
    }

    inline BlendComponent* FromAPI(WGPUBlendComponent* rhs) {
        return reinterpret_cast<BlendComponent*>(rhs);
    }
    inline const WGPUBufferBindingLayout* ToAPI(const BufferBindingLayout* rhs) {
        return reinterpret_cast<const WGPUBufferBindingLayout*>(rhs);
    }

    inline WGPUBufferBindingLayout* ToAPI(BufferBindingLayout* rhs) {
        return reinterpret_cast<WGPUBufferBindingLayout*>(rhs);
    }

    inline const BufferBindingLayout* FromAPI(const WGPUBufferBindingLayout* rhs) {
        return reinterpret_cast<const BufferBindingLayout*>(rhs);
    }

    inline BufferBindingLayout* FromAPI(WGPUBufferBindingLayout* rhs) {
        return reinterpret_cast<BufferBindingLayout*>(rhs);
    }
    inline const WGPUBufferDescriptor* ToAPI(const BufferDescriptor* rhs) {
        return reinterpret_cast<const WGPUBufferDescriptor*>(rhs);
    }

    inline WGPUBufferDescriptor* ToAPI(BufferDescriptor* rhs) {
        return reinterpret_cast<WGPUBufferDescriptor*>(rhs);
    }

    inline const BufferDescriptor* FromAPI(const WGPUBufferDescriptor* rhs) {
        return reinterpret_cast<const BufferDescriptor*>(rhs);
    }

    inline BufferDescriptor* FromAPI(WGPUBufferDescriptor* rhs) {
        return reinterpret_cast<BufferDescriptor*>(rhs);
    }
    inline const WGPUColor* ToAPI(const Color* rhs) {
        return reinterpret_cast<const WGPUColor*>(rhs);
    }

    inline WGPUColor* ToAPI(Color* rhs) {
        return reinterpret_cast<WGPUColor*>(rhs);
    }

    inline const Color* FromAPI(const WGPUColor* rhs) {
        return reinterpret_cast<const Color*>(rhs);
    }

    inline Color* FromAPI(WGPUColor* rhs) {
        return reinterpret_cast<Color*>(rhs);
    }
    inline const WGPUCommandBufferDescriptor* ToAPI(const CommandBufferDescriptor* rhs) {
        return reinterpret_cast<const WGPUCommandBufferDescriptor*>(rhs);
    }

    inline WGPUCommandBufferDescriptor* ToAPI(CommandBufferDescriptor* rhs) {
        return reinterpret_cast<WGPUCommandBufferDescriptor*>(rhs);
    }

    inline const CommandBufferDescriptor* FromAPI(const WGPUCommandBufferDescriptor* rhs) {
        return reinterpret_cast<const CommandBufferDescriptor*>(rhs);
    }

    inline CommandBufferDescriptor* FromAPI(WGPUCommandBufferDescriptor* rhs) {
        return reinterpret_cast<CommandBufferDescriptor*>(rhs);
    }
    inline const WGPUCommandEncoderDescriptor* ToAPI(const CommandEncoderDescriptor* rhs) {
        return reinterpret_cast<const WGPUCommandEncoderDescriptor*>(rhs);
    }

    inline WGPUCommandEncoderDescriptor* ToAPI(CommandEncoderDescriptor* rhs) {
        return reinterpret_cast<WGPUCommandEncoderDescriptor*>(rhs);
    }

    inline const CommandEncoderDescriptor* FromAPI(const WGPUCommandEncoderDescriptor* rhs) {
        return reinterpret_cast<const CommandEncoderDescriptor*>(rhs);
    }

    inline CommandEncoderDescriptor* FromAPI(WGPUCommandEncoderDescriptor* rhs) {
        return reinterpret_cast<CommandEncoderDescriptor*>(rhs);
    }
    inline const WGPUCompilationMessage* ToAPI(const CompilationMessage* rhs) {
        return reinterpret_cast<const WGPUCompilationMessage*>(rhs);
    }

    inline WGPUCompilationMessage* ToAPI(CompilationMessage* rhs) {
        return reinterpret_cast<WGPUCompilationMessage*>(rhs);
    }

    inline const CompilationMessage* FromAPI(const WGPUCompilationMessage* rhs) {
        return reinterpret_cast<const CompilationMessage*>(rhs);
    }

    inline CompilationMessage* FromAPI(WGPUCompilationMessage* rhs) {
        return reinterpret_cast<CompilationMessage*>(rhs);
    }
    inline const WGPUComputePassTimestampWrite* ToAPI(const ComputePassTimestampWrite* rhs) {
        return reinterpret_cast<const WGPUComputePassTimestampWrite*>(rhs);
    }

    inline WGPUComputePassTimestampWrite* ToAPI(ComputePassTimestampWrite* rhs) {
        return reinterpret_cast<WGPUComputePassTimestampWrite*>(rhs);
    }

    inline const ComputePassTimestampWrite* FromAPI(const WGPUComputePassTimestampWrite* rhs) {
        return reinterpret_cast<const ComputePassTimestampWrite*>(rhs);
    }

    inline ComputePassTimestampWrite* FromAPI(WGPUComputePassTimestampWrite* rhs) {
        return reinterpret_cast<ComputePassTimestampWrite*>(rhs);
    }
    inline const WGPUConstantEntry* ToAPI(const ConstantEntry* rhs) {
        return reinterpret_cast<const WGPUConstantEntry*>(rhs);
    }

    inline WGPUConstantEntry* ToAPI(ConstantEntry* rhs) {
        return reinterpret_cast<WGPUConstantEntry*>(rhs);
    }

    inline const ConstantEntry* FromAPI(const WGPUConstantEntry* rhs) {
        return reinterpret_cast<const ConstantEntry*>(rhs);
    }

    inline ConstantEntry* FromAPI(WGPUConstantEntry* rhs) {
        return reinterpret_cast<ConstantEntry*>(rhs);
    }
    inline const WGPUCopyTextureForBrowserOptions* ToAPI(const CopyTextureForBrowserOptions* rhs) {
        return reinterpret_cast<const WGPUCopyTextureForBrowserOptions*>(rhs);
    }

    inline WGPUCopyTextureForBrowserOptions* ToAPI(CopyTextureForBrowserOptions* rhs) {
        return reinterpret_cast<WGPUCopyTextureForBrowserOptions*>(rhs);
    }

    inline const CopyTextureForBrowserOptions* FromAPI(const WGPUCopyTextureForBrowserOptions* rhs) {
        return reinterpret_cast<const CopyTextureForBrowserOptions*>(rhs);
    }

    inline CopyTextureForBrowserOptions* FromAPI(WGPUCopyTextureForBrowserOptions* rhs) {
        return reinterpret_cast<CopyTextureForBrowserOptions*>(rhs);
    }
    inline const WGPUDawnCacheDeviceDescriptor* ToAPI(const DawnCacheDeviceDescriptor* rhs) {
        return reinterpret_cast<const WGPUDawnCacheDeviceDescriptor*>(rhs);
    }

    inline WGPUDawnCacheDeviceDescriptor* ToAPI(DawnCacheDeviceDescriptor* rhs) {
        return reinterpret_cast<WGPUDawnCacheDeviceDescriptor*>(rhs);
    }

    inline const DawnCacheDeviceDescriptor* FromAPI(const WGPUDawnCacheDeviceDescriptor* rhs) {
        return reinterpret_cast<const DawnCacheDeviceDescriptor*>(rhs);
    }

    inline DawnCacheDeviceDescriptor* FromAPI(WGPUDawnCacheDeviceDescriptor* rhs) {
        return reinterpret_cast<DawnCacheDeviceDescriptor*>(rhs);
    }
    inline const WGPUDawnEncoderInternalUsageDescriptor* ToAPI(const DawnEncoderInternalUsageDescriptor* rhs) {
        return reinterpret_cast<const WGPUDawnEncoderInternalUsageDescriptor*>(rhs);
    }

    inline WGPUDawnEncoderInternalUsageDescriptor* ToAPI(DawnEncoderInternalUsageDescriptor* rhs) {
        return reinterpret_cast<WGPUDawnEncoderInternalUsageDescriptor*>(rhs);
    }

    inline const DawnEncoderInternalUsageDescriptor* FromAPI(const WGPUDawnEncoderInternalUsageDescriptor* rhs) {
        return reinterpret_cast<const DawnEncoderInternalUsageDescriptor*>(rhs);
    }

    inline DawnEncoderInternalUsageDescriptor* FromAPI(WGPUDawnEncoderInternalUsageDescriptor* rhs) {
        return reinterpret_cast<DawnEncoderInternalUsageDescriptor*>(rhs);
    }
    inline const WGPUDawnInstanceDescriptor* ToAPI(const DawnInstanceDescriptor* rhs) {
        return reinterpret_cast<const WGPUDawnInstanceDescriptor*>(rhs);
    }

    inline WGPUDawnInstanceDescriptor* ToAPI(DawnInstanceDescriptor* rhs) {
        return reinterpret_cast<WGPUDawnInstanceDescriptor*>(rhs);
    }

    inline const DawnInstanceDescriptor* FromAPI(const WGPUDawnInstanceDescriptor* rhs) {
        return reinterpret_cast<const DawnInstanceDescriptor*>(rhs);
    }

    inline DawnInstanceDescriptor* FromAPI(WGPUDawnInstanceDescriptor* rhs) {
        return reinterpret_cast<DawnInstanceDescriptor*>(rhs);
    }
    inline const WGPUDawnTextureInternalUsageDescriptor* ToAPI(const DawnTextureInternalUsageDescriptor* rhs) {
        return reinterpret_cast<const WGPUDawnTextureInternalUsageDescriptor*>(rhs);
    }

    inline WGPUDawnTextureInternalUsageDescriptor* ToAPI(DawnTextureInternalUsageDescriptor* rhs) {
        return reinterpret_cast<WGPUDawnTextureInternalUsageDescriptor*>(rhs);
    }

    inline const DawnTextureInternalUsageDescriptor* FromAPI(const WGPUDawnTextureInternalUsageDescriptor* rhs) {
        return reinterpret_cast<const DawnTextureInternalUsageDescriptor*>(rhs);
    }

    inline DawnTextureInternalUsageDescriptor* FromAPI(WGPUDawnTextureInternalUsageDescriptor* rhs) {
        return reinterpret_cast<DawnTextureInternalUsageDescriptor*>(rhs);
    }
    inline const WGPUDawnTogglesDeviceDescriptor* ToAPI(const DawnTogglesDeviceDescriptor* rhs) {
        return reinterpret_cast<const WGPUDawnTogglesDeviceDescriptor*>(rhs);
    }

    inline WGPUDawnTogglesDeviceDescriptor* ToAPI(DawnTogglesDeviceDescriptor* rhs) {
        return reinterpret_cast<WGPUDawnTogglesDeviceDescriptor*>(rhs);
    }

    inline const DawnTogglesDeviceDescriptor* FromAPI(const WGPUDawnTogglesDeviceDescriptor* rhs) {
        return reinterpret_cast<const DawnTogglesDeviceDescriptor*>(rhs);
    }

    inline DawnTogglesDeviceDescriptor* FromAPI(WGPUDawnTogglesDeviceDescriptor* rhs) {
        return reinterpret_cast<DawnTogglesDeviceDescriptor*>(rhs);
    }
    inline const WGPUExtent3D* ToAPI(const Extent3D* rhs) {
        return reinterpret_cast<const WGPUExtent3D*>(rhs);
    }

    inline WGPUExtent3D* ToAPI(Extent3D* rhs) {
        return reinterpret_cast<WGPUExtent3D*>(rhs);
    }

    inline const Extent3D* FromAPI(const WGPUExtent3D* rhs) {
        return reinterpret_cast<const Extent3D*>(rhs);
    }

    inline Extent3D* FromAPI(WGPUExtent3D* rhs) {
        return reinterpret_cast<Extent3D*>(rhs);
    }
    inline const WGPUExternalTextureBindingEntry* ToAPI(const ExternalTextureBindingEntry* rhs) {
        return reinterpret_cast<const WGPUExternalTextureBindingEntry*>(rhs);
    }

    inline WGPUExternalTextureBindingEntry* ToAPI(ExternalTextureBindingEntry* rhs) {
        return reinterpret_cast<WGPUExternalTextureBindingEntry*>(rhs);
    }

    inline const ExternalTextureBindingEntry* FromAPI(const WGPUExternalTextureBindingEntry* rhs) {
        return reinterpret_cast<const ExternalTextureBindingEntry*>(rhs);
    }

    inline ExternalTextureBindingEntry* FromAPI(WGPUExternalTextureBindingEntry* rhs) {
        return reinterpret_cast<ExternalTextureBindingEntry*>(rhs);
    }
    inline const WGPUExternalTextureBindingLayout* ToAPI(const ExternalTextureBindingLayout* rhs) {
        return reinterpret_cast<const WGPUExternalTextureBindingLayout*>(rhs);
    }

    inline WGPUExternalTextureBindingLayout* ToAPI(ExternalTextureBindingLayout* rhs) {
        return reinterpret_cast<WGPUExternalTextureBindingLayout*>(rhs);
    }

    inline const ExternalTextureBindingLayout* FromAPI(const WGPUExternalTextureBindingLayout* rhs) {
        return reinterpret_cast<const ExternalTextureBindingLayout*>(rhs);
    }

    inline ExternalTextureBindingLayout* FromAPI(WGPUExternalTextureBindingLayout* rhs) {
        return reinterpret_cast<ExternalTextureBindingLayout*>(rhs);
    }
    inline const WGPUExternalTextureDescriptor* ToAPI(const ExternalTextureDescriptor* rhs) {
        return reinterpret_cast<const WGPUExternalTextureDescriptor*>(rhs);
    }

    inline WGPUExternalTextureDescriptor* ToAPI(ExternalTextureDescriptor* rhs) {
        return reinterpret_cast<WGPUExternalTextureDescriptor*>(rhs);
    }

    inline const ExternalTextureDescriptor* FromAPI(const WGPUExternalTextureDescriptor* rhs) {
        return reinterpret_cast<const ExternalTextureDescriptor*>(rhs);
    }

    inline ExternalTextureDescriptor* FromAPI(WGPUExternalTextureDescriptor* rhs) {
        return reinterpret_cast<ExternalTextureDescriptor*>(rhs);
    }
    inline const WGPUInstanceDescriptor* ToAPI(const InstanceDescriptor* rhs) {
        return reinterpret_cast<const WGPUInstanceDescriptor*>(rhs);
    }

    inline WGPUInstanceDescriptor* ToAPI(InstanceDescriptor* rhs) {
        return reinterpret_cast<WGPUInstanceDescriptor*>(rhs);
    }

    inline const InstanceDescriptor* FromAPI(const WGPUInstanceDescriptor* rhs) {
        return reinterpret_cast<const InstanceDescriptor*>(rhs);
    }

    inline InstanceDescriptor* FromAPI(WGPUInstanceDescriptor* rhs) {
        return reinterpret_cast<InstanceDescriptor*>(rhs);
    }
    inline const WGPULimits* ToAPI(const Limits* rhs) {
        return reinterpret_cast<const WGPULimits*>(rhs);
    }

    inline WGPULimits* ToAPI(Limits* rhs) {
        return reinterpret_cast<WGPULimits*>(rhs);
    }

    inline const Limits* FromAPI(const WGPULimits* rhs) {
        return reinterpret_cast<const Limits*>(rhs);
    }

    inline Limits* FromAPI(WGPULimits* rhs) {
        return reinterpret_cast<Limits*>(rhs);
    }
    inline const WGPUMultisampleState* ToAPI(const MultisampleState* rhs) {
        return reinterpret_cast<const WGPUMultisampleState*>(rhs);
    }

    inline WGPUMultisampleState* ToAPI(MultisampleState* rhs) {
        return reinterpret_cast<WGPUMultisampleState*>(rhs);
    }

    inline const MultisampleState* FromAPI(const WGPUMultisampleState* rhs) {
        return reinterpret_cast<const MultisampleState*>(rhs);
    }

    inline MultisampleState* FromAPI(WGPUMultisampleState* rhs) {
        return reinterpret_cast<MultisampleState*>(rhs);
    }
    inline const WGPUOrigin3D* ToAPI(const Origin3D* rhs) {
        return reinterpret_cast<const WGPUOrigin3D*>(rhs);
    }

    inline WGPUOrigin3D* ToAPI(Origin3D* rhs) {
        return reinterpret_cast<WGPUOrigin3D*>(rhs);
    }

    inline const Origin3D* FromAPI(const WGPUOrigin3D* rhs) {
        return reinterpret_cast<const Origin3D*>(rhs);
    }

    inline Origin3D* FromAPI(WGPUOrigin3D* rhs) {
        return reinterpret_cast<Origin3D*>(rhs);
    }
    inline const WGPUPipelineLayoutDescriptor* ToAPI(const PipelineLayoutDescriptor* rhs) {
        return reinterpret_cast<const WGPUPipelineLayoutDescriptor*>(rhs);
    }

    inline WGPUPipelineLayoutDescriptor* ToAPI(PipelineLayoutDescriptor* rhs) {
        return reinterpret_cast<WGPUPipelineLayoutDescriptor*>(rhs);
    }

    inline const PipelineLayoutDescriptor* FromAPI(const WGPUPipelineLayoutDescriptor* rhs) {
        return reinterpret_cast<const PipelineLayoutDescriptor*>(rhs);
    }

    inline PipelineLayoutDescriptor* FromAPI(WGPUPipelineLayoutDescriptor* rhs) {
        return reinterpret_cast<PipelineLayoutDescriptor*>(rhs);
    }
    inline const WGPUPrimitiveDepthClampingState* ToAPI(const PrimitiveDepthClampingState* rhs) {
        return reinterpret_cast<const WGPUPrimitiveDepthClampingState*>(rhs);
    }

    inline WGPUPrimitiveDepthClampingState* ToAPI(PrimitiveDepthClampingState* rhs) {
        return reinterpret_cast<WGPUPrimitiveDepthClampingState*>(rhs);
    }

    inline const PrimitiveDepthClampingState* FromAPI(const WGPUPrimitiveDepthClampingState* rhs) {
        return reinterpret_cast<const PrimitiveDepthClampingState*>(rhs);
    }

    inline PrimitiveDepthClampingState* FromAPI(WGPUPrimitiveDepthClampingState* rhs) {
        return reinterpret_cast<PrimitiveDepthClampingState*>(rhs);
    }
    inline const WGPUPrimitiveState* ToAPI(const PrimitiveState* rhs) {
        return reinterpret_cast<const WGPUPrimitiveState*>(rhs);
    }

    inline WGPUPrimitiveState* ToAPI(PrimitiveState* rhs) {
        return reinterpret_cast<WGPUPrimitiveState*>(rhs);
    }

    inline const PrimitiveState* FromAPI(const WGPUPrimitiveState* rhs) {
        return reinterpret_cast<const PrimitiveState*>(rhs);
    }

    inline PrimitiveState* FromAPI(WGPUPrimitiveState* rhs) {
        return reinterpret_cast<PrimitiveState*>(rhs);
    }
    inline const WGPUQuerySetDescriptor* ToAPI(const QuerySetDescriptor* rhs) {
        return reinterpret_cast<const WGPUQuerySetDescriptor*>(rhs);
    }

    inline WGPUQuerySetDescriptor* ToAPI(QuerySetDescriptor* rhs) {
        return reinterpret_cast<WGPUQuerySetDescriptor*>(rhs);
    }

    inline const QuerySetDescriptor* FromAPI(const WGPUQuerySetDescriptor* rhs) {
        return reinterpret_cast<const QuerySetDescriptor*>(rhs);
    }

    inline QuerySetDescriptor* FromAPI(WGPUQuerySetDescriptor* rhs) {
        return reinterpret_cast<QuerySetDescriptor*>(rhs);
    }
    inline const WGPUQueueDescriptor* ToAPI(const QueueDescriptor* rhs) {
        return reinterpret_cast<const WGPUQueueDescriptor*>(rhs);
    }

    inline WGPUQueueDescriptor* ToAPI(QueueDescriptor* rhs) {
        return reinterpret_cast<WGPUQueueDescriptor*>(rhs);
    }

    inline const QueueDescriptor* FromAPI(const WGPUQueueDescriptor* rhs) {
        return reinterpret_cast<const QueueDescriptor*>(rhs);
    }

    inline QueueDescriptor* FromAPI(WGPUQueueDescriptor* rhs) {
        return reinterpret_cast<QueueDescriptor*>(rhs);
    }
    inline const WGPURenderBundleDescriptor* ToAPI(const RenderBundleDescriptor* rhs) {
        return reinterpret_cast<const WGPURenderBundleDescriptor*>(rhs);
    }

    inline WGPURenderBundleDescriptor* ToAPI(RenderBundleDescriptor* rhs) {
        return reinterpret_cast<WGPURenderBundleDescriptor*>(rhs);
    }

    inline const RenderBundleDescriptor* FromAPI(const WGPURenderBundleDescriptor* rhs) {
        return reinterpret_cast<const RenderBundleDescriptor*>(rhs);
    }

    inline RenderBundleDescriptor* FromAPI(WGPURenderBundleDescriptor* rhs) {
        return reinterpret_cast<RenderBundleDescriptor*>(rhs);
    }
    inline const WGPURenderBundleEncoderDescriptor* ToAPI(const RenderBundleEncoderDescriptor* rhs) {
        return reinterpret_cast<const WGPURenderBundleEncoderDescriptor*>(rhs);
    }

    inline WGPURenderBundleEncoderDescriptor* ToAPI(RenderBundleEncoderDescriptor* rhs) {
        return reinterpret_cast<WGPURenderBundleEncoderDescriptor*>(rhs);
    }

    inline const RenderBundleEncoderDescriptor* FromAPI(const WGPURenderBundleEncoderDescriptor* rhs) {
        return reinterpret_cast<const RenderBundleEncoderDescriptor*>(rhs);
    }

    inline RenderBundleEncoderDescriptor* FromAPI(WGPURenderBundleEncoderDescriptor* rhs) {
        return reinterpret_cast<RenderBundleEncoderDescriptor*>(rhs);
    }
    inline const WGPURenderPassDepthStencilAttachment* ToAPI(const RenderPassDepthStencilAttachment* rhs) {
        return reinterpret_cast<const WGPURenderPassDepthStencilAttachment*>(rhs);
    }

    inline WGPURenderPassDepthStencilAttachment* ToAPI(RenderPassDepthStencilAttachment* rhs) {
        return reinterpret_cast<WGPURenderPassDepthStencilAttachment*>(rhs);
    }

    inline const RenderPassDepthStencilAttachment* FromAPI(const WGPURenderPassDepthStencilAttachment* rhs) {
        return reinterpret_cast<const RenderPassDepthStencilAttachment*>(rhs);
    }

    inline RenderPassDepthStencilAttachment* FromAPI(WGPURenderPassDepthStencilAttachment* rhs) {
        return reinterpret_cast<RenderPassDepthStencilAttachment*>(rhs);
    }
    inline const WGPURenderPassTimestampWrite* ToAPI(const RenderPassTimestampWrite* rhs) {
        return reinterpret_cast<const WGPURenderPassTimestampWrite*>(rhs);
    }

    inline WGPURenderPassTimestampWrite* ToAPI(RenderPassTimestampWrite* rhs) {
        return reinterpret_cast<WGPURenderPassTimestampWrite*>(rhs);
    }

    inline const RenderPassTimestampWrite* FromAPI(const WGPURenderPassTimestampWrite* rhs) {
        return reinterpret_cast<const RenderPassTimestampWrite*>(rhs);
    }

    inline RenderPassTimestampWrite* FromAPI(WGPURenderPassTimestampWrite* rhs) {
        return reinterpret_cast<RenderPassTimestampWrite*>(rhs);
    }
    inline const WGPURequestAdapterOptions* ToAPI(const RequestAdapterOptions* rhs) {
        return reinterpret_cast<const WGPURequestAdapterOptions*>(rhs);
    }

    inline WGPURequestAdapterOptions* ToAPI(RequestAdapterOptions* rhs) {
        return reinterpret_cast<WGPURequestAdapterOptions*>(rhs);
    }

    inline const RequestAdapterOptions* FromAPI(const WGPURequestAdapterOptions* rhs) {
        return reinterpret_cast<const RequestAdapterOptions*>(rhs);
    }

    inline RequestAdapterOptions* FromAPI(WGPURequestAdapterOptions* rhs) {
        return reinterpret_cast<RequestAdapterOptions*>(rhs);
    }
    inline const WGPUSamplerBindingLayout* ToAPI(const SamplerBindingLayout* rhs) {
        return reinterpret_cast<const WGPUSamplerBindingLayout*>(rhs);
    }

    inline WGPUSamplerBindingLayout* ToAPI(SamplerBindingLayout* rhs) {
        return reinterpret_cast<WGPUSamplerBindingLayout*>(rhs);
    }

    inline const SamplerBindingLayout* FromAPI(const WGPUSamplerBindingLayout* rhs) {
        return reinterpret_cast<const SamplerBindingLayout*>(rhs);
    }

    inline SamplerBindingLayout* FromAPI(WGPUSamplerBindingLayout* rhs) {
        return reinterpret_cast<SamplerBindingLayout*>(rhs);
    }
    inline const WGPUSamplerDescriptor* ToAPI(const SamplerDescriptor* rhs) {
        return reinterpret_cast<const WGPUSamplerDescriptor*>(rhs);
    }

    inline WGPUSamplerDescriptor* ToAPI(SamplerDescriptor* rhs) {
        return reinterpret_cast<WGPUSamplerDescriptor*>(rhs);
    }

    inline const SamplerDescriptor* FromAPI(const WGPUSamplerDescriptor* rhs) {
        return reinterpret_cast<const SamplerDescriptor*>(rhs);
    }

    inline SamplerDescriptor* FromAPI(WGPUSamplerDescriptor* rhs) {
        return reinterpret_cast<SamplerDescriptor*>(rhs);
    }
    inline const WGPUShaderModuleDescriptor* ToAPI(const ShaderModuleDescriptor* rhs) {
        return reinterpret_cast<const WGPUShaderModuleDescriptor*>(rhs);
    }

    inline WGPUShaderModuleDescriptor* ToAPI(ShaderModuleDescriptor* rhs) {
        return reinterpret_cast<WGPUShaderModuleDescriptor*>(rhs);
    }

    inline const ShaderModuleDescriptor* FromAPI(const WGPUShaderModuleDescriptor* rhs) {
        return reinterpret_cast<const ShaderModuleDescriptor*>(rhs);
    }

    inline ShaderModuleDescriptor* FromAPI(WGPUShaderModuleDescriptor* rhs) {
        return reinterpret_cast<ShaderModuleDescriptor*>(rhs);
    }
    inline const WGPUShaderModuleSPIRVDescriptor* ToAPI(const ShaderModuleSPIRVDescriptor* rhs) {
        return reinterpret_cast<const WGPUShaderModuleSPIRVDescriptor*>(rhs);
    }

    inline WGPUShaderModuleSPIRVDescriptor* ToAPI(ShaderModuleSPIRVDescriptor* rhs) {
        return reinterpret_cast<WGPUShaderModuleSPIRVDescriptor*>(rhs);
    }

    inline const ShaderModuleSPIRVDescriptor* FromAPI(const WGPUShaderModuleSPIRVDescriptor* rhs) {
        return reinterpret_cast<const ShaderModuleSPIRVDescriptor*>(rhs);
    }

    inline ShaderModuleSPIRVDescriptor* FromAPI(WGPUShaderModuleSPIRVDescriptor* rhs) {
        return reinterpret_cast<ShaderModuleSPIRVDescriptor*>(rhs);
    }
    inline const WGPUShaderModuleWGSLDescriptor* ToAPI(const ShaderModuleWGSLDescriptor* rhs) {
        return reinterpret_cast<const WGPUShaderModuleWGSLDescriptor*>(rhs);
    }

    inline WGPUShaderModuleWGSLDescriptor* ToAPI(ShaderModuleWGSLDescriptor* rhs) {
        return reinterpret_cast<WGPUShaderModuleWGSLDescriptor*>(rhs);
    }

    inline const ShaderModuleWGSLDescriptor* FromAPI(const WGPUShaderModuleWGSLDescriptor* rhs) {
        return reinterpret_cast<const ShaderModuleWGSLDescriptor*>(rhs);
    }

    inline ShaderModuleWGSLDescriptor* FromAPI(WGPUShaderModuleWGSLDescriptor* rhs) {
        return reinterpret_cast<ShaderModuleWGSLDescriptor*>(rhs);
    }
    inline const WGPUStencilFaceState* ToAPI(const StencilFaceState* rhs) {
        return reinterpret_cast<const WGPUStencilFaceState*>(rhs);
    }

    inline WGPUStencilFaceState* ToAPI(StencilFaceState* rhs) {
        return reinterpret_cast<WGPUStencilFaceState*>(rhs);
    }

    inline const StencilFaceState* FromAPI(const WGPUStencilFaceState* rhs) {
        return reinterpret_cast<const StencilFaceState*>(rhs);
    }

    inline StencilFaceState* FromAPI(WGPUStencilFaceState* rhs) {
        return reinterpret_cast<StencilFaceState*>(rhs);
    }
    inline const WGPUStorageTextureBindingLayout* ToAPI(const StorageTextureBindingLayout* rhs) {
        return reinterpret_cast<const WGPUStorageTextureBindingLayout*>(rhs);
    }

    inline WGPUStorageTextureBindingLayout* ToAPI(StorageTextureBindingLayout* rhs) {
        return reinterpret_cast<WGPUStorageTextureBindingLayout*>(rhs);
    }

    inline const StorageTextureBindingLayout* FromAPI(const WGPUStorageTextureBindingLayout* rhs) {
        return reinterpret_cast<const StorageTextureBindingLayout*>(rhs);
    }

    inline StorageTextureBindingLayout* FromAPI(WGPUStorageTextureBindingLayout* rhs) {
        return reinterpret_cast<StorageTextureBindingLayout*>(rhs);
    }
    inline const WGPUSurfaceDescriptor* ToAPI(const SurfaceDescriptor* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptor*>(rhs);
    }

    inline WGPUSurfaceDescriptor* ToAPI(SurfaceDescriptor* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptor*>(rhs);
    }

    inline const SurfaceDescriptor* FromAPI(const WGPUSurfaceDescriptor* rhs) {
        return reinterpret_cast<const SurfaceDescriptor*>(rhs);
    }

    inline SurfaceDescriptor* FromAPI(WGPUSurfaceDescriptor* rhs) {
        return reinterpret_cast<SurfaceDescriptor*>(rhs);
    }
    inline const WGPUSurfaceDescriptorFromAndroidNativeWindow* ToAPI(const SurfaceDescriptorFromAndroidNativeWindow* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptorFromAndroidNativeWindow*>(rhs);
    }

    inline WGPUSurfaceDescriptorFromAndroidNativeWindow* ToAPI(SurfaceDescriptorFromAndroidNativeWindow* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptorFromAndroidNativeWindow*>(rhs);
    }

    inline const SurfaceDescriptorFromAndroidNativeWindow* FromAPI(const WGPUSurfaceDescriptorFromAndroidNativeWindow* rhs) {
        return reinterpret_cast<const SurfaceDescriptorFromAndroidNativeWindow*>(rhs);
    }

    inline SurfaceDescriptorFromAndroidNativeWindow* FromAPI(WGPUSurfaceDescriptorFromAndroidNativeWindow* rhs) {
        return reinterpret_cast<SurfaceDescriptorFromAndroidNativeWindow*>(rhs);
    }
    inline const WGPUSurfaceDescriptorFromCanvasHTMLSelector* ToAPI(const SurfaceDescriptorFromCanvasHTMLSelector* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptorFromCanvasHTMLSelector*>(rhs);
    }

    inline WGPUSurfaceDescriptorFromCanvasHTMLSelector* ToAPI(SurfaceDescriptorFromCanvasHTMLSelector* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptorFromCanvasHTMLSelector*>(rhs);
    }

    inline const SurfaceDescriptorFromCanvasHTMLSelector* FromAPI(const WGPUSurfaceDescriptorFromCanvasHTMLSelector* rhs) {
        return reinterpret_cast<const SurfaceDescriptorFromCanvasHTMLSelector*>(rhs);
    }

    inline SurfaceDescriptorFromCanvasHTMLSelector* FromAPI(WGPUSurfaceDescriptorFromCanvasHTMLSelector* rhs) {
        return reinterpret_cast<SurfaceDescriptorFromCanvasHTMLSelector*>(rhs);
    }
    inline const WGPUSurfaceDescriptorFromMetalLayer* ToAPI(const SurfaceDescriptorFromMetalLayer* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptorFromMetalLayer*>(rhs);
    }

    inline WGPUSurfaceDescriptorFromMetalLayer* ToAPI(SurfaceDescriptorFromMetalLayer* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptorFromMetalLayer*>(rhs);
    }

    inline const SurfaceDescriptorFromMetalLayer* FromAPI(const WGPUSurfaceDescriptorFromMetalLayer* rhs) {
        return reinterpret_cast<const SurfaceDescriptorFromMetalLayer*>(rhs);
    }

    inline SurfaceDescriptorFromMetalLayer* FromAPI(WGPUSurfaceDescriptorFromMetalLayer* rhs) {
        return reinterpret_cast<SurfaceDescriptorFromMetalLayer*>(rhs);
    }
    inline const WGPUSurfaceDescriptorFromWaylandSurface* ToAPI(const SurfaceDescriptorFromWaylandSurface* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptorFromWaylandSurface*>(rhs);
    }

    inline WGPUSurfaceDescriptorFromWaylandSurface* ToAPI(SurfaceDescriptorFromWaylandSurface* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptorFromWaylandSurface*>(rhs);
    }

    inline const SurfaceDescriptorFromWaylandSurface* FromAPI(const WGPUSurfaceDescriptorFromWaylandSurface* rhs) {
        return reinterpret_cast<const SurfaceDescriptorFromWaylandSurface*>(rhs);
    }

    inline SurfaceDescriptorFromWaylandSurface* FromAPI(WGPUSurfaceDescriptorFromWaylandSurface* rhs) {
        return reinterpret_cast<SurfaceDescriptorFromWaylandSurface*>(rhs);
    }
    inline const WGPUSurfaceDescriptorFromWindowsCoreWindow* ToAPI(const SurfaceDescriptorFromWindowsCoreWindow* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptorFromWindowsCoreWindow*>(rhs);
    }

    inline WGPUSurfaceDescriptorFromWindowsCoreWindow* ToAPI(SurfaceDescriptorFromWindowsCoreWindow* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptorFromWindowsCoreWindow*>(rhs);
    }

    inline const SurfaceDescriptorFromWindowsCoreWindow* FromAPI(const WGPUSurfaceDescriptorFromWindowsCoreWindow* rhs) {
        return reinterpret_cast<const SurfaceDescriptorFromWindowsCoreWindow*>(rhs);
    }

    inline SurfaceDescriptorFromWindowsCoreWindow* FromAPI(WGPUSurfaceDescriptorFromWindowsCoreWindow* rhs) {
        return reinterpret_cast<SurfaceDescriptorFromWindowsCoreWindow*>(rhs);
    }
    inline const WGPUSurfaceDescriptorFromWindowsHWND* ToAPI(const SurfaceDescriptorFromWindowsHWND* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptorFromWindowsHWND*>(rhs);
    }

    inline WGPUSurfaceDescriptorFromWindowsHWND* ToAPI(SurfaceDescriptorFromWindowsHWND* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptorFromWindowsHWND*>(rhs);
    }

    inline const SurfaceDescriptorFromWindowsHWND* FromAPI(const WGPUSurfaceDescriptorFromWindowsHWND* rhs) {
        return reinterpret_cast<const SurfaceDescriptorFromWindowsHWND*>(rhs);
    }

    inline SurfaceDescriptorFromWindowsHWND* FromAPI(WGPUSurfaceDescriptorFromWindowsHWND* rhs) {
        return reinterpret_cast<SurfaceDescriptorFromWindowsHWND*>(rhs);
    }
    inline const WGPUSurfaceDescriptorFromWindowsSwapChainPanel* ToAPI(const SurfaceDescriptorFromWindowsSwapChainPanel* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptorFromWindowsSwapChainPanel*>(rhs);
    }

    inline WGPUSurfaceDescriptorFromWindowsSwapChainPanel* ToAPI(SurfaceDescriptorFromWindowsSwapChainPanel* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptorFromWindowsSwapChainPanel*>(rhs);
    }

    inline const SurfaceDescriptorFromWindowsSwapChainPanel* FromAPI(const WGPUSurfaceDescriptorFromWindowsSwapChainPanel* rhs) {
        return reinterpret_cast<const SurfaceDescriptorFromWindowsSwapChainPanel*>(rhs);
    }

    inline SurfaceDescriptorFromWindowsSwapChainPanel* FromAPI(WGPUSurfaceDescriptorFromWindowsSwapChainPanel* rhs) {
        return reinterpret_cast<SurfaceDescriptorFromWindowsSwapChainPanel*>(rhs);
    }
    inline const WGPUSurfaceDescriptorFromXlibWindow* ToAPI(const SurfaceDescriptorFromXlibWindow* rhs) {
        return reinterpret_cast<const WGPUSurfaceDescriptorFromXlibWindow*>(rhs);
    }

    inline WGPUSurfaceDescriptorFromXlibWindow* ToAPI(SurfaceDescriptorFromXlibWindow* rhs) {
        return reinterpret_cast<WGPUSurfaceDescriptorFromXlibWindow*>(rhs);
    }

    inline const SurfaceDescriptorFromXlibWindow* FromAPI(const WGPUSurfaceDescriptorFromXlibWindow* rhs) {
        return reinterpret_cast<const SurfaceDescriptorFromXlibWindow*>(rhs);
    }

    inline SurfaceDescriptorFromXlibWindow* FromAPI(WGPUSurfaceDescriptorFromXlibWindow* rhs) {
        return reinterpret_cast<SurfaceDescriptorFromXlibWindow*>(rhs);
    }
    inline const WGPUSwapChainDescriptor* ToAPI(const SwapChainDescriptor* rhs) {
        return reinterpret_cast<const WGPUSwapChainDescriptor*>(rhs);
    }

    inline WGPUSwapChainDescriptor* ToAPI(SwapChainDescriptor* rhs) {
        return reinterpret_cast<WGPUSwapChainDescriptor*>(rhs);
    }

    inline const SwapChainDescriptor* FromAPI(const WGPUSwapChainDescriptor* rhs) {
        return reinterpret_cast<const SwapChainDescriptor*>(rhs);
    }

    inline SwapChainDescriptor* FromAPI(WGPUSwapChainDescriptor* rhs) {
        return reinterpret_cast<SwapChainDescriptor*>(rhs);
    }
    inline const WGPUTextureBindingLayout* ToAPI(const TextureBindingLayout* rhs) {
        return reinterpret_cast<const WGPUTextureBindingLayout*>(rhs);
    }

    inline WGPUTextureBindingLayout* ToAPI(TextureBindingLayout* rhs) {
        return reinterpret_cast<WGPUTextureBindingLayout*>(rhs);
    }

    inline const TextureBindingLayout* FromAPI(const WGPUTextureBindingLayout* rhs) {
        return reinterpret_cast<const TextureBindingLayout*>(rhs);
    }

    inline TextureBindingLayout* FromAPI(WGPUTextureBindingLayout* rhs) {
        return reinterpret_cast<TextureBindingLayout*>(rhs);
    }
    inline const WGPUTextureDataLayout* ToAPI(const TextureDataLayout* rhs) {
        return reinterpret_cast<const WGPUTextureDataLayout*>(rhs);
    }

    inline WGPUTextureDataLayout* ToAPI(TextureDataLayout* rhs) {
        return reinterpret_cast<WGPUTextureDataLayout*>(rhs);
    }

    inline const TextureDataLayout* FromAPI(const WGPUTextureDataLayout* rhs) {
        return reinterpret_cast<const TextureDataLayout*>(rhs);
    }

    inline TextureDataLayout* FromAPI(WGPUTextureDataLayout* rhs) {
        return reinterpret_cast<TextureDataLayout*>(rhs);
    }
    inline const WGPUTextureViewDescriptor* ToAPI(const TextureViewDescriptor* rhs) {
        return reinterpret_cast<const WGPUTextureViewDescriptor*>(rhs);
    }

    inline WGPUTextureViewDescriptor* ToAPI(TextureViewDescriptor* rhs) {
        return reinterpret_cast<WGPUTextureViewDescriptor*>(rhs);
    }

    inline const TextureViewDescriptor* FromAPI(const WGPUTextureViewDescriptor* rhs) {
        return reinterpret_cast<const TextureViewDescriptor*>(rhs);
    }

    inline TextureViewDescriptor* FromAPI(WGPUTextureViewDescriptor* rhs) {
        return reinterpret_cast<TextureViewDescriptor*>(rhs);
    }
    inline const WGPUVertexAttribute* ToAPI(const VertexAttribute* rhs) {
        return reinterpret_cast<const WGPUVertexAttribute*>(rhs);
    }

    inline WGPUVertexAttribute* ToAPI(VertexAttribute* rhs) {
        return reinterpret_cast<WGPUVertexAttribute*>(rhs);
    }

    inline const VertexAttribute* FromAPI(const WGPUVertexAttribute* rhs) {
        return reinterpret_cast<const VertexAttribute*>(rhs);
    }

    inline VertexAttribute* FromAPI(WGPUVertexAttribute* rhs) {
        return reinterpret_cast<VertexAttribute*>(rhs);
    }
    inline const WGPUBindGroupDescriptor* ToAPI(const BindGroupDescriptor* rhs) {
        return reinterpret_cast<const WGPUBindGroupDescriptor*>(rhs);
    }

    inline WGPUBindGroupDescriptor* ToAPI(BindGroupDescriptor* rhs) {
        return reinterpret_cast<WGPUBindGroupDescriptor*>(rhs);
    }

    inline const BindGroupDescriptor* FromAPI(const WGPUBindGroupDescriptor* rhs) {
        return reinterpret_cast<const BindGroupDescriptor*>(rhs);
    }

    inline BindGroupDescriptor* FromAPI(WGPUBindGroupDescriptor* rhs) {
        return reinterpret_cast<BindGroupDescriptor*>(rhs);
    }
    inline const WGPUBindGroupLayoutEntry* ToAPI(const BindGroupLayoutEntry* rhs) {
        return reinterpret_cast<const WGPUBindGroupLayoutEntry*>(rhs);
    }

    inline WGPUBindGroupLayoutEntry* ToAPI(BindGroupLayoutEntry* rhs) {
        return reinterpret_cast<WGPUBindGroupLayoutEntry*>(rhs);
    }

    inline const BindGroupLayoutEntry* FromAPI(const WGPUBindGroupLayoutEntry* rhs) {
        return reinterpret_cast<const BindGroupLayoutEntry*>(rhs);
    }

    inline BindGroupLayoutEntry* FromAPI(WGPUBindGroupLayoutEntry* rhs) {
        return reinterpret_cast<BindGroupLayoutEntry*>(rhs);
    }
    inline const WGPUBlendState* ToAPI(const BlendState* rhs) {
        return reinterpret_cast<const WGPUBlendState*>(rhs);
    }

    inline WGPUBlendState* ToAPI(BlendState* rhs) {
        return reinterpret_cast<WGPUBlendState*>(rhs);
    }

    inline const BlendState* FromAPI(const WGPUBlendState* rhs) {
        return reinterpret_cast<const BlendState*>(rhs);
    }

    inline BlendState* FromAPI(WGPUBlendState* rhs) {
        return reinterpret_cast<BlendState*>(rhs);
    }
    inline const WGPUCompilationInfo* ToAPI(const CompilationInfo* rhs) {
        return reinterpret_cast<const WGPUCompilationInfo*>(rhs);
    }

    inline WGPUCompilationInfo* ToAPI(CompilationInfo* rhs) {
        return reinterpret_cast<WGPUCompilationInfo*>(rhs);
    }

    inline const CompilationInfo* FromAPI(const WGPUCompilationInfo* rhs) {
        return reinterpret_cast<const CompilationInfo*>(rhs);
    }

    inline CompilationInfo* FromAPI(WGPUCompilationInfo* rhs) {
        return reinterpret_cast<CompilationInfo*>(rhs);
    }
    inline const WGPUComputePassDescriptor* ToAPI(const ComputePassDescriptor* rhs) {
        return reinterpret_cast<const WGPUComputePassDescriptor*>(rhs);
    }

    inline WGPUComputePassDescriptor* ToAPI(ComputePassDescriptor* rhs) {
        return reinterpret_cast<WGPUComputePassDescriptor*>(rhs);
    }

    inline const ComputePassDescriptor* FromAPI(const WGPUComputePassDescriptor* rhs) {
        return reinterpret_cast<const ComputePassDescriptor*>(rhs);
    }

    inline ComputePassDescriptor* FromAPI(WGPUComputePassDescriptor* rhs) {
        return reinterpret_cast<ComputePassDescriptor*>(rhs);
    }
    inline const WGPUDepthStencilState* ToAPI(const DepthStencilState* rhs) {
        return reinterpret_cast<const WGPUDepthStencilState*>(rhs);
    }

    inline WGPUDepthStencilState* ToAPI(DepthStencilState* rhs) {
        return reinterpret_cast<WGPUDepthStencilState*>(rhs);
    }

    inline const DepthStencilState* FromAPI(const WGPUDepthStencilState* rhs) {
        return reinterpret_cast<const DepthStencilState*>(rhs);
    }

    inline DepthStencilState* FromAPI(WGPUDepthStencilState* rhs) {
        return reinterpret_cast<DepthStencilState*>(rhs);
    }
    inline const WGPUImageCopyBuffer* ToAPI(const ImageCopyBuffer* rhs) {
        return reinterpret_cast<const WGPUImageCopyBuffer*>(rhs);
    }

    inline WGPUImageCopyBuffer* ToAPI(ImageCopyBuffer* rhs) {
        return reinterpret_cast<WGPUImageCopyBuffer*>(rhs);
    }

    inline const ImageCopyBuffer* FromAPI(const WGPUImageCopyBuffer* rhs) {
        return reinterpret_cast<const ImageCopyBuffer*>(rhs);
    }

    inline ImageCopyBuffer* FromAPI(WGPUImageCopyBuffer* rhs) {
        return reinterpret_cast<ImageCopyBuffer*>(rhs);
    }
    inline const WGPUImageCopyTexture* ToAPI(const ImageCopyTexture* rhs) {
        return reinterpret_cast<const WGPUImageCopyTexture*>(rhs);
    }

    inline WGPUImageCopyTexture* ToAPI(ImageCopyTexture* rhs) {
        return reinterpret_cast<WGPUImageCopyTexture*>(rhs);
    }

    inline const ImageCopyTexture* FromAPI(const WGPUImageCopyTexture* rhs) {
        return reinterpret_cast<const ImageCopyTexture*>(rhs);
    }

    inline ImageCopyTexture* FromAPI(WGPUImageCopyTexture* rhs) {
        return reinterpret_cast<ImageCopyTexture*>(rhs);
    }
    inline const WGPUProgrammableStageDescriptor* ToAPI(const ProgrammableStageDescriptor* rhs) {
        return reinterpret_cast<const WGPUProgrammableStageDescriptor*>(rhs);
    }

    inline WGPUProgrammableStageDescriptor* ToAPI(ProgrammableStageDescriptor* rhs) {
        return reinterpret_cast<WGPUProgrammableStageDescriptor*>(rhs);
    }

    inline const ProgrammableStageDescriptor* FromAPI(const WGPUProgrammableStageDescriptor* rhs) {
        return reinterpret_cast<const ProgrammableStageDescriptor*>(rhs);
    }

    inline ProgrammableStageDescriptor* FromAPI(WGPUProgrammableStageDescriptor* rhs) {
        return reinterpret_cast<ProgrammableStageDescriptor*>(rhs);
    }
    inline const WGPURenderPassColorAttachment* ToAPI(const RenderPassColorAttachment* rhs) {
        return reinterpret_cast<const WGPURenderPassColorAttachment*>(rhs);
    }

    inline WGPURenderPassColorAttachment* ToAPI(RenderPassColorAttachment* rhs) {
        return reinterpret_cast<WGPURenderPassColorAttachment*>(rhs);
    }

    inline const RenderPassColorAttachment* FromAPI(const WGPURenderPassColorAttachment* rhs) {
        return reinterpret_cast<const RenderPassColorAttachment*>(rhs);
    }

    inline RenderPassColorAttachment* FromAPI(WGPURenderPassColorAttachment* rhs) {
        return reinterpret_cast<RenderPassColorAttachment*>(rhs);
    }
    inline const WGPURequiredLimits* ToAPI(const RequiredLimits* rhs) {
        return reinterpret_cast<const WGPURequiredLimits*>(rhs);
    }

    inline WGPURequiredLimits* ToAPI(RequiredLimits* rhs) {
        return reinterpret_cast<WGPURequiredLimits*>(rhs);
    }

    inline const RequiredLimits* FromAPI(const WGPURequiredLimits* rhs) {
        return reinterpret_cast<const RequiredLimits*>(rhs);
    }

    inline RequiredLimits* FromAPI(WGPURequiredLimits* rhs) {
        return reinterpret_cast<RequiredLimits*>(rhs);
    }
    inline const WGPUSupportedLimits* ToAPI(const SupportedLimits* rhs) {
        return reinterpret_cast<const WGPUSupportedLimits*>(rhs);
    }

    inline WGPUSupportedLimits* ToAPI(SupportedLimits* rhs) {
        return reinterpret_cast<WGPUSupportedLimits*>(rhs);
    }

    inline const SupportedLimits* FromAPI(const WGPUSupportedLimits* rhs) {
        return reinterpret_cast<const SupportedLimits*>(rhs);
    }

    inline SupportedLimits* FromAPI(WGPUSupportedLimits* rhs) {
        return reinterpret_cast<SupportedLimits*>(rhs);
    }
    inline const WGPUTextureDescriptor* ToAPI(const TextureDescriptor* rhs) {
        return reinterpret_cast<const WGPUTextureDescriptor*>(rhs);
    }

    inline WGPUTextureDescriptor* ToAPI(TextureDescriptor* rhs) {
        return reinterpret_cast<WGPUTextureDescriptor*>(rhs);
    }

    inline const TextureDescriptor* FromAPI(const WGPUTextureDescriptor* rhs) {
        return reinterpret_cast<const TextureDescriptor*>(rhs);
    }

    inline TextureDescriptor* FromAPI(WGPUTextureDescriptor* rhs) {
        return reinterpret_cast<TextureDescriptor*>(rhs);
    }
    inline const WGPUVertexBufferLayout* ToAPI(const VertexBufferLayout* rhs) {
        return reinterpret_cast<const WGPUVertexBufferLayout*>(rhs);
    }

    inline WGPUVertexBufferLayout* ToAPI(VertexBufferLayout* rhs) {
        return reinterpret_cast<WGPUVertexBufferLayout*>(rhs);
    }

    inline const VertexBufferLayout* FromAPI(const WGPUVertexBufferLayout* rhs) {
        return reinterpret_cast<const VertexBufferLayout*>(rhs);
    }

    inline VertexBufferLayout* FromAPI(WGPUVertexBufferLayout* rhs) {
        return reinterpret_cast<VertexBufferLayout*>(rhs);
    }
    inline const WGPUBindGroupLayoutDescriptor* ToAPI(const BindGroupLayoutDescriptor* rhs) {
        return reinterpret_cast<const WGPUBindGroupLayoutDescriptor*>(rhs);
    }

    inline WGPUBindGroupLayoutDescriptor* ToAPI(BindGroupLayoutDescriptor* rhs) {
        return reinterpret_cast<WGPUBindGroupLayoutDescriptor*>(rhs);
    }

    inline const BindGroupLayoutDescriptor* FromAPI(const WGPUBindGroupLayoutDescriptor* rhs) {
        return reinterpret_cast<const BindGroupLayoutDescriptor*>(rhs);
    }

    inline BindGroupLayoutDescriptor* FromAPI(WGPUBindGroupLayoutDescriptor* rhs) {
        return reinterpret_cast<BindGroupLayoutDescriptor*>(rhs);
    }
    inline const WGPUColorTargetState* ToAPI(const ColorTargetState* rhs) {
        return reinterpret_cast<const WGPUColorTargetState*>(rhs);
    }

    inline WGPUColorTargetState* ToAPI(ColorTargetState* rhs) {
        return reinterpret_cast<WGPUColorTargetState*>(rhs);
    }

    inline const ColorTargetState* FromAPI(const WGPUColorTargetState* rhs) {
        return reinterpret_cast<const ColorTargetState*>(rhs);
    }

    inline ColorTargetState* FromAPI(WGPUColorTargetState* rhs) {
        return reinterpret_cast<ColorTargetState*>(rhs);
    }
    inline const WGPUComputePipelineDescriptor* ToAPI(const ComputePipelineDescriptor* rhs) {
        return reinterpret_cast<const WGPUComputePipelineDescriptor*>(rhs);
    }

    inline WGPUComputePipelineDescriptor* ToAPI(ComputePipelineDescriptor* rhs) {
        return reinterpret_cast<WGPUComputePipelineDescriptor*>(rhs);
    }

    inline const ComputePipelineDescriptor* FromAPI(const WGPUComputePipelineDescriptor* rhs) {
        return reinterpret_cast<const ComputePipelineDescriptor*>(rhs);
    }

    inline ComputePipelineDescriptor* FromAPI(WGPUComputePipelineDescriptor* rhs) {
        return reinterpret_cast<ComputePipelineDescriptor*>(rhs);
    }
    inline const WGPUDeviceDescriptor* ToAPI(const DeviceDescriptor* rhs) {
        return reinterpret_cast<const WGPUDeviceDescriptor*>(rhs);
    }

    inline WGPUDeviceDescriptor* ToAPI(DeviceDescriptor* rhs) {
        return reinterpret_cast<WGPUDeviceDescriptor*>(rhs);
    }

    inline const DeviceDescriptor* FromAPI(const WGPUDeviceDescriptor* rhs) {
        return reinterpret_cast<const DeviceDescriptor*>(rhs);
    }

    inline DeviceDescriptor* FromAPI(WGPUDeviceDescriptor* rhs) {
        return reinterpret_cast<DeviceDescriptor*>(rhs);
    }
    inline const WGPUDeviceProperties* ToAPI(const DeviceProperties* rhs) {
        return reinterpret_cast<const WGPUDeviceProperties*>(rhs);
    }

    inline WGPUDeviceProperties* ToAPI(DeviceProperties* rhs) {
        return reinterpret_cast<WGPUDeviceProperties*>(rhs);
    }

    inline const DeviceProperties* FromAPI(const WGPUDeviceProperties* rhs) {
        return reinterpret_cast<const DeviceProperties*>(rhs);
    }

    inline DeviceProperties* FromAPI(WGPUDeviceProperties* rhs) {
        return reinterpret_cast<DeviceProperties*>(rhs);
    }
    inline const WGPURenderPassDescriptor* ToAPI(const RenderPassDescriptor* rhs) {
        return reinterpret_cast<const WGPURenderPassDescriptor*>(rhs);
    }

    inline WGPURenderPassDescriptor* ToAPI(RenderPassDescriptor* rhs) {
        return reinterpret_cast<WGPURenderPassDescriptor*>(rhs);
    }

    inline const RenderPassDescriptor* FromAPI(const WGPURenderPassDescriptor* rhs) {
        return reinterpret_cast<const RenderPassDescriptor*>(rhs);
    }

    inline RenderPassDescriptor* FromAPI(WGPURenderPassDescriptor* rhs) {
        return reinterpret_cast<RenderPassDescriptor*>(rhs);
    }
    inline const WGPUVertexState* ToAPI(const VertexState* rhs) {
        return reinterpret_cast<const WGPUVertexState*>(rhs);
    }

    inline WGPUVertexState* ToAPI(VertexState* rhs) {
        return reinterpret_cast<WGPUVertexState*>(rhs);
    }

    inline const VertexState* FromAPI(const WGPUVertexState* rhs) {
        return reinterpret_cast<const VertexState*>(rhs);
    }

    inline VertexState* FromAPI(WGPUVertexState* rhs) {
        return reinterpret_cast<VertexState*>(rhs);
    }
    inline const WGPUFragmentState* ToAPI(const FragmentState* rhs) {
        return reinterpret_cast<const WGPUFragmentState*>(rhs);
    }

    inline WGPUFragmentState* ToAPI(FragmentState* rhs) {
        return reinterpret_cast<WGPUFragmentState*>(rhs);
    }

    inline const FragmentState* FromAPI(const WGPUFragmentState* rhs) {
        return reinterpret_cast<const FragmentState*>(rhs);
    }

    inline FragmentState* FromAPI(WGPUFragmentState* rhs) {
        return reinterpret_cast<FragmentState*>(rhs);
    }
    inline const WGPURenderPipelineDescriptor* ToAPI(const RenderPipelineDescriptor* rhs) {
        return reinterpret_cast<const WGPURenderPipelineDescriptor*>(rhs);
    }

    inline WGPURenderPipelineDescriptor* ToAPI(RenderPipelineDescriptor* rhs) {
        return reinterpret_cast<WGPURenderPipelineDescriptor*>(rhs);
    }

    inline const RenderPipelineDescriptor* FromAPI(const WGPURenderPipelineDescriptor* rhs) {
        return reinterpret_cast<const RenderPipelineDescriptor*>(rhs);
    }

    inline RenderPipelineDescriptor* FromAPI(WGPURenderPipelineDescriptor* rhs) {
        return reinterpret_cast<RenderPipelineDescriptor*>(rhs);
    }

    inline const WGPUAdapterImpl* ToAPI(const AdapterBase* rhs) {
        return reinterpret_cast<const WGPUAdapterImpl*>(rhs);
    }

    inline WGPUAdapterImpl* ToAPI(AdapterBase* rhs) {
        return reinterpret_cast<WGPUAdapterImpl*>(rhs);
    }

    inline const AdapterBase* FromAPI(const WGPUAdapterImpl* rhs) {
        return reinterpret_cast<const AdapterBase*>(rhs);
    }

    inline AdapterBase* FromAPI(WGPUAdapterImpl* rhs) {
        return reinterpret_cast<AdapterBase*>(rhs);
    }
    inline const WGPUBindGroupImpl* ToAPI(const BindGroupBase* rhs) {
        return reinterpret_cast<const WGPUBindGroupImpl*>(rhs);
    }

    inline WGPUBindGroupImpl* ToAPI(BindGroupBase* rhs) {
        return reinterpret_cast<WGPUBindGroupImpl*>(rhs);
    }

    inline const BindGroupBase* FromAPI(const WGPUBindGroupImpl* rhs) {
        return reinterpret_cast<const BindGroupBase*>(rhs);
    }

    inline BindGroupBase* FromAPI(WGPUBindGroupImpl* rhs) {
        return reinterpret_cast<BindGroupBase*>(rhs);
    }
    inline const WGPUBindGroupLayoutImpl* ToAPI(const BindGroupLayoutBase* rhs) {
        return reinterpret_cast<const WGPUBindGroupLayoutImpl*>(rhs);
    }

    inline WGPUBindGroupLayoutImpl* ToAPI(BindGroupLayoutBase* rhs) {
        return reinterpret_cast<WGPUBindGroupLayoutImpl*>(rhs);
    }

    inline const BindGroupLayoutBase* FromAPI(const WGPUBindGroupLayoutImpl* rhs) {
        return reinterpret_cast<const BindGroupLayoutBase*>(rhs);
    }

    inline BindGroupLayoutBase* FromAPI(WGPUBindGroupLayoutImpl* rhs) {
        return reinterpret_cast<BindGroupLayoutBase*>(rhs);
    }
    inline const WGPUBufferImpl* ToAPI(const BufferBase* rhs) {
        return reinterpret_cast<const WGPUBufferImpl*>(rhs);
    }

    inline WGPUBufferImpl* ToAPI(BufferBase* rhs) {
        return reinterpret_cast<WGPUBufferImpl*>(rhs);
    }

    inline const BufferBase* FromAPI(const WGPUBufferImpl* rhs) {
        return reinterpret_cast<const BufferBase*>(rhs);
    }

    inline BufferBase* FromAPI(WGPUBufferImpl* rhs) {
        return reinterpret_cast<BufferBase*>(rhs);
    }
    inline const WGPUCommandBufferImpl* ToAPI(const CommandBufferBase* rhs) {
        return reinterpret_cast<const WGPUCommandBufferImpl*>(rhs);
    }

    inline WGPUCommandBufferImpl* ToAPI(CommandBufferBase* rhs) {
        return reinterpret_cast<WGPUCommandBufferImpl*>(rhs);
    }

    inline const CommandBufferBase* FromAPI(const WGPUCommandBufferImpl* rhs) {
        return reinterpret_cast<const CommandBufferBase*>(rhs);
    }

    inline CommandBufferBase* FromAPI(WGPUCommandBufferImpl* rhs) {
        return reinterpret_cast<CommandBufferBase*>(rhs);
    }
    inline const WGPUCommandEncoderImpl* ToAPI(const CommandEncoderBase* rhs) {
        return reinterpret_cast<const WGPUCommandEncoderImpl*>(rhs);
    }

    inline WGPUCommandEncoderImpl* ToAPI(CommandEncoderBase* rhs) {
        return reinterpret_cast<WGPUCommandEncoderImpl*>(rhs);
    }

    inline const CommandEncoderBase* FromAPI(const WGPUCommandEncoderImpl* rhs) {
        return reinterpret_cast<const CommandEncoderBase*>(rhs);
    }

    inline CommandEncoderBase* FromAPI(WGPUCommandEncoderImpl* rhs) {
        return reinterpret_cast<CommandEncoderBase*>(rhs);
    }
    inline const WGPUComputePassEncoderImpl* ToAPI(const ComputePassEncoderBase* rhs) {
        return reinterpret_cast<const WGPUComputePassEncoderImpl*>(rhs);
    }

    inline WGPUComputePassEncoderImpl* ToAPI(ComputePassEncoderBase* rhs) {
        return reinterpret_cast<WGPUComputePassEncoderImpl*>(rhs);
    }

    inline const ComputePassEncoderBase* FromAPI(const WGPUComputePassEncoderImpl* rhs) {
        return reinterpret_cast<const ComputePassEncoderBase*>(rhs);
    }

    inline ComputePassEncoderBase* FromAPI(WGPUComputePassEncoderImpl* rhs) {
        return reinterpret_cast<ComputePassEncoderBase*>(rhs);
    }
    inline const WGPUComputePipelineImpl* ToAPI(const ComputePipelineBase* rhs) {
        return reinterpret_cast<const WGPUComputePipelineImpl*>(rhs);
    }

    inline WGPUComputePipelineImpl* ToAPI(ComputePipelineBase* rhs) {
        return reinterpret_cast<WGPUComputePipelineImpl*>(rhs);
    }

    inline const ComputePipelineBase* FromAPI(const WGPUComputePipelineImpl* rhs) {
        return reinterpret_cast<const ComputePipelineBase*>(rhs);
    }

    inline ComputePipelineBase* FromAPI(WGPUComputePipelineImpl* rhs) {
        return reinterpret_cast<ComputePipelineBase*>(rhs);
    }
    inline const WGPUDeviceImpl* ToAPI(const DeviceBase* rhs) {
        return reinterpret_cast<const WGPUDeviceImpl*>(rhs);
    }

    inline WGPUDeviceImpl* ToAPI(DeviceBase* rhs) {
        return reinterpret_cast<WGPUDeviceImpl*>(rhs);
    }

    inline const DeviceBase* FromAPI(const WGPUDeviceImpl* rhs) {
        return reinterpret_cast<const DeviceBase*>(rhs);
    }

    inline DeviceBase* FromAPI(WGPUDeviceImpl* rhs) {
        return reinterpret_cast<DeviceBase*>(rhs);
    }
    inline const WGPUExternalTextureImpl* ToAPI(const ExternalTextureBase* rhs) {
        return reinterpret_cast<const WGPUExternalTextureImpl*>(rhs);
    }

    inline WGPUExternalTextureImpl* ToAPI(ExternalTextureBase* rhs) {
        return reinterpret_cast<WGPUExternalTextureImpl*>(rhs);
    }

    inline const ExternalTextureBase* FromAPI(const WGPUExternalTextureImpl* rhs) {
        return reinterpret_cast<const ExternalTextureBase*>(rhs);
    }

    inline ExternalTextureBase* FromAPI(WGPUExternalTextureImpl* rhs) {
        return reinterpret_cast<ExternalTextureBase*>(rhs);
    }
    inline const WGPUInstanceImpl* ToAPI(const InstanceBase* rhs) {
        return reinterpret_cast<const WGPUInstanceImpl*>(rhs);
    }

    inline WGPUInstanceImpl* ToAPI(InstanceBase* rhs) {
        return reinterpret_cast<WGPUInstanceImpl*>(rhs);
    }

    inline const InstanceBase* FromAPI(const WGPUInstanceImpl* rhs) {
        return reinterpret_cast<const InstanceBase*>(rhs);
    }

    inline InstanceBase* FromAPI(WGPUInstanceImpl* rhs) {
        return reinterpret_cast<InstanceBase*>(rhs);
    }
    inline const WGPUPipelineLayoutImpl* ToAPI(const PipelineLayoutBase* rhs) {
        return reinterpret_cast<const WGPUPipelineLayoutImpl*>(rhs);
    }

    inline WGPUPipelineLayoutImpl* ToAPI(PipelineLayoutBase* rhs) {
        return reinterpret_cast<WGPUPipelineLayoutImpl*>(rhs);
    }

    inline const PipelineLayoutBase* FromAPI(const WGPUPipelineLayoutImpl* rhs) {
        return reinterpret_cast<const PipelineLayoutBase*>(rhs);
    }

    inline PipelineLayoutBase* FromAPI(WGPUPipelineLayoutImpl* rhs) {
        return reinterpret_cast<PipelineLayoutBase*>(rhs);
    }
    inline const WGPUQuerySetImpl* ToAPI(const QuerySetBase* rhs) {
        return reinterpret_cast<const WGPUQuerySetImpl*>(rhs);
    }

    inline WGPUQuerySetImpl* ToAPI(QuerySetBase* rhs) {
        return reinterpret_cast<WGPUQuerySetImpl*>(rhs);
    }

    inline const QuerySetBase* FromAPI(const WGPUQuerySetImpl* rhs) {
        return reinterpret_cast<const QuerySetBase*>(rhs);
    }

    inline QuerySetBase* FromAPI(WGPUQuerySetImpl* rhs) {
        return reinterpret_cast<QuerySetBase*>(rhs);
    }
    inline const WGPUQueueImpl* ToAPI(const QueueBase* rhs) {
        return reinterpret_cast<const WGPUQueueImpl*>(rhs);
    }

    inline WGPUQueueImpl* ToAPI(QueueBase* rhs) {
        return reinterpret_cast<WGPUQueueImpl*>(rhs);
    }

    inline const QueueBase* FromAPI(const WGPUQueueImpl* rhs) {
        return reinterpret_cast<const QueueBase*>(rhs);
    }

    inline QueueBase* FromAPI(WGPUQueueImpl* rhs) {
        return reinterpret_cast<QueueBase*>(rhs);
    }
    inline const WGPURenderBundleImpl* ToAPI(const RenderBundleBase* rhs) {
        return reinterpret_cast<const WGPURenderBundleImpl*>(rhs);
    }

    inline WGPURenderBundleImpl* ToAPI(RenderBundleBase* rhs) {
        return reinterpret_cast<WGPURenderBundleImpl*>(rhs);
    }

    inline const RenderBundleBase* FromAPI(const WGPURenderBundleImpl* rhs) {
        return reinterpret_cast<const RenderBundleBase*>(rhs);
    }

    inline RenderBundleBase* FromAPI(WGPURenderBundleImpl* rhs) {
        return reinterpret_cast<RenderBundleBase*>(rhs);
    }
    inline const WGPURenderBundleEncoderImpl* ToAPI(const RenderBundleEncoderBase* rhs) {
        return reinterpret_cast<const WGPURenderBundleEncoderImpl*>(rhs);
    }

    inline WGPURenderBundleEncoderImpl* ToAPI(RenderBundleEncoderBase* rhs) {
        return reinterpret_cast<WGPURenderBundleEncoderImpl*>(rhs);
    }

    inline const RenderBundleEncoderBase* FromAPI(const WGPURenderBundleEncoderImpl* rhs) {
        return reinterpret_cast<const RenderBundleEncoderBase*>(rhs);
    }

    inline RenderBundleEncoderBase* FromAPI(WGPURenderBundleEncoderImpl* rhs) {
        return reinterpret_cast<RenderBundleEncoderBase*>(rhs);
    }
    inline const WGPURenderPassEncoderImpl* ToAPI(const RenderPassEncoderBase* rhs) {
        return reinterpret_cast<const WGPURenderPassEncoderImpl*>(rhs);
    }

    inline WGPURenderPassEncoderImpl* ToAPI(RenderPassEncoderBase* rhs) {
        return reinterpret_cast<WGPURenderPassEncoderImpl*>(rhs);
    }

    inline const RenderPassEncoderBase* FromAPI(const WGPURenderPassEncoderImpl* rhs) {
        return reinterpret_cast<const RenderPassEncoderBase*>(rhs);
    }

    inline RenderPassEncoderBase* FromAPI(WGPURenderPassEncoderImpl* rhs) {
        return reinterpret_cast<RenderPassEncoderBase*>(rhs);
    }
    inline const WGPURenderPipelineImpl* ToAPI(const RenderPipelineBase* rhs) {
        return reinterpret_cast<const WGPURenderPipelineImpl*>(rhs);
    }

    inline WGPURenderPipelineImpl* ToAPI(RenderPipelineBase* rhs) {
        return reinterpret_cast<WGPURenderPipelineImpl*>(rhs);
    }

    inline const RenderPipelineBase* FromAPI(const WGPURenderPipelineImpl* rhs) {
        return reinterpret_cast<const RenderPipelineBase*>(rhs);
    }

    inline RenderPipelineBase* FromAPI(WGPURenderPipelineImpl* rhs) {
        return reinterpret_cast<RenderPipelineBase*>(rhs);
    }
    inline const WGPUSamplerImpl* ToAPI(const SamplerBase* rhs) {
        return reinterpret_cast<const WGPUSamplerImpl*>(rhs);
    }

    inline WGPUSamplerImpl* ToAPI(SamplerBase* rhs) {
        return reinterpret_cast<WGPUSamplerImpl*>(rhs);
    }

    inline const SamplerBase* FromAPI(const WGPUSamplerImpl* rhs) {
        return reinterpret_cast<const SamplerBase*>(rhs);
    }

    inline SamplerBase* FromAPI(WGPUSamplerImpl* rhs) {
        return reinterpret_cast<SamplerBase*>(rhs);
    }
    inline const WGPUShaderModuleImpl* ToAPI(const ShaderModuleBase* rhs) {
        return reinterpret_cast<const WGPUShaderModuleImpl*>(rhs);
    }

    inline WGPUShaderModuleImpl* ToAPI(ShaderModuleBase* rhs) {
        return reinterpret_cast<WGPUShaderModuleImpl*>(rhs);
    }

    inline const ShaderModuleBase* FromAPI(const WGPUShaderModuleImpl* rhs) {
        return reinterpret_cast<const ShaderModuleBase*>(rhs);
    }

    inline ShaderModuleBase* FromAPI(WGPUShaderModuleImpl* rhs) {
        return reinterpret_cast<ShaderModuleBase*>(rhs);
    }
    inline const WGPUSurfaceImpl* ToAPI(const SurfaceBase* rhs) {
        return reinterpret_cast<const WGPUSurfaceImpl*>(rhs);
    }

    inline WGPUSurfaceImpl* ToAPI(SurfaceBase* rhs) {
        return reinterpret_cast<WGPUSurfaceImpl*>(rhs);
    }

    inline const SurfaceBase* FromAPI(const WGPUSurfaceImpl* rhs) {
        return reinterpret_cast<const SurfaceBase*>(rhs);
    }

    inline SurfaceBase* FromAPI(WGPUSurfaceImpl* rhs) {
        return reinterpret_cast<SurfaceBase*>(rhs);
    }
    inline const WGPUSwapChainImpl* ToAPI(const SwapChainBase* rhs) {
        return reinterpret_cast<const WGPUSwapChainImpl*>(rhs);
    }

    inline WGPUSwapChainImpl* ToAPI(SwapChainBase* rhs) {
        return reinterpret_cast<WGPUSwapChainImpl*>(rhs);
    }

    inline const SwapChainBase* FromAPI(const WGPUSwapChainImpl* rhs) {
        return reinterpret_cast<const SwapChainBase*>(rhs);
    }

    inline SwapChainBase* FromAPI(WGPUSwapChainImpl* rhs) {
        return reinterpret_cast<SwapChainBase*>(rhs);
    }
    inline const WGPUTextureImpl* ToAPI(const TextureBase* rhs) {
        return reinterpret_cast<const WGPUTextureImpl*>(rhs);
    }

    inline WGPUTextureImpl* ToAPI(TextureBase* rhs) {
        return reinterpret_cast<WGPUTextureImpl*>(rhs);
    }

    inline const TextureBase* FromAPI(const WGPUTextureImpl* rhs) {
        return reinterpret_cast<const TextureBase*>(rhs);
    }

    inline TextureBase* FromAPI(WGPUTextureImpl* rhs) {
        return reinterpret_cast<TextureBase*>(rhs);
    }
    inline const WGPUTextureViewImpl* ToAPI(const TextureViewBase* rhs) {
        return reinterpret_cast<const WGPUTextureViewImpl*>(rhs);
    }

    inline WGPUTextureViewImpl* ToAPI(TextureViewBase* rhs) {
        return reinterpret_cast<WGPUTextureViewImpl*>(rhs);
    }

    inline const TextureViewBase* FromAPI(const WGPUTextureViewImpl* rhs) {
        return reinterpret_cast<const TextureViewBase*>(rhs);
    }

    inline TextureViewBase* FromAPI(WGPUTextureViewImpl* rhs) {
        return reinterpret_cast<TextureViewBase*>(rhs);
    }

    template <typename T>
    struct EnumCount;

    template<>
    struct EnumCount<wgpu::AdapterType> {
        static constexpr uint32_t value = 4;
    };
    template<>
    struct EnumCount<wgpu::AddressMode> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::AlphaMode> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::BackendType> {
        static constexpr uint32_t value = 8;
    };
    template<>
    struct EnumCount<wgpu::BlendFactor> {
        static constexpr uint32_t value = 13;
    };
    template<>
    struct EnumCount<wgpu::BlendOperation> {
        static constexpr uint32_t value = 5;
    };
    template<>
    struct EnumCount<wgpu::BufferBindingType> {
        static constexpr uint32_t value = 4;
    };
    template<>
    struct EnumCount<wgpu::BufferMapAsyncStatus> {
        static constexpr uint32_t value = 6;
    };
    template<>
    struct EnumCount<wgpu::CompareFunction> {
        static constexpr uint32_t value = 9;
    };
    template<>
    struct EnumCount<wgpu::CompilationInfoRequestStatus> {
        static constexpr uint32_t value = 4;
    };
    template<>
    struct EnumCount<wgpu::CompilationMessageType> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::ComputePassTimestampLocation> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::CreatePipelineAsyncStatus> {
        static constexpr uint32_t value = 5;
    };
    template<>
    struct EnumCount<wgpu::CullMode> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::DeviceLostReason> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::ErrorFilter> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::ErrorType> {
        static constexpr uint32_t value = 5;
    };
    template<>
    struct EnumCount<wgpu::FilterMode> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::FrontFace> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::IndexFormat> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::LoadOp> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::LoggingType> {
        static constexpr uint32_t value = 4;
    };
    template<>
    struct EnumCount<wgpu::PipelineStatisticName> {
        static constexpr uint32_t value = 5;
    };
    template<>
    struct EnumCount<wgpu::PowerPreference> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::PredefinedColorSpace> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::PresentMode> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::PrimitiveTopology> {
        static constexpr uint32_t value = 5;
    };
    template<>
    struct EnumCount<wgpu::QueryType> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::QueueWorkDoneStatus> {
        static constexpr uint32_t value = 4;
    };
    template<>
    struct EnumCount<wgpu::RenderPassTimestampLocation> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::RequestAdapterStatus> {
        static constexpr uint32_t value = 4;
    };
    template<>
    struct EnumCount<wgpu::RequestDeviceStatus> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::SamplerBindingType> {
        static constexpr uint32_t value = 4;
    };
    template<>
    struct EnumCount<wgpu::StencilOperation> {
        static constexpr uint32_t value = 8;
    };
    template<>
    struct EnumCount<wgpu::StorageTextureAccess> {
        static constexpr uint32_t value = 2;
    };
    template<>
    struct EnumCount<wgpu::StoreOp> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::TextureAspect> {
        static constexpr uint32_t value = 5;
    };
    template<>
    struct EnumCount<wgpu::TextureComponentType> {
        static constexpr uint32_t value = 4;
    };
    template<>
    struct EnumCount<wgpu::TextureDimension> {
        static constexpr uint32_t value = 3;
    };
    template<>
    struct EnumCount<wgpu::TextureFormat> {
        static constexpr uint32_t value = 97;
    };
    template<>
    struct EnumCount<wgpu::TextureSampleType> {
        static constexpr uint32_t value = 6;
    };
    template<>
    struct EnumCount<wgpu::TextureViewDimension> {
        static constexpr uint32_t value = 7;
    };
    template<>
    struct EnumCount<wgpu::VertexFormat> {
        static constexpr uint32_t value = 31;
    };
    template<>
    struct EnumCount<wgpu::VertexStepMode> {
        static constexpr uint32_t value = 2;
    };
}

#endif  // DAWNNATIVE_DAWN_PLATFORM_AUTOGEN_H_
