
#ifndef DAWNNATIVE_OPENGL_OPENGLFUNCTIONSBASE_H_
#define DAWNNATIVE_OPENGL_OPENGLFUNCTIONSBASE_H_

#include "dawn/native/Error.h"
#include "dawn/native/opengl/opengl_platform.h"

namespace dawn::native::opengl {
    using GetProcAddress = void* (*) (const char*);

    struct OpenGLFunctionsBase {
      public:
        // OpenGL ES 2.0
        PFNGLACTIVETEXTUREPROC ActiveTexture = nullptr;
        PFNGLATTACHSHADERPROC AttachShader = nullptr;
        PFNGLBINDATTRIBLOCATIONPROC BindAttribLocation = nullptr;
        PFNGLBINDBUFFERPROC BindBuffer = nullptr;
        PFNGLBINDFRAMEBUFFERPROC BindFramebuffer = nullptr;
        PFNGLBINDRENDERBUFFERPROC BindRenderbuffer = nullptr;
        PFNGLBINDTEXTUREPROC BindTexture = nullptr;
        PFNGLBLENDCOLORPROC BlendColor = nullptr;
        PFNGLBLENDEQUATIONPROC BlendEquation = nullptr;
        PFNGLBLENDEQUATIONSEPARATEPROC BlendEquationSeparate = nullptr;
        PFNGLBLENDFUNCPROC BlendFunc = nullptr;
        PFNGLBLENDFUNCSEPARATEPROC BlendFuncSeparate = nullptr;
        PFNGLBUFFERDATAPROC BufferData = nullptr;
        PFNGLBUFFERSUBDATAPROC BufferSubData = nullptr;
        PFNGLCHECKFRAMEBUFFERSTATUSPROC CheckFramebufferStatus = nullptr;
        PFNGLCLEARPROC Clear = nullptr;
        PFNGLCLEARCOLORPROC ClearColor = nullptr;
        PFNGLCLEARDEPTHFPROC ClearDepthf = nullptr;
        PFNGLCLEARSTENCILPROC ClearStencil = nullptr;
        PFNGLCOLORMASKPROC ColorMask = nullptr;
        PFNGLCOMPILESHADERPROC CompileShader = nullptr;
        PFNGLCOMPRESSEDTEXIMAGE2DPROC CompressedTexImage2D = nullptr;
        PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC CompressedTexSubImage2D = nullptr;
        PFNGLCOPYTEXIMAGE2DPROC CopyTexImage2D = nullptr;
        PFNGLCOPYTEXSUBIMAGE2DPROC CopyTexSubImage2D = nullptr;
        PFNGLCREATEPROGRAMPROC CreateProgram = nullptr;
        PFNGLCREATESHADERPROC CreateShader = nullptr;
        PFNGLCULLFACEPROC CullFace = nullptr;
        PFNGLDELETEBUFFERSPROC DeleteBuffers = nullptr;
        PFNGLDELETEFRAMEBUFFERSPROC DeleteFramebuffers = nullptr;
        PFNGLDELETEPROGRAMPROC DeleteProgram = nullptr;
        PFNGLDELETERENDERBUFFERSPROC DeleteRenderbuffers = nullptr;
        PFNGLDELETESHADERPROC DeleteShader = nullptr;
        PFNGLDELETETEXTURESPROC DeleteTextures = nullptr;
        PFNGLDEPTHFUNCPROC DepthFunc = nullptr;
        PFNGLDEPTHMASKPROC DepthMask = nullptr;
        PFNGLDEPTHRANGEFPROC DepthRangef = nullptr;
        PFNGLDETACHSHADERPROC DetachShader = nullptr;
        PFNGLDISABLEPROC Disable = nullptr;
        PFNGLDISABLEVERTEXATTRIBARRAYPROC DisableVertexAttribArray = nullptr;
        PFNGLDRAWARRAYSPROC DrawArrays = nullptr;
        PFNGLDRAWELEMENTSPROC DrawElements = nullptr;
        PFNGLENABLEPROC Enable = nullptr;
        PFNGLENABLEVERTEXATTRIBARRAYPROC EnableVertexAttribArray = nullptr;
        PFNGLFINISHPROC Finish = nullptr;
        PFNGLFLUSHPROC Flush = nullptr;
        PFNGLFRAMEBUFFERRENDERBUFFERPROC FramebufferRenderbuffer = nullptr;
        PFNGLFRAMEBUFFERTEXTURE2DPROC FramebufferTexture2D = nullptr;
        PFNGLFRONTFACEPROC FrontFace = nullptr;
        PFNGLGENBUFFERSPROC GenBuffers = nullptr;
        PFNGLGENERATEMIPMAPPROC GenerateMipmap = nullptr;
        PFNGLGENFRAMEBUFFERSPROC GenFramebuffers = nullptr;
        PFNGLGENRENDERBUFFERSPROC GenRenderbuffers = nullptr;
        PFNGLGENTEXTURESPROC GenTextures = nullptr;
        PFNGLGETACTIVEATTRIBPROC GetActiveAttrib = nullptr;
        PFNGLGETACTIVEUNIFORMPROC GetActiveUniform = nullptr;
        PFNGLGETATTACHEDSHADERSPROC GetAttachedShaders = nullptr;
        PFNGLGETATTRIBLOCATIONPROC GetAttribLocation = nullptr;
        PFNGLGETBOOLEANVPROC GetBooleanv = nullptr;
        PFNGLGETBUFFERPARAMETERIVPROC GetBufferParameteriv = nullptr;
        PFNGLGETERRORPROC GetError = nullptr;
        PFNGLGETFLOATVPROC GetFloatv = nullptr;
        PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVPROC GetFramebufferAttachmentParameteriv = nullptr;
        PFNGLGETINTEGERVPROC GetIntegerv = nullptr;
        PFNGLGETPROGRAMIVPROC GetProgramiv = nullptr;
        PFNGLGETPROGRAMINFOLOGPROC GetProgramInfoLog = nullptr;
        PFNGLGETRENDERBUFFERPARAMETERIVPROC GetRenderbufferParameteriv = nullptr;
        PFNGLGETSHADERIVPROC GetShaderiv = nullptr;
        PFNGLGETSHADERINFOLOGPROC GetShaderInfoLog = nullptr;
        PFNGLGETSHADERPRECISIONFORMATPROC GetShaderPrecisionFormat = nullptr;
        PFNGLGETSHADERSOURCEPROC GetShaderSource = nullptr;
        PFNGLGETSTRINGPROC GetString = nullptr;
        PFNGLGETTEXPARAMETERFVPROC GetTexParameterfv = nullptr;
        PFNGLGETTEXPARAMETERIVPROC GetTexParameteriv = nullptr;
        PFNGLGETUNIFORMFVPROC GetUniformfv = nullptr;
        PFNGLGETUNIFORMIVPROC GetUniformiv = nullptr;
        PFNGLGETUNIFORMLOCATIONPROC GetUniformLocation = nullptr;
        PFNGLGETVERTEXATTRIBFVPROC GetVertexAttribfv = nullptr;
        PFNGLGETVERTEXATTRIBIVPROC GetVertexAttribiv = nullptr;
        PFNGLGETVERTEXATTRIBPOINTERVPROC GetVertexAttribPointerv = nullptr;
        PFNGLHINTPROC Hint = nullptr;
        PFNGLISBUFFERPROC IsBuffer = nullptr;
        PFNGLISENABLEDPROC IsEnabled = nullptr;
        PFNGLISFRAMEBUFFERPROC IsFramebuffer = nullptr;
        PFNGLISPROGRAMPROC IsProgram = nullptr;
        PFNGLISRENDERBUFFERPROC IsRenderbuffer = nullptr;
        PFNGLISSHADERPROC IsShader = nullptr;
        PFNGLISTEXTUREPROC IsTexture = nullptr;
        PFNGLLINEWIDTHPROC LineWidth = nullptr;
        PFNGLLINKPROGRAMPROC LinkProgram = nullptr;
        PFNGLPIXELSTOREIPROC PixelStorei = nullptr;
        PFNGLPOLYGONOFFSETPROC PolygonOffset = nullptr;
        PFNGLREADPIXELSPROC ReadPixels = nullptr;
        PFNGLRELEASESHADERCOMPILERPROC ReleaseShaderCompiler = nullptr;
        PFNGLRENDERBUFFERSTORAGEPROC RenderbufferStorage = nullptr;
        PFNGLSAMPLECOVERAGEPROC SampleCoverage = nullptr;
        PFNGLSCISSORPROC Scissor = nullptr;
        PFNGLSHADERBINARYPROC ShaderBinary = nullptr;
        PFNGLSHADERSOURCEPROC ShaderSource = nullptr;
        PFNGLSTENCILFUNCPROC StencilFunc = nullptr;
        PFNGLSTENCILFUNCSEPARATEPROC StencilFuncSeparate = nullptr;
        PFNGLSTENCILMASKPROC StencilMask = nullptr;
        PFNGLSTENCILMASKSEPARATEPROC StencilMaskSeparate = nullptr;
        PFNGLSTENCILOPPROC StencilOp = nullptr;
        PFNGLSTENCILOPSEPARATEPROC StencilOpSeparate = nullptr;
        PFNGLTEXIMAGE2DPROC TexImage2D = nullptr;
        PFNGLTEXPARAMETERFPROC TexParameterf = nullptr;
        PFNGLTEXPARAMETERFVPROC TexParameterfv = nullptr;
        PFNGLTEXPARAMETERIPROC TexParameteri = nullptr;
        PFNGLTEXPARAMETERIVPROC TexParameteriv = nullptr;
        PFNGLTEXSUBIMAGE2DPROC TexSubImage2D = nullptr;
        PFNGLUNIFORM1FPROC Uniform1f = nullptr;
        PFNGLUNIFORM1FVPROC Uniform1fv = nullptr;
        PFNGLUNIFORM1IPROC Uniform1i = nullptr;
        PFNGLUNIFORM1IVPROC Uniform1iv = nullptr;
        PFNGLUNIFORM2FPROC Uniform2f = nullptr;
        PFNGLUNIFORM2FVPROC Uniform2fv = nullptr;
        PFNGLUNIFORM2IPROC Uniform2i = nullptr;
        PFNGLUNIFORM2IVPROC Uniform2iv = nullptr;
        PFNGLUNIFORM3FPROC Uniform3f = nullptr;
        PFNGLUNIFORM3FVPROC Uniform3fv = nullptr;
        PFNGLUNIFORM3IPROC Uniform3i = nullptr;
        PFNGLUNIFORM3IVPROC Uniform3iv = nullptr;
        PFNGLUNIFORM4FPROC Uniform4f = nullptr;
        PFNGLUNIFORM4FVPROC Uniform4fv = nullptr;
        PFNGLUNIFORM4IPROC Uniform4i = nullptr;
        PFNGLUNIFORM4IVPROC Uniform4iv = nullptr;
        PFNGLUNIFORMMATRIX2FVPROC UniformMatrix2fv = nullptr;
        PFNGLUNIFORMMATRIX3FVPROC UniformMatrix3fv = nullptr;
        PFNGLUNIFORMMATRIX4FVPROC UniformMatrix4fv = nullptr;
        PFNGLUSEPROGRAMPROC UseProgram = nullptr;
        PFNGLVALIDATEPROGRAMPROC ValidateProgram = nullptr;
        PFNGLVERTEXATTRIB1FPROC VertexAttrib1f = nullptr;
        PFNGLVERTEXATTRIB1FVPROC VertexAttrib1fv = nullptr;
        PFNGLVERTEXATTRIB2FPROC VertexAttrib2f = nullptr;
        PFNGLVERTEXATTRIB2FVPROC VertexAttrib2fv = nullptr;
        PFNGLVERTEXATTRIB3FPROC VertexAttrib3f = nullptr;
        PFNGLVERTEXATTRIB3FVPROC VertexAttrib3fv = nullptr;
        PFNGLVERTEXATTRIB4FPROC VertexAttrib4f = nullptr;
        PFNGLVERTEXATTRIB4FVPROC VertexAttrib4fv = nullptr;
        PFNGLVERTEXATTRIBPOINTERPROC VertexAttribPointer = nullptr;
        PFNGLVIEWPORTPROC Viewport = nullptr;

        // OpenGL ES 3.0
        PFNGLREADBUFFERPROC ReadBuffer = nullptr;
        PFNGLDRAWRANGEELEMENTSPROC DrawRangeElements = nullptr;
        PFNGLTEXIMAGE3DPROC TexImage3D = nullptr;
        PFNGLTEXSUBIMAGE3DPROC TexSubImage3D = nullptr;
        PFNGLCOPYTEXSUBIMAGE3DPROC CopyTexSubImage3D = nullptr;
        PFNGLCOMPRESSEDTEXIMAGE3DPROC CompressedTexImage3D = nullptr;
        PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC CompressedTexSubImage3D = nullptr;
        PFNGLGENQUERIESPROC GenQueries = nullptr;
        PFNGLDELETEQUERIESPROC DeleteQueries = nullptr;
        PFNGLISQUERYPROC IsQuery = nullptr;
        PFNGLBEGINQUERYPROC BeginQuery = nullptr;
        PFNGLENDQUERYPROC EndQuery = nullptr;
        PFNGLGETQUERYIVPROC GetQueryiv = nullptr;
        PFNGLGETQUERYOBJECTUIVPROC GetQueryObjectuiv = nullptr;
        PFNGLUNMAPBUFFERPROC UnmapBuffer = nullptr;
        PFNGLGETBUFFERPOINTERVPROC GetBufferPointerv = nullptr;
        PFNGLDRAWBUFFERSPROC DrawBuffers = nullptr;
        PFNGLUNIFORMMATRIX2X3FVPROC UniformMatrix2x3fv = nullptr;
        PFNGLUNIFORMMATRIX3X2FVPROC UniformMatrix3x2fv = nullptr;
        PFNGLUNIFORMMATRIX2X4FVPROC UniformMatrix2x4fv = nullptr;
        PFNGLUNIFORMMATRIX4X2FVPROC UniformMatrix4x2fv = nullptr;
        PFNGLUNIFORMMATRIX3X4FVPROC UniformMatrix3x4fv = nullptr;
        PFNGLUNIFORMMATRIX4X3FVPROC UniformMatrix4x3fv = nullptr;
        PFNGLBLITFRAMEBUFFERPROC BlitFramebuffer = nullptr;
        PFNGLRENDERBUFFERSTORAGEMULTISAMPLEPROC RenderbufferStorageMultisample = nullptr;
        PFNGLFRAMEBUFFERTEXTURELAYERPROC FramebufferTextureLayer = nullptr;
        PFNGLMAPBUFFERRANGEPROC MapBufferRange = nullptr;
        PFNGLFLUSHMAPPEDBUFFERRANGEPROC FlushMappedBufferRange = nullptr;
        PFNGLBINDVERTEXARRAYPROC BindVertexArray = nullptr;
        PFNGLDELETEVERTEXARRAYSPROC DeleteVertexArrays = nullptr;
        PFNGLGENVERTEXARRAYSPROC GenVertexArrays = nullptr;
        PFNGLISVERTEXARRAYPROC IsVertexArray = nullptr;
        PFNGLGETINTEGERI_VPROC GetIntegeri_v = nullptr;
        PFNGLBEGINTRANSFORMFEEDBACKPROC BeginTransformFeedback = nullptr;
        PFNGLENDTRANSFORMFEEDBACKPROC EndTransformFeedback = nullptr;
        PFNGLBINDBUFFERRANGEPROC BindBufferRange = nullptr;
        PFNGLBINDBUFFERBASEPROC BindBufferBase = nullptr;
        PFNGLTRANSFORMFEEDBACKVARYINGSPROC TransformFeedbackVaryings = nullptr;
        PFNGLGETTRANSFORMFEEDBACKVARYINGPROC GetTransformFeedbackVarying = nullptr;
        PFNGLVERTEXATTRIBIPOINTERPROC VertexAttribIPointer = nullptr;
        PFNGLGETVERTEXATTRIBIIVPROC GetVertexAttribIiv = nullptr;
        PFNGLGETVERTEXATTRIBIUIVPROC GetVertexAttribIuiv = nullptr;
        PFNGLVERTEXATTRIBI4IPROC VertexAttribI4i = nullptr;
        PFNGLVERTEXATTRIBI4UIPROC VertexAttribI4ui = nullptr;
        PFNGLVERTEXATTRIBI4IVPROC VertexAttribI4iv = nullptr;
        PFNGLVERTEXATTRIBI4UIVPROC VertexAttribI4uiv = nullptr;
        PFNGLGETUNIFORMUIVPROC GetUniformuiv = nullptr;
        PFNGLGETFRAGDATALOCATIONPROC GetFragDataLocation = nullptr;
        PFNGLUNIFORM1UIPROC Uniform1ui = nullptr;
        PFNGLUNIFORM2UIPROC Uniform2ui = nullptr;
        PFNGLUNIFORM3UIPROC Uniform3ui = nullptr;
        PFNGLUNIFORM4UIPROC Uniform4ui = nullptr;
        PFNGLUNIFORM1UIVPROC Uniform1uiv = nullptr;
        PFNGLUNIFORM2UIVPROC Uniform2uiv = nullptr;
        PFNGLUNIFORM3UIVPROC Uniform3uiv = nullptr;
        PFNGLUNIFORM4UIVPROC Uniform4uiv = nullptr;
        PFNGLCLEARBUFFERIVPROC ClearBufferiv = nullptr;
        PFNGLCLEARBUFFERUIVPROC ClearBufferuiv = nullptr;
        PFNGLCLEARBUFFERFVPROC ClearBufferfv = nullptr;
        PFNGLCLEARBUFFERFIPROC ClearBufferfi = nullptr;
        PFNGLGETSTRINGIPROC GetStringi = nullptr;
        PFNGLCOPYBUFFERSUBDATAPROC CopyBufferSubData = nullptr;
        PFNGLGETUNIFORMINDICESPROC GetUniformIndices = nullptr;
        PFNGLGETACTIVEUNIFORMSIVPROC GetActiveUniformsiv = nullptr;
        PFNGLGETUNIFORMBLOCKINDEXPROC GetUniformBlockIndex = nullptr;
        PFNGLGETACTIVEUNIFORMBLOCKIVPROC GetActiveUniformBlockiv = nullptr;
        PFNGLGETACTIVEUNIFORMBLOCKNAMEPROC GetActiveUniformBlockName = nullptr;
        PFNGLUNIFORMBLOCKBINDINGPROC UniformBlockBinding = nullptr;
        PFNGLDRAWARRAYSINSTANCEDPROC DrawArraysInstanced = nullptr;
        PFNGLDRAWELEMENTSINSTANCEDPROC DrawElementsInstanced = nullptr;
        PFNGLFENCESYNCPROC FenceSync = nullptr;
        PFNGLISSYNCPROC IsSync = nullptr;
        PFNGLDELETESYNCPROC DeleteSync = nullptr;
        PFNGLCLIENTWAITSYNCPROC ClientWaitSync = nullptr;
        PFNGLWAITSYNCPROC WaitSync = nullptr;
        PFNGLGETINTEGER64VPROC GetInteger64v = nullptr;
        PFNGLGETSYNCIVPROC GetSynciv = nullptr;
        PFNGLGETINTEGER64I_VPROC GetInteger64i_v = nullptr;
        PFNGLGETBUFFERPARAMETERI64VPROC GetBufferParameteri64v = nullptr;
        PFNGLGENSAMPLERSPROC GenSamplers = nullptr;
        PFNGLDELETESAMPLERSPROC DeleteSamplers = nullptr;
        PFNGLISSAMPLERPROC IsSampler = nullptr;
        PFNGLBINDSAMPLERPROC BindSampler = nullptr;
        PFNGLSAMPLERPARAMETERIPROC SamplerParameteri = nullptr;
        PFNGLSAMPLERPARAMETERIVPROC SamplerParameteriv = nullptr;
        PFNGLSAMPLERPARAMETERFPROC SamplerParameterf = nullptr;
        PFNGLSAMPLERPARAMETERFVPROC SamplerParameterfv = nullptr;
        PFNGLGETSAMPLERPARAMETERIVPROC GetSamplerParameteriv = nullptr;
        PFNGLGETSAMPLERPARAMETERFVPROC GetSamplerParameterfv = nullptr;
        PFNGLVERTEXATTRIBDIVISORPROC VertexAttribDivisor = nullptr;
        PFNGLBINDTRANSFORMFEEDBACKPROC BindTransformFeedback = nullptr;
        PFNGLDELETETRANSFORMFEEDBACKSPROC DeleteTransformFeedbacks = nullptr;
        PFNGLGENTRANSFORMFEEDBACKSPROC GenTransformFeedbacks = nullptr;
        PFNGLISTRANSFORMFEEDBACKPROC IsTransformFeedback = nullptr;
        PFNGLPAUSETRANSFORMFEEDBACKPROC PauseTransformFeedback = nullptr;
        PFNGLRESUMETRANSFORMFEEDBACKPROC ResumeTransformFeedback = nullptr;
        PFNGLGETPROGRAMBINARYPROC GetProgramBinary = nullptr;
        PFNGLPROGRAMBINARYPROC ProgramBinary = nullptr;
        PFNGLPROGRAMPARAMETERIPROC ProgramParameteri = nullptr;
        PFNGLINVALIDATEFRAMEBUFFERPROC InvalidateFramebuffer = nullptr;
        PFNGLINVALIDATESUBFRAMEBUFFERPROC InvalidateSubFramebuffer = nullptr;
        PFNGLTEXSTORAGE2DPROC TexStorage2D = nullptr;
        PFNGLTEXSTORAGE3DPROC TexStorage3D = nullptr;
        PFNGLGETINTERNALFORMATIVPROC GetInternalformativ = nullptr;

        // OpenGL ES 3.1
        PFNGLDISPATCHCOMPUTEPROC DispatchCompute = nullptr;
        PFNGLDISPATCHCOMPUTEINDIRECTPROC DispatchComputeIndirect = nullptr;
        PFNGLDRAWARRAYSINDIRECTPROC DrawArraysIndirect = nullptr;
        PFNGLDRAWELEMENTSINDIRECTPROC DrawElementsIndirect = nullptr;
        PFNGLFRAMEBUFFERPARAMETERIPROC FramebufferParameteri = nullptr;
        PFNGLGETFRAMEBUFFERPARAMETERIVPROC GetFramebufferParameteriv = nullptr;
        PFNGLGETPROGRAMINTERFACEIVPROC GetProgramInterfaceiv = nullptr;
        PFNGLGETPROGRAMRESOURCEINDEXPROC GetProgramResourceIndex = nullptr;
        PFNGLGETPROGRAMRESOURCENAMEPROC GetProgramResourceName = nullptr;
        PFNGLGETPROGRAMRESOURCEIVPROC GetProgramResourceiv = nullptr;
        PFNGLGETPROGRAMRESOURCELOCATIONPROC GetProgramResourceLocation = nullptr;
        PFNGLUSEPROGRAMSTAGESPROC UseProgramStages = nullptr;
        PFNGLACTIVESHADERPROGRAMPROC ActiveShaderProgram = nullptr;
        PFNGLCREATESHADERPROGRAMVPROC CreateShaderProgramv = nullptr;
        PFNGLBINDPROGRAMPIPELINEPROC BindProgramPipeline = nullptr;
        PFNGLDELETEPROGRAMPIPELINESPROC DeleteProgramPipelines = nullptr;
        PFNGLGENPROGRAMPIPELINESPROC GenProgramPipelines = nullptr;
        PFNGLISPROGRAMPIPELINEPROC IsProgramPipeline = nullptr;
        PFNGLGETPROGRAMPIPELINEIVPROC GetProgramPipelineiv = nullptr;
        PFNGLPROGRAMUNIFORM1IPROC ProgramUniform1i = nullptr;
        PFNGLPROGRAMUNIFORM2IPROC ProgramUniform2i = nullptr;
        PFNGLPROGRAMUNIFORM3IPROC ProgramUniform3i = nullptr;
        PFNGLPROGRAMUNIFORM4IPROC ProgramUniform4i = nullptr;
        PFNGLPROGRAMUNIFORM1UIPROC ProgramUniform1ui = nullptr;
        PFNGLPROGRAMUNIFORM2UIPROC ProgramUniform2ui = nullptr;
        PFNGLPROGRAMUNIFORM3UIPROC ProgramUniform3ui = nullptr;
        PFNGLPROGRAMUNIFORM4UIPROC ProgramUniform4ui = nullptr;
        PFNGLPROGRAMUNIFORM1FPROC ProgramUniform1f = nullptr;
        PFNGLPROGRAMUNIFORM2FPROC ProgramUniform2f = nullptr;
        PFNGLPROGRAMUNIFORM3FPROC ProgramUniform3f = nullptr;
        PFNGLPROGRAMUNIFORM4FPROC ProgramUniform4f = nullptr;
        PFNGLPROGRAMUNIFORM1IVPROC ProgramUniform1iv = nullptr;
        PFNGLPROGRAMUNIFORM2IVPROC ProgramUniform2iv = nullptr;
        PFNGLPROGRAMUNIFORM3IVPROC ProgramUniform3iv = nullptr;
        PFNGLPROGRAMUNIFORM4IVPROC ProgramUniform4iv = nullptr;
        PFNGLPROGRAMUNIFORM1UIVPROC ProgramUniform1uiv = nullptr;
        PFNGLPROGRAMUNIFORM2UIVPROC ProgramUniform2uiv = nullptr;
        PFNGLPROGRAMUNIFORM3UIVPROC ProgramUniform3uiv = nullptr;
        PFNGLPROGRAMUNIFORM4UIVPROC ProgramUniform4uiv = nullptr;
        PFNGLPROGRAMUNIFORM1FVPROC ProgramUniform1fv = nullptr;
        PFNGLPROGRAMUNIFORM2FVPROC ProgramUniform2fv = nullptr;
        PFNGLPROGRAMUNIFORM3FVPROC ProgramUniform3fv = nullptr;
        PFNGLPROGRAMUNIFORM4FVPROC ProgramUniform4fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX2FVPROC ProgramUniformMatrix2fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX3FVPROC ProgramUniformMatrix3fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX4FVPROC ProgramUniformMatrix4fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX2X3FVPROC ProgramUniformMatrix2x3fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX3X2FVPROC ProgramUniformMatrix3x2fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX2X4FVPROC ProgramUniformMatrix2x4fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX4X2FVPROC ProgramUniformMatrix4x2fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX3X4FVPROC ProgramUniformMatrix3x4fv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX4X3FVPROC ProgramUniformMatrix4x3fv = nullptr;
        PFNGLVALIDATEPROGRAMPIPELINEPROC ValidateProgramPipeline = nullptr;
        PFNGLGETPROGRAMPIPELINEINFOLOGPROC GetProgramPipelineInfoLog = nullptr;
        PFNGLBINDIMAGETEXTUREPROC BindImageTexture = nullptr;
        PFNGLGETBOOLEANI_VPROC GetBooleani_v = nullptr;
        PFNGLMEMORYBARRIERPROC MemoryBarrier = nullptr;
        PFNGLMEMORYBARRIERBYREGIONPROC MemoryBarrierByRegion = nullptr;
        PFNGLTEXSTORAGE2DMULTISAMPLEPROC TexStorage2DMultisample = nullptr;
        PFNGLGETMULTISAMPLEFVPROC GetMultisamplefv = nullptr;
        PFNGLSAMPLEMASKIPROC SampleMaski = nullptr;
        PFNGLGETTEXLEVELPARAMETERIVPROC GetTexLevelParameteriv = nullptr;
        PFNGLGETTEXLEVELPARAMETERFVPROC GetTexLevelParameterfv = nullptr;
        PFNGLBINDVERTEXBUFFERPROC BindVertexBuffer = nullptr;
        PFNGLVERTEXATTRIBFORMATPROC VertexAttribFormat = nullptr;
        PFNGLVERTEXATTRIBIFORMATPROC VertexAttribIFormat = nullptr;
        PFNGLVERTEXATTRIBBINDINGPROC VertexAttribBinding = nullptr;
        PFNGLVERTEXBINDINGDIVISORPROC VertexBindingDivisor = nullptr;

        // OpenGL ES 3.2
        PFNGLBLENDBARRIERPROC BlendBarrier = nullptr;
        PFNGLCOPYIMAGESUBDATAPROC CopyImageSubData = nullptr;
        PFNGLDEBUGMESSAGECONTROLPROC DebugMessageControl = nullptr;
        PFNGLDEBUGMESSAGEINSERTPROC DebugMessageInsert = nullptr;
        PFNGLDEBUGMESSAGECALLBACKPROC DebugMessageCallback = nullptr;
        PFNGLGETDEBUGMESSAGELOGPROC GetDebugMessageLog = nullptr;
        PFNGLPUSHDEBUGGROUPPROC PushDebugGroup = nullptr;
        PFNGLPOPDEBUGGROUPPROC PopDebugGroup = nullptr;
        PFNGLOBJECTLABELPROC ObjectLabel = nullptr;
        PFNGLGETOBJECTLABELPROC GetObjectLabel = nullptr;
        PFNGLOBJECTPTRLABELPROC ObjectPtrLabel = nullptr;
        PFNGLGETOBJECTPTRLABELPROC GetObjectPtrLabel = nullptr;
        PFNGLGETPOINTERVPROC GetPointerv = nullptr;
        PFNGLENABLEIPROC Enablei = nullptr;
        PFNGLDISABLEIPROC Disablei = nullptr;
        PFNGLBLENDEQUATIONIPROC BlendEquationi = nullptr;
        PFNGLBLENDEQUATIONSEPARATEIPROC BlendEquationSeparatei = nullptr;
        PFNGLBLENDFUNCIPROC BlendFunci = nullptr;
        PFNGLBLENDFUNCSEPARATEIPROC BlendFuncSeparatei = nullptr;
        PFNGLCOLORMASKIPROC ColorMaski = nullptr;
        PFNGLISENABLEDIPROC IsEnabledi = nullptr;
        PFNGLDRAWELEMENTSBASEVERTEXPROC DrawElementsBaseVertex = nullptr;
        PFNGLDRAWRANGEELEMENTSBASEVERTEXPROC DrawRangeElementsBaseVertex = nullptr;
        PFNGLDRAWELEMENTSINSTANCEDBASEVERTEXPROC DrawElementsInstancedBaseVertex = nullptr;
        PFNGLFRAMEBUFFERTEXTUREPROC FramebufferTexture = nullptr;
        PFNGLPRIMITIVEBOUNDINGBOXPROC PrimitiveBoundingBox = nullptr;
        PFNGLGETGRAPHICSRESETSTATUSPROC GetGraphicsResetStatus = nullptr;
        PFNGLREADNPIXELSPROC ReadnPixels = nullptr;
        PFNGLGETNUNIFORMFVPROC GetnUniformfv = nullptr;
        PFNGLGETNUNIFORMIVPROC GetnUniformiv = nullptr;
        PFNGLGETNUNIFORMUIVPROC GetnUniformuiv = nullptr;
        PFNGLMINSAMPLESHADINGPROC MinSampleShading = nullptr;
        PFNGLPATCHPARAMETERIPROC PatchParameteri = nullptr;
        PFNGLTEXPARAMETERIIVPROC TexParameterIiv = nullptr;
        PFNGLTEXPARAMETERIUIVPROC TexParameterIuiv = nullptr;
        PFNGLGETTEXPARAMETERIIVPROC GetTexParameterIiv = nullptr;
        PFNGLGETTEXPARAMETERIUIVPROC GetTexParameterIuiv = nullptr;
        PFNGLSAMPLERPARAMETERIIVPROC SamplerParameterIiv = nullptr;
        PFNGLSAMPLERPARAMETERIUIVPROC SamplerParameterIuiv = nullptr;
        PFNGLGETSAMPLERPARAMETERIIVPROC GetSamplerParameterIiv = nullptr;
        PFNGLGETSAMPLERPARAMETERIUIVPROC GetSamplerParameterIuiv = nullptr;
        PFNGLTEXBUFFERPROC TexBuffer = nullptr;
        PFNGLTEXBUFFERRANGEPROC TexBufferRange = nullptr;
        PFNGLTEXSTORAGE3DMULTISAMPLEPROC TexStorage3DMultisample = nullptr;

        // Desktop OpenGL 1.0
        PFNGLPOINTSIZEPROC PointSize = nullptr;
        PFNGLPOLYGONMODEPROC PolygonMode = nullptr;
        PFNGLTEXIMAGE1DPROC TexImage1D = nullptr;
        PFNGLDRAWBUFFERPROC DrawBuffer = nullptr;
        PFNGLCLEARDEPTHPROC ClearDepth = nullptr;
        PFNGLLOGICOPPROC LogicOp = nullptr;
        PFNGLPIXELSTOREFPROC PixelStoref = nullptr;
        PFNGLGETDOUBLEVPROC GetDoublev = nullptr;
        PFNGLGETTEXIMAGEPROC GetTexImage = nullptr;
        PFNGLDEPTHRANGEPROC DepthRange = nullptr;

        // Desktop OpenGL 1.1
        PFNGLCOPYTEXIMAGE1DPROC CopyTexImage1D = nullptr;
        PFNGLCOPYTEXSUBIMAGE1DPROC CopyTexSubImage1D = nullptr;
        PFNGLTEXSUBIMAGE1DPROC TexSubImage1D = nullptr;

        // Desktop OpenGL 1.2

        // Desktop OpenGL 1.3
        PFNGLCOMPRESSEDTEXIMAGE1DPROC CompressedTexImage1D = nullptr;
        PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC CompressedTexSubImage1D = nullptr;
        PFNGLGETCOMPRESSEDTEXIMAGEPROC GetCompressedTexImage = nullptr;

        // Desktop OpenGL 1.4
        PFNGLMULTIDRAWARRAYSPROC MultiDrawArrays = nullptr;
        PFNGLMULTIDRAWELEMENTSPROC MultiDrawElements = nullptr;
        PFNGLPOINTPARAMETERFPROC PointParameterf = nullptr;
        PFNGLPOINTPARAMETERFVPROC PointParameterfv = nullptr;
        PFNGLPOINTPARAMETERIPROC PointParameteri = nullptr;
        PFNGLPOINTPARAMETERIVPROC PointParameteriv = nullptr;

        // Desktop OpenGL 1.5
        PFNGLGETQUERYOBJECTIVPROC GetQueryObjectiv = nullptr;
        PFNGLGETBUFFERSUBDATAPROC GetBufferSubData = nullptr;
        PFNGLMAPBUFFERPROC MapBuffer = nullptr;

        // Desktop OpenGL 2.0
        PFNGLGETVERTEXATTRIBDVPROC GetVertexAttribdv = nullptr;
        PFNGLVERTEXATTRIB1DPROC VertexAttrib1d = nullptr;
        PFNGLVERTEXATTRIB1DVPROC VertexAttrib1dv = nullptr;
        PFNGLVERTEXATTRIB1SPROC VertexAttrib1s = nullptr;
        PFNGLVERTEXATTRIB1SVPROC VertexAttrib1sv = nullptr;
        PFNGLVERTEXATTRIB2DPROC VertexAttrib2d = nullptr;
        PFNGLVERTEXATTRIB2DVPROC VertexAttrib2dv = nullptr;
        PFNGLVERTEXATTRIB2SPROC VertexAttrib2s = nullptr;
        PFNGLVERTEXATTRIB2SVPROC VertexAttrib2sv = nullptr;
        PFNGLVERTEXATTRIB3DPROC VertexAttrib3d = nullptr;
        PFNGLVERTEXATTRIB3DVPROC VertexAttrib3dv = nullptr;
        PFNGLVERTEXATTRIB3SPROC VertexAttrib3s = nullptr;
        PFNGLVERTEXATTRIB3SVPROC VertexAttrib3sv = nullptr;
        PFNGLVERTEXATTRIB4NBVPROC VertexAttrib4Nbv = nullptr;
        PFNGLVERTEXATTRIB4NIVPROC VertexAttrib4Niv = nullptr;
        PFNGLVERTEXATTRIB4NSVPROC VertexAttrib4Nsv = nullptr;
        PFNGLVERTEXATTRIB4NUBPROC VertexAttrib4Nub = nullptr;
        PFNGLVERTEXATTRIB4NUBVPROC VertexAttrib4Nubv = nullptr;
        PFNGLVERTEXATTRIB4NUIVPROC VertexAttrib4Nuiv = nullptr;
        PFNGLVERTEXATTRIB4NUSVPROC VertexAttrib4Nusv = nullptr;
        PFNGLVERTEXATTRIB4BVPROC VertexAttrib4bv = nullptr;
        PFNGLVERTEXATTRIB4DPROC VertexAttrib4d = nullptr;
        PFNGLVERTEXATTRIB4DVPROC VertexAttrib4dv = nullptr;
        PFNGLVERTEXATTRIB4IVPROC VertexAttrib4iv = nullptr;
        PFNGLVERTEXATTRIB4SPROC VertexAttrib4s = nullptr;
        PFNGLVERTEXATTRIB4SVPROC VertexAttrib4sv = nullptr;
        PFNGLVERTEXATTRIB4UBVPROC VertexAttrib4ubv = nullptr;
        PFNGLVERTEXATTRIB4UIVPROC VertexAttrib4uiv = nullptr;
        PFNGLVERTEXATTRIB4USVPROC VertexAttrib4usv = nullptr;

        // Desktop OpenGL 2.1

        // Desktop OpenGL 3.0
        PFNGLCLAMPCOLORPROC ClampColor = nullptr;
        PFNGLBEGINCONDITIONALRENDERPROC BeginConditionalRender = nullptr;
        PFNGLENDCONDITIONALRENDERPROC EndConditionalRender = nullptr;
        PFNGLVERTEXATTRIBI1IPROC VertexAttribI1i = nullptr;
        PFNGLVERTEXATTRIBI2IPROC VertexAttribI2i = nullptr;
        PFNGLVERTEXATTRIBI3IPROC VertexAttribI3i = nullptr;
        PFNGLVERTEXATTRIBI1UIPROC VertexAttribI1ui = nullptr;
        PFNGLVERTEXATTRIBI2UIPROC VertexAttribI2ui = nullptr;
        PFNGLVERTEXATTRIBI3UIPROC VertexAttribI3ui = nullptr;
        PFNGLVERTEXATTRIBI1IVPROC VertexAttribI1iv = nullptr;
        PFNGLVERTEXATTRIBI2IVPROC VertexAttribI2iv = nullptr;
        PFNGLVERTEXATTRIBI3IVPROC VertexAttribI3iv = nullptr;
        PFNGLVERTEXATTRIBI1UIVPROC VertexAttribI1uiv = nullptr;
        PFNGLVERTEXATTRIBI2UIVPROC VertexAttribI2uiv = nullptr;
        PFNGLVERTEXATTRIBI3UIVPROC VertexAttribI3uiv = nullptr;
        PFNGLVERTEXATTRIBI4BVPROC VertexAttribI4bv = nullptr;
        PFNGLVERTEXATTRIBI4SVPROC VertexAttribI4sv = nullptr;
        PFNGLVERTEXATTRIBI4UBVPROC VertexAttribI4ubv = nullptr;
        PFNGLVERTEXATTRIBI4USVPROC VertexAttribI4usv = nullptr;
        PFNGLBINDFRAGDATALOCATIONPROC BindFragDataLocation = nullptr;
        PFNGLFRAMEBUFFERTEXTURE1DPROC FramebufferTexture1D = nullptr;
        PFNGLFRAMEBUFFERTEXTURE3DPROC FramebufferTexture3D = nullptr;

        // Desktop OpenGL 3.1
        PFNGLPRIMITIVERESTARTINDEXPROC PrimitiveRestartIndex = nullptr;
        PFNGLGETACTIVEUNIFORMNAMEPROC GetActiveUniformName = nullptr;

        // Desktop OpenGL 3.2
        PFNGLMULTIDRAWELEMENTSBASEVERTEXPROC MultiDrawElementsBaseVertex = nullptr;
        PFNGLPROVOKINGVERTEXPROC ProvokingVertex = nullptr;
        PFNGLTEXIMAGE2DMULTISAMPLEPROC TexImage2DMultisample = nullptr;
        PFNGLTEXIMAGE3DMULTISAMPLEPROC TexImage3DMultisample = nullptr;

        // Desktop OpenGL 3.3
        PFNGLBINDFRAGDATALOCATIONINDEXEDPROC BindFragDataLocationIndexed = nullptr;
        PFNGLGETFRAGDATAINDEXPROC GetFragDataIndex = nullptr;
        PFNGLQUERYCOUNTERPROC QueryCounter = nullptr;
        PFNGLGETQUERYOBJECTI64VPROC GetQueryObjecti64v = nullptr;
        PFNGLGETQUERYOBJECTUI64VPROC GetQueryObjectui64v = nullptr;
        PFNGLVERTEXATTRIBP1UIPROC VertexAttribP1ui = nullptr;
        PFNGLVERTEXATTRIBP1UIVPROC VertexAttribP1uiv = nullptr;
        PFNGLVERTEXATTRIBP2UIPROC VertexAttribP2ui = nullptr;
        PFNGLVERTEXATTRIBP2UIVPROC VertexAttribP2uiv = nullptr;
        PFNGLVERTEXATTRIBP3UIPROC VertexAttribP3ui = nullptr;
        PFNGLVERTEXATTRIBP3UIVPROC VertexAttribP3uiv = nullptr;
        PFNGLVERTEXATTRIBP4UIPROC VertexAttribP4ui = nullptr;
        PFNGLVERTEXATTRIBP4UIVPROC VertexAttribP4uiv = nullptr;
        PFNGLVERTEXP2UIPROC VertexP2ui = nullptr;
        PFNGLVERTEXP2UIVPROC VertexP2uiv = nullptr;
        PFNGLVERTEXP3UIPROC VertexP3ui = nullptr;
        PFNGLVERTEXP3UIVPROC VertexP3uiv = nullptr;
        PFNGLVERTEXP4UIPROC VertexP4ui = nullptr;
        PFNGLVERTEXP4UIVPROC VertexP4uiv = nullptr;
        PFNGLTEXCOORDP1UIPROC TexCoordP1ui = nullptr;
        PFNGLTEXCOORDP1UIVPROC TexCoordP1uiv = nullptr;
        PFNGLTEXCOORDP2UIPROC TexCoordP2ui = nullptr;
        PFNGLTEXCOORDP2UIVPROC TexCoordP2uiv = nullptr;
        PFNGLTEXCOORDP3UIPROC TexCoordP3ui = nullptr;
        PFNGLTEXCOORDP3UIVPROC TexCoordP3uiv = nullptr;
        PFNGLTEXCOORDP4UIPROC TexCoordP4ui = nullptr;
        PFNGLTEXCOORDP4UIVPROC TexCoordP4uiv = nullptr;
        PFNGLMULTITEXCOORDP1UIPROC MultiTexCoordP1ui = nullptr;
        PFNGLMULTITEXCOORDP1UIVPROC MultiTexCoordP1uiv = nullptr;
        PFNGLMULTITEXCOORDP2UIPROC MultiTexCoordP2ui = nullptr;
        PFNGLMULTITEXCOORDP2UIVPROC MultiTexCoordP2uiv = nullptr;
        PFNGLMULTITEXCOORDP3UIPROC MultiTexCoordP3ui = nullptr;
        PFNGLMULTITEXCOORDP3UIVPROC MultiTexCoordP3uiv = nullptr;
        PFNGLMULTITEXCOORDP4UIPROC MultiTexCoordP4ui = nullptr;
        PFNGLMULTITEXCOORDP4UIVPROC MultiTexCoordP4uiv = nullptr;
        PFNGLNORMALP3UIPROC NormalP3ui = nullptr;
        PFNGLNORMALP3UIVPROC NormalP3uiv = nullptr;
        PFNGLCOLORP3UIPROC ColorP3ui = nullptr;
        PFNGLCOLORP3UIVPROC ColorP3uiv = nullptr;
        PFNGLCOLORP4UIPROC ColorP4ui = nullptr;
        PFNGLCOLORP4UIVPROC ColorP4uiv = nullptr;
        PFNGLSECONDARYCOLORP3UIPROC SecondaryColorP3ui = nullptr;
        PFNGLSECONDARYCOLORP3UIVPROC SecondaryColorP3uiv = nullptr;

        // Desktop OpenGL 4.0
        PFNGLUNIFORM1DPROC Uniform1d = nullptr;
        PFNGLUNIFORM2DPROC Uniform2d = nullptr;
        PFNGLUNIFORM3DPROC Uniform3d = nullptr;
        PFNGLUNIFORM4DPROC Uniform4d = nullptr;
        PFNGLUNIFORM1DVPROC Uniform1dv = nullptr;
        PFNGLUNIFORM2DVPROC Uniform2dv = nullptr;
        PFNGLUNIFORM3DVPROC Uniform3dv = nullptr;
        PFNGLUNIFORM4DVPROC Uniform4dv = nullptr;
        PFNGLUNIFORMMATRIX2DVPROC UniformMatrix2dv = nullptr;
        PFNGLUNIFORMMATRIX3DVPROC UniformMatrix3dv = nullptr;
        PFNGLUNIFORMMATRIX4DVPROC UniformMatrix4dv = nullptr;
        PFNGLUNIFORMMATRIX2X3DVPROC UniformMatrix2x3dv = nullptr;
        PFNGLUNIFORMMATRIX2X4DVPROC UniformMatrix2x4dv = nullptr;
        PFNGLUNIFORMMATRIX3X2DVPROC UniformMatrix3x2dv = nullptr;
        PFNGLUNIFORMMATRIX3X4DVPROC UniformMatrix3x4dv = nullptr;
        PFNGLUNIFORMMATRIX4X2DVPROC UniformMatrix4x2dv = nullptr;
        PFNGLUNIFORMMATRIX4X3DVPROC UniformMatrix4x3dv = nullptr;
        PFNGLGETUNIFORMDVPROC GetUniformdv = nullptr;
        PFNGLGETSUBROUTINEUNIFORMLOCATIONPROC GetSubroutineUniformLocation = nullptr;
        PFNGLGETSUBROUTINEINDEXPROC GetSubroutineIndex = nullptr;
        PFNGLGETACTIVESUBROUTINEUNIFORMIVPROC GetActiveSubroutineUniformiv = nullptr;
        PFNGLGETACTIVESUBROUTINEUNIFORMNAMEPROC GetActiveSubroutineUniformName = nullptr;
        PFNGLGETACTIVESUBROUTINENAMEPROC GetActiveSubroutineName = nullptr;
        PFNGLUNIFORMSUBROUTINESUIVPROC UniformSubroutinesuiv = nullptr;
        PFNGLGETUNIFORMSUBROUTINEUIVPROC GetUniformSubroutineuiv = nullptr;
        PFNGLGETPROGRAMSTAGEIVPROC GetProgramStageiv = nullptr;
        PFNGLPATCHPARAMETERFVPROC PatchParameterfv = nullptr;
        PFNGLDRAWTRANSFORMFEEDBACKPROC DrawTransformFeedback = nullptr;
        PFNGLDRAWTRANSFORMFEEDBACKSTREAMPROC DrawTransformFeedbackStream = nullptr;
        PFNGLBEGINQUERYINDEXEDPROC BeginQueryIndexed = nullptr;
        PFNGLENDQUERYINDEXEDPROC EndQueryIndexed = nullptr;
        PFNGLGETQUERYINDEXEDIVPROC GetQueryIndexediv = nullptr;

        // Desktop OpenGL 4.1
        PFNGLPROGRAMUNIFORM1DPROC ProgramUniform1d = nullptr;
        PFNGLPROGRAMUNIFORM1DVPROC ProgramUniform1dv = nullptr;
        PFNGLPROGRAMUNIFORM2DPROC ProgramUniform2d = nullptr;
        PFNGLPROGRAMUNIFORM2DVPROC ProgramUniform2dv = nullptr;
        PFNGLPROGRAMUNIFORM3DPROC ProgramUniform3d = nullptr;
        PFNGLPROGRAMUNIFORM3DVPROC ProgramUniform3dv = nullptr;
        PFNGLPROGRAMUNIFORM4DPROC ProgramUniform4d = nullptr;
        PFNGLPROGRAMUNIFORM4DVPROC ProgramUniform4dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX2DVPROC ProgramUniformMatrix2dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX3DVPROC ProgramUniformMatrix3dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX4DVPROC ProgramUniformMatrix4dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX2X3DVPROC ProgramUniformMatrix2x3dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX3X2DVPROC ProgramUniformMatrix3x2dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX2X4DVPROC ProgramUniformMatrix2x4dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX4X2DVPROC ProgramUniformMatrix4x2dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX3X4DVPROC ProgramUniformMatrix3x4dv = nullptr;
        PFNGLPROGRAMUNIFORMMATRIX4X3DVPROC ProgramUniformMatrix4x3dv = nullptr;
        PFNGLVERTEXATTRIBL1DPROC VertexAttribL1d = nullptr;
        PFNGLVERTEXATTRIBL2DPROC VertexAttribL2d = nullptr;
        PFNGLVERTEXATTRIBL3DPROC VertexAttribL3d = nullptr;
        PFNGLVERTEXATTRIBL4DPROC VertexAttribL4d = nullptr;
        PFNGLVERTEXATTRIBL1DVPROC VertexAttribL1dv = nullptr;
        PFNGLVERTEXATTRIBL2DVPROC VertexAttribL2dv = nullptr;
        PFNGLVERTEXATTRIBL3DVPROC VertexAttribL3dv = nullptr;
        PFNGLVERTEXATTRIBL4DVPROC VertexAttribL4dv = nullptr;
        PFNGLVERTEXATTRIBLPOINTERPROC VertexAttribLPointer = nullptr;
        PFNGLGETVERTEXATTRIBLDVPROC GetVertexAttribLdv = nullptr;
        PFNGLVIEWPORTARRAYVPROC ViewportArrayv = nullptr;
        PFNGLVIEWPORTINDEXEDFPROC ViewportIndexedf = nullptr;
        PFNGLVIEWPORTINDEXEDFVPROC ViewportIndexedfv = nullptr;
        PFNGLSCISSORARRAYVPROC ScissorArrayv = nullptr;
        PFNGLSCISSORINDEXEDPROC ScissorIndexed = nullptr;
        PFNGLSCISSORINDEXEDVPROC ScissorIndexedv = nullptr;
        PFNGLDEPTHRANGEARRAYVPROC DepthRangeArrayv = nullptr;
        PFNGLDEPTHRANGEINDEXEDPROC DepthRangeIndexed = nullptr;
        PFNGLGETFLOATI_VPROC GetFloati_v = nullptr;
        PFNGLGETDOUBLEI_VPROC GetDoublei_v = nullptr;

        // Desktop OpenGL 4.2
        PFNGLDRAWARRAYSINSTANCEDBASEINSTANCEPROC DrawArraysInstancedBaseInstance = nullptr;
        PFNGLDRAWELEMENTSINSTANCEDBASEINSTANCEPROC DrawElementsInstancedBaseInstance = nullptr;
        PFNGLDRAWELEMENTSINSTANCEDBASEVERTEXBASEINSTANCEPROC DrawElementsInstancedBaseVertexBaseInstance = nullptr;
        PFNGLGETACTIVEATOMICCOUNTERBUFFERIVPROC GetActiveAtomicCounterBufferiv = nullptr;
        PFNGLTEXSTORAGE1DPROC TexStorage1D = nullptr;
        PFNGLDRAWTRANSFORMFEEDBACKINSTANCEDPROC DrawTransformFeedbackInstanced = nullptr;
        PFNGLDRAWTRANSFORMFEEDBACKSTREAMINSTANCEDPROC DrawTransformFeedbackStreamInstanced = nullptr;

        // Desktop OpenGL 4.3
        PFNGLCLEARBUFFERDATAPROC ClearBufferData = nullptr;
        PFNGLCLEARBUFFERSUBDATAPROC ClearBufferSubData = nullptr;
        PFNGLGETINTERNALFORMATI64VPROC GetInternalformati64v = nullptr;
        PFNGLINVALIDATETEXSUBIMAGEPROC InvalidateTexSubImage = nullptr;
        PFNGLINVALIDATETEXIMAGEPROC InvalidateTexImage = nullptr;
        PFNGLINVALIDATEBUFFERSUBDATAPROC InvalidateBufferSubData = nullptr;
        PFNGLINVALIDATEBUFFERDATAPROC InvalidateBufferData = nullptr;
        PFNGLMULTIDRAWARRAYSINDIRECTPROC MultiDrawArraysIndirect = nullptr;
        PFNGLMULTIDRAWELEMENTSINDIRECTPROC MultiDrawElementsIndirect = nullptr;
        PFNGLGETPROGRAMRESOURCELOCATIONINDEXPROC GetProgramResourceLocationIndex = nullptr;
        PFNGLSHADERSTORAGEBLOCKBINDINGPROC ShaderStorageBlockBinding = nullptr;
        PFNGLTEXTUREVIEWPROC TextureView = nullptr;
        PFNGLVERTEXATTRIBLFORMATPROC VertexAttribLFormat = nullptr;

        // Desktop OpenGL 4.4
        PFNGLBUFFERSTORAGEPROC BufferStorage = nullptr;
        PFNGLCLEARTEXIMAGEPROC ClearTexImage = nullptr;
        PFNGLCLEARTEXSUBIMAGEPROC ClearTexSubImage = nullptr;
        PFNGLBINDBUFFERSBASEPROC BindBuffersBase = nullptr;
        PFNGLBINDBUFFERSRANGEPROC BindBuffersRange = nullptr;
        PFNGLBINDTEXTURESPROC BindTextures = nullptr;
        PFNGLBINDSAMPLERSPROC BindSamplers = nullptr;
        PFNGLBINDIMAGETEXTURESPROC BindImageTextures = nullptr;
        PFNGLBINDVERTEXBUFFERSPROC BindVertexBuffers = nullptr;

        // Desktop OpenGL 4.5
        PFNGLCLIPCONTROLPROC ClipControl = nullptr;
        PFNGLCREATETRANSFORMFEEDBACKSPROC CreateTransformFeedbacks = nullptr;
        PFNGLTRANSFORMFEEDBACKBUFFERBASEPROC TransformFeedbackBufferBase = nullptr;
        PFNGLTRANSFORMFEEDBACKBUFFERRANGEPROC TransformFeedbackBufferRange = nullptr;
        PFNGLGETTRANSFORMFEEDBACKIVPROC GetTransformFeedbackiv = nullptr;
        PFNGLGETTRANSFORMFEEDBACKI_VPROC GetTransformFeedbacki_v = nullptr;
        PFNGLGETTRANSFORMFEEDBACKI64_VPROC GetTransformFeedbacki64_v = nullptr;
        PFNGLCREATEBUFFERSPROC CreateBuffers = nullptr;
        PFNGLNAMEDBUFFERSTORAGEPROC NamedBufferStorage = nullptr;
        PFNGLNAMEDBUFFERDATAPROC NamedBufferData = nullptr;
        PFNGLNAMEDBUFFERSUBDATAPROC NamedBufferSubData = nullptr;
        PFNGLCOPYNAMEDBUFFERSUBDATAPROC CopyNamedBufferSubData = nullptr;
        PFNGLCLEARNAMEDBUFFERDATAPROC ClearNamedBufferData = nullptr;
        PFNGLCLEARNAMEDBUFFERSUBDATAPROC ClearNamedBufferSubData = nullptr;
        PFNGLMAPNAMEDBUFFERPROC MapNamedBuffer = nullptr;
        PFNGLMAPNAMEDBUFFERRANGEPROC MapNamedBufferRange = nullptr;
        PFNGLUNMAPNAMEDBUFFERPROC UnmapNamedBuffer = nullptr;
        PFNGLFLUSHMAPPEDNAMEDBUFFERRANGEPROC FlushMappedNamedBufferRange = nullptr;
        PFNGLGETNAMEDBUFFERPARAMETERIVPROC GetNamedBufferParameteriv = nullptr;
        PFNGLGETNAMEDBUFFERPARAMETERI64VPROC GetNamedBufferParameteri64v = nullptr;
        PFNGLGETNAMEDBUFFERPOINTERVPROC GetNamedBufferPointerv = nullptr;
        PFNGLGETNAMEDBUFFERSUBDATAPROC GetNamedBufferSubData = nullptr;
        PFNGLCREATEFRAMEBUFFERSPROC CreateFramebuffers = nullptr;
        PFNGLNAMEDFRAMEBUFFERRENDERBUFFERPROC NamedFramebufferRenderbuffer = nullptr;
        PFNGLNAMEDFRAMEBUFFERPARAMETERIPROC NamedFramebufferParameteri = nullptr;
        PFNGLNAMEDFRAMEBUFFERTEXTUREPROC NamedFramebufferTexture = nullptr;
        PFNGLNAMEDFRAMEBUFFERTEXTURELAYERPROC NamedFramebufferTextureLayer = nullptr;
        PFNGLNAMEDFRAMEBUFFERDRAWBUFFERPROC NamedFramebufferDrawBuffer = nullptr;
        PFNGLNAMEDFRAMEBUFFERDRAWBUFFERSPROC NamedFramebufferDrawBuffers = nullptr;
        PFNGLNAMEDFRAMEBUFFERREADBUFFERPROC NamedFramebufferReadBuffer = nullptr;
        PFNGLINVALIDATENAMEDFRAMEBUFFERDATAPROC InvalidateNamedFramebufferData = nullptr;
        PFNGLINVALIDATENAMEDFRAMEBUFFERSUBDATAPROC InvalidateNamedFramebufferSubData = nullptr;
        PFNGLCLEARNAMEDFRAMEBUFFERIVPROC ClearNamedFramebufferiv = nullptr;
        PFNGLCLEARNAMEDFRAMEBUFFERUIVPROC ClearNamedFramebufferuiv = nullptr;
        PFNGLCLEARNAMEDFRAMEBUFFERFVPROC ClearNamedFramebufferfv = nullptr;
        PFNGLCLEARNAMEDFRAMEBUFFERFIPROC ClearNamedFramebufferfi = nullptr;
        PFNGLBLITNAMEDFRAMEBUFFERPROC BlitNamedFramebuffer = nullptr;
        PFNGLCHECKNAMEDFRAMEBUFFERSTATUSPROC CheckNamedFramebufferStatus = nullptr;
        PFNGLGETNAMEDFRAMEBUFFERPARAMETERIVPROC GetNamedFramebufferParameteriv = nullptr;
        PFNGLGETNAMEDFRAMEBUFFERATTACHMENTPARAMETERIVPROC GetNamedFramebufferAttachmentParameteriv = nullptr;
        PFNGLCREATERENDERBUFFERSPROC CreateRenderbuffers = nullptr;
        PFNGLNAMEDRENDERBUFFERSTORAGEPROC NamedRenderbufferStorage = nullptr;
        PFNGLNAMEDRENDERBUFFERSTORAGEMULTISAMPLEPROC NamedRenderbufferStorageMultisample = nullptr;
        PFNGLGETNAMEDRENDERBUFFERPARAMETERIVPROC GetNamedRenderbufferParameteriv = nullptr;
        PFNGLCREATETEXTURESPROC CreateTextures = nullptr;
        PFNGLTEXTUREBUFFERPROC TextureBuffer = nullptr;
        PFNGLTEXTUREBUFFERRANGEPROC TextureBufferRange = nullptr;
        PFNGLTEXTURESTORAGE1DPROC TextureStorage1D = nullptr;
        PFNGLTEXTURESTORAGE2DPROC TextureStorage2D = nullptr;
        PFNGLTEXTURESTORAGE3DPROC TextureStorage3D = nullptr;
        PFNGLTEXTURESTORAGE2DMULTISAMPLEPROC TextureStorage2DMultisample = nullptr;
        PFNGLTEXTURESTORAGE3DMULTISAMPLEPROC TextureStorage3DMultisample = nullptr;
        PFNGLTEXTURESUBIMAGE1DPROC TextureSubImage1D = nullptr;
        PFNGLTEXTURESUBIMAGE2DPROC TextureSubImage2D = nullptr;
        PFNGLTEXTURESUBIMAGE3DPROC TextureSubImage3D = nullptr;
        PFNGLCOMPRESSEDTEXTURESUBIMAGE1DPROC CompressedTextureSubImage1D = nullptr;
        PFNGLCOMPRESSEDTEXTURESUBIMAGE2DPROC CompressedTextureSubImage2D = nullptr;
        PFNGLCOMPRESSEDTEXTURESUBIMAGE3DPROC CompressedTextureSubImage3D = nullptr;
        PFNGLCOPYTEXTURESUBIMAGE1DPROC CopyTextureSubImage1D = nullptr;
        PFNGLCOPYTEXTURESUBIMAGE2DPROC CopyTextureSubImage2D = nullptr;
        PFNGLCOPYTEXTURESUBIMAGE3DPROC CopyTextureSubImage3D = nullptr;
        PFNGLTEXTUREPARAMETERFPROC TextureParameterf = nullptr;
        PFNGLTEXTUREPARAMETERFVPROC TextureParameterfv = nullptr;
        PFNGLTEXTUREPARAMETERIPROC TextureParameteri = nullptr;
        PFNGLTEXTUREPARAMETERIIVPROC TextureParameterIiv = nullptr;
        PFNGLTEXTUREPARAMETERIUIVPROC TextureParameterIuiv = nullptr;
        PFNGLTEXTUREPARAMETERIVPROC TextureParameteriv = nullptr;
        PFNGLGENERATETEXTUREMIPMAPPROC GenerateTextureMipmap = nullptr;
        PFNGLBINDTEXTUREUNITPROC BindTextureUnit = nullptr;
        PFNGLGETTEXTUREIMAGEPROC GetTextureImage = nullptr;
        PFNGLGETCOMPRESSEDTEXTUREIMAGEPROC GetCompressedTextureImage = nullptr;
        PFNGLGETTEXTURELEVELPARAMETERFVPROC GetTextureLevelParameterfv = nullptr;
        PFNGLGETTEXTURELEVELPARAMETERIVPROC GetTextureLevelParameteriv = nullptr;
        PFNGLGETTEXTUREPARAMETERFVPROC GetTextureParameterfv = nullptr;
        PFNGLGETTEXTUREPARAMETERIIVPROC GetTextureParameterIiv = nullptr;
        PFNGLGETTEXTUREPARAMETERIUIVPROC GetTextureParameterIuiv = nullptr;
        PFNGLGETTEXTUREPARAMETERIVPROC GetTextureParameteriv = nullptr;
        PFNGLCREATEVERTEXARRAYSPROC CreateVertexArrays = nullptr;
        PFNGLDISABLEVERTEXARRAYATTRIBPROC DisableVertexArrayAttrib = nullptr;
        PFNGLENABLEVERTEXARRAYATTRIBPROC EnableVertexArrayAttrib = nullptr;
        PFNGLVERTEXARRAYELEMENTBUFFERPROC VertexArrayElementBuffer = nullptr;
        PFNGLVERTEXARRAYVERTEXBUFFERPROC VertexArrayVertexBuffer = nullptr;
        PFNGLVERTEXARRAYVERTEXBUFFERSPROC VertexArrayVertexBuffers = nullptr;
        PFNGLVERTEXARRAYATTRIBBINDINGPROC VertexArrayAttribBinding = nullptr;
        PFNGLVERTEXARRAYATTRIBFORMATPROC VertexArrayAttribFormat = nullptr;
        PFNGLVERTEXARRAYATTRIBIFORMATPROC VertexArrayAttribIFormat = nullptr;
        PFNGLVERTEXARRAYATTRIBLFORMATPROC VertexArrayAttribLFormat = nullptr;
        PFNGLVERTEXARRAYBINDINGDIVISORPROC VertexArrayBindingDivisor = nullptr;
        PFNGLGETVERTEXARRAYIVPROC GetVertexArrayiv = nullptr;
        PFNGLGETVERTEXARRAYINDEXEDIVPROC GetVertexArrayIndexediv = nullptr;
        PFNGLGETVERTEXARRAYINDEXED64IVPROC GetVertexArrayIndexed64iv = nullptr;
        PFNGLCREATESAMPLERSPROC CreateSamplers = nullptr;
        PFNGLCREATEPROGRAMPIPELINESPROC CreateProgramPipelines = nullptr;
        PFNGLCREATEQUERIESPROC CreateQueries = nullptr;
        PFNGLGETQUERYBUFFEROBJECTI64VPROC GetQueryBufferObjecti64v = nullptr;
        PFNGLGETQUERYBUFFEROBJECTIVPROC GetQueryBufferObjectiv = nullptr;
        PFNGLGETQUERYBUFFEROBJECTUI64VPROC GetQueryBufferObjectui64v = nullptr;
        PFNGLGETQUERYBUFFEROBJECTUIVPROC GetQueryBufferObjectuiv = nullptr;
        PFNGLGETTEXTURESUBIMAGEPROC GetTextureSubImage = nullptr;
        PFNGLGETCOMPRESSEDTEXTURESUBIMAGEPROC GetCompressedTextureSubImage = nullptr;
        PFNGLGETNCOMPRESSEDTEXIMAGEPROC GetnCompressedTexImage = nullptr;
        PFNGLGETNTEXIMAGEPROC GetnTexImage = nullptr;
        PFNGLGETNUNIFORMDVPROC GetnUniformdv = nullptr;
        PFNGLGETNMAPDVPROC GetnMapdv = nullptr;
        PFNGLGETNMAPFVPROC GetnMapfv = nullptr;
        PFNGLGETNMAPIVPROC GetnMapiv = nullptr;
        PFNGLGETNPIXELMAPFVPROC GetnPixelMapfv = nullptr;
        PFNGLGETNPIXELMAPUIVPROC GetnPixelMapuiv = nullptr;
        PFNGLGETNPIXELMAPUSVPROC GetnPixelMapusv = nullptr;
        PFNGLGETNPOLYGONSTIPPLEPROC GetnPolygonStipple = nullptr;
        PFNGLGETNCOLORTABLEPROC GetnColorTable = nullptr;
        PFNGLGETNCONVOLUTIONFILTERPROC GetnConvolutionFilter = nullptr;
        PFNGLGETNSEPARABLEFILTERPROC GetnSeparableFilter = nullptr;
        PFNGLGETNHISTOGRAMPROC GetnHistogram = nullptr;
        PFNGLGETNMINMAXPROC GetnMinmax = nullptr;
        PFNGLTEXTUREBARRIERPROC TextureBarrier = nullptr;

        // Desktop OpenGL 4.6
        PFNGLSPECIALIZESHADERPROC SpecializeShader = nullptr;
        PFNGLMULTIDRAWARRAYSINDIRECTCOUNTPROC MultiDrawArraysIndirectCount = nullptr;
        PFNGLMULTIDRAWELEMENTSINDIRECTCOUNTPROC MultiDrawElementsIndirectCount = nullptr;
        PFNGLPOLYGONOFFSETCLAMPPROC PolygonOffsetClamp = nullptr;

        // GL_EXT_texture_compression_s3tc

        // GL_EXT_texture_compression_s3tc_srgb

        // GL_OES_EGL_image
        PFNGLEGLIMAGETARGETTEXTURE2DOESPROC EGLImageTargetTexture2DOES = nullptr;
        PFNGLEGLIMAGETARGETRENDERBUFFERSTORAGEOESPROC EGLImageTargetRenderbufferStorageOES = nullptr;


      protected:
        MaybeError LoadDesktopGLProcs(GetProcAddress getProc, int majorVersion, int minorVersion);
        MaybeError LoadOpenGLESProcs(GetProcAddress getProc, int majorVersion, int minorVersion);

      private:
        template<typename T>
        MaybeError LoadProc(GetProcAddress getProc, T* memberProc, const char* name);
    };

}  // namespace dawn::native::opengl

#endif // DAWNNATIVE_OPENGL_OPENGLFUNCTIONSBASE_H_
