// Copyright 2021 The Tint Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

////////////////////////////////////////////////////////////////////////////////
// File generated by tools/builtin-gen
// using the template:
//   src/tint/sem/parameter_usage.h.tmpl
// and the builtin defintion file:
//   src/tint/builtins.def
//
// Do not modify this file directly
////////////////////////////////////////////////////////////////////////////////

#ifndef SRC_TINT_SEM_PARAMETER_USAGE_H_
#define SRC_TINT_SEM_PARAMETER_USAGE_H_

namespace tint::sem {

/// ParameterUsage is extra metadata for identifying a parameter based on its
/// overload position
enum class ParameterUsage {
  kNone = -1,
  kArrayIndex,
  kBias,
  kComponent,
  kCoords,
  kDdx,
  kDdy,
  kDepthRef,
  kLevel,
  kOffset,
  kSampleIndex,
  kSampler,
  kTexture,
  kValue,
};

/// @returns a string representation of the given parameter usage.
const char* str(ParameterUsage usage);

}  // namespace tint::sem

#endif  // SRC_TINT_SEM_PARAMETER_USAGE_H_
